      PROGRAM LEASTWIND
C
C **LEGACY REMOVE** IT LOOKS LIKE UGUESS, VGUESS, AND WGUESS ARE NEVER READ
C IN ANYWHERE, EVEN BEHIND A CONDITIONAL READ.  THEY SHOULD PROBABLY BE 
C REMOVED AS WELL AS ALL REFERENCES TO THEM, AT LEAST IN THE TRANSITION
C VERSION.  REMOVAL WILL ALSO NEED TO BE FROM PARAMETER LIST IN CALL TO
C ABCD **END LEGACY REMOVE**
C
C
C     MAIN PROGRAM OF WIND_INTERPOLATE_RT_AUTO_FIRST_DEFRECKLE
C     MAIN PROGRAM OF wind_interpolate_rt_auto_first_defreckle,
C      one of the routines in the ja scritps
C  NOTE:  **LEGACY REMOVE** REFERS TO VARIABLES OR SECTIONS OF CODE
C         THAT WILL REMAIN FOR NOW IN "RESEARCH VERSION" BUT WHICH WILL
C         BE REMOVED FOR REAL-TIME VERSION
C       
C ... FUNCTION:   
C       
C          THIS PROGRAM COMPUTES SUMMATIONS OF PRODUCTS NEEDED FOR THE
C          FIRST LEAST SQUARES WIND SOLUTION. THE GOVERNING EQUATIONS 
C          ARE FORMULATED IN R-THETA-Z COORDINATES RELATIVE TO THE STORM
C          CENTER, AND REPRESENT THE AZIMUTHAL STRUCTURE IN TERMS OF 
C          FOURIER WAVENUMBER 0 AND 1 COMPONENTS.  AIRCRAFT MOTION 
C          REMOVAL, BARGEN-BROWN DEALIASING, DEFRECKLING, SURFACE
C          REMOVAL , AND REMOVAL OF DATA WITH LOW SIGNAL QUALITY (SQI)
C          ARE PERFORMED AS PART OF THE QC PROCESS. 
C       
C ... LEASTWIND SUBPROGRAM REFERENCES:      
C       
C          NON-SYSTEM     OPENRAMFILE, ABCD, WRITEABCD
C
C          SYSTEM         GETARG, INQUIRE (TO DETERMINE PRESENCE OF
C                                          OF SPECIFIC BACKDOOR FILES)
C 
C ... IMPORTANT FLAGS: <()> INDICATES DEFAULT
C          
C          IGRAPHICS      USE GRAPHICS (0) NO (1) YES
C          COMYES         USE COMMAND FILE (N) NO <(Y)> YES
C          IACROSS        AZI-COVERAGE (0) SECTOR <(1)> FULL
C          IGUESS         USE A GUESS WIND FIELD <(0)> NO (1) YES
C          IREVERSE       REVERSE SIGN OF DOPPLER VR <(0)> NO (1) YES
C          IREADABCD      READ IN SUMFILE <(0)> NO (1) YES
C          IWRITEABCD     WRITE OUT SUMFILE (0) NO <(1)> YES
C          IVSPEED        USE CONST. AZI ADV. <(0)> NO (1) YES
C          IRAMSFILES     USE RAMSFILE <(0)> NO (1) YES
C      
C     VERSION:  <TBD>
C       
C     CODE WRITTEN BY:  JOHN GAMACHE   
C                       HRD/AOML/NOAA          
C                       MIAMI, FL 33149      
C       
C     FOR ADDITIONAL DETAILS ON THE ALGORITHM SEE TBD
C       
C     BASED ON THEORY BY:  <TBD>
C       
C     REFERENCE THE BOOK:  <TBD>
C       
C     **************************************************  
C     *               IMPORTANT NOTE                   *  
C     *                                                *  
C     *                    <TBD>                       *  
C     *                                                *  
C     **************************************************  
C       
C     SPECIFICATIONS FOR LOCAL VARIABLES
C       
C **** HEADER RECORD OF AN HRD-TYPE DOPPLER WIND FILE 
C 
C IATTEN FLAGS WHETHER TO CORRECT FOR INTERVENING ATTENUATION
C APPLYMASKYESNO FLAGS WHETHER TO APPLY REFLECTIVITY MASK
C
      CHARACTER IATTEN,APPLYMASKYESNO,APPLYUNDERONLY
C
C BLANKEXISTS--WHETHER THE FILE "blankradius" EXISTS
C ATTENEXISTS--WHETHER THE FILE "attenanswer" EXISTS
C RADMASKEXISTS--WHETHER THE FILE "radmaskfile" EXISTS
C APPLYMASKEXISTS--WHETHER THE FILE "applymaskfile" EXISTS
C
      LOGICAL BLANKEXISTS,ATTENEXISTS,RADMASKEXISTS,APPLYMASKEXISTS
      LOGICAL CHANGEMELTBANDEXISTS,CHANGENSKIPEXISTS
C 
C P3RADMIN VALUE IN KM OF THE RADIUS FROM THE AIRCRAFT WITHIN WHICH
C          ALL DATA ARE FLAGGED
C GROUNDADJUST A SINGLE CONSTANT VALUE IN METERS, OF THE EARTH'S SURFACE
C   FOR THE PURPOSE OF SURFACE REMOVAL OVER A FLAT LAND SURFACE
C   OBVIOUSLY GENERALLY AN APPROXIMATION
C
      REAL P3RADMIN,GROUNDADJUST
C
C I_EXIST--WHETHER FILE MASKADDFILE EXISTS (which includes maskadd_42,
C          maskadd_43, and maskadd_49
C
      LOGICAL I_EXIST
C
C IB, JB, AND KB ARE THE INTEGER HOURS, MINUTES, AND SECONDS FOR 
C     BEGINNING TIME OF INTERPOLATION PERIOD
C IE, JE, AND KE ARE THE INTEGER HOURS, MINUTES, AND SECONDS FOR
C     FOR END TINE OF INTERPOLATION PERIOD
C IH, IM, AND IS ARE THE INTEGER HOURS, MINUTES, AND SECONDS FOR
C     TIME WHEN ORIGIN OF MOVING COORDINATE SYSTEM IS OLAT AND OLON
C     THIS IS GENERALLY THE TIME THE AIRCRAFT IS AT CLOSE POINT OF 
C     APPROACHED TO CENTER OF DISTURBANCE OF TROPICAL CYCLONE
C     (ALSO KNOW AS CENTER TIME OR CENTIME)
C     ONE OUT OF EVERY NSKIP SWEEPS IS INTERPOLATED, SO NSKIP=1 MEANS
C         EVERY SWEEP IS INTERPOALTE AND NSKIP=2 MEANS EVERY OTHER SWEEP
C         IS INTERPOLATED, ETC.  SINCE 2017 THE DEFAULT IN REAL TIME IS
C         NSKIP=3 (Note nskip in binary directory is define to only be
C                  the amount of files skipped between interpolated ones)
C ILEN IS LENGTH IN CHARACTERS OF INPUT ARGUMENTS TO ja (INVOKING 
C        AUTOMATED ANALYSIS) CALL (IF ZERO A DEFAULT VALUES IS USED)
C IAPPLYMASK WHETHER REFLECTIVITY MUST BE GREATER THAN A MASK VALUE FOR THE
C   REFLECTIVITY AND DOPPLER RADIAL WIND TO BE INTERPOLATED YES=1 NO=0
C   DEFAULT IS NO FOR RVP5 AND YES FOR RVP8 OR LATER--MAY NOT BE NEED FOR 
C   2017 AND 2018
C
      INTEGER IB,JB,KB,IE,JE,KE,IH,IM,IS,NSKIP,ILEN,IAPPLYMASK
C
C IMAX = NUMBER OF RADIAL BINS IN ANALYIS RESULTING FROM THIS INTERPOLATION
C JMAX = NUMBER OF AZIMUTHAL BINS IN ANALYSIS RESULTING FROM THIS INTERPOLATION
C KMAX = NUMBER OF VERTICAL BINS IN ANALYSIS RESULTING FROM THIS INTERPOLATION
C IDBZADD INTEGER VALUE OF DBZ TO ADD TO INPUT REFLECTIVITY (BIAS)
C
      INTEGER IMAX,JMAX,KMAX,IDBZADD,IUNDERONLY
C
C STIME TIME IN SECONDS SINCE MIDNIGHT FOR START OF INTERPOLATION
C ETIME TIME IN SECONDS SINCE MIDNIGHT FOR END OF INTERPOLATION (CAN BE GREATER
C        THAN 86400
C OLAT LATITUDE OF ANALYSIS ORIGIN AT CENTER TIME
C OLON LONGITUDE OF ANALYSIS ORIGIN AT CENTER TIME (W = NEGATIVE LONGITUDE)
C SX, SY, SZ RADIAL (KM), AZIMUTHAL (DEG), AND VERTICAL (KM) RESOLUTION OF
C     OF ANALYSIS RESULTING FROM THIS INTERPOLATION
C
      REAL STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT
C
C SMOTIONU/SMOTIONV EASTWARD/NORTHWARD MOTION OF COORDINATE SYSTEM THAT
C DATA ARE INTERPOLATED TO IN M/S--USUALLY AN ESTIMATE OF STORM MOTION
C
      REAL SMOTIONU,SMOTIONV
C
C FLTNAME--8 CHARACTER FLIGHT ID YYMMDDAI WHERE YY, MM,DD,A,I ARE YEAR,
C MONTH,D DAY, AIRCRAFT(H-N42RF,I-N43RF,N-N49RF), AND THE NUMBER OF THE FLIGHT
C FOR A GIVEN DAY FOR A GIVEN AIRCRAFT (1 OR 2)
C EXPERIMENT--SHORT DESCRIPTION OF MISSION THAT USUALLY INCLUDES STORM NAME
C MASKADDFILE--NAME OF FILE CONTAINING INFORMATION ABOUT HOW TO USE THE
C    NOISE/ARTIFACT MASK DEVELOPED FROM CLEAR-AIR FLIGHT
C
      CHARACTER FLTNAME*8,EXPERIMENT*32,MASKADDFILE*10
C
C FILNAM IS A LEGACY VARIABLE THAT WAS CHANGED TO THE NAME OF THE JOB FILE
C USED TO PROVIDE INPUT FOR THE INTERPOLATION
C AIRCHAR IS "H"/"I"/"N" FOR N42RF/N43RF/N49RF
C
      CHARACTER FILNAM(40)*80,AIRCHAR*1
C 
C **** REMAINING 
C 
C  N AND IJK ARE USED AS INDICES FOR LOOPS
C  IROLLTOL IS INTEGER VALUE OF MAXIMUM AIRCRAFT ROLL (DEG) ALLOWED FOR DATA
C           TO BE INCLUDED IN INTERPOLATION
C      INTEGER N,IJK,IROLLTOL
C KMIN2, KMAX2 MINIMUM AND MAXIMUM INTEGER VERTICAL LEVES IN ANALYSIS
C
      INTEGER KMIN2,KMAX2
C
C LUIN IS THE UNIT NUMBER FOR JOB FILE
C LUOUT IS THE UNIT NUMBER FOR OUTPUT MESSAGES
C LUW IS LOGICAL UNIT NUMBER FOR THE SUMFILE--THE FILE CONTAINING NEEDED
C     SUMS OF VARIABLES NEEDED TO PRODUCE A SYNTHESIZED WIND FIELD
C NFILE IS A LEGACY VARIABLE GOING BACK TO WHEN MORE THAN ONE TDR INPUT 
C **LEGACY REMOVE** NF AND NFILE (NF INVOLVES ABCD)
C NFILE WAS USED IN THE EXECUTION OF THIS ROUTINE 
C NF IS ALSO A LEGACY VARIABLE AND CAN PROBABLY BE REMOVED
C NFF IS USED TO DETERMINE WHETHER FILE TO BE WRITTEN IS AFT (1) OR FORE (2)
C 
      INTEGER LUIN,LUOUT,LUW,NFILE,NF,NFF
C
C
C IGRAPHICS EQUALS 0/1 IF SWEEP GRAPHICS ARE NOT SHOWN/SHOWN 
C           DURING INTERPOLATION
C IACROSS EQUALS 0/1 IF RADIUS OF INFLUENCE IS TO CROSS 0/360 DEG BORDER
C IACROSS SHOULD BE 1 FOR MOST MODERN 360 DEGREE ANALYSES
C IACROSS EQUALS 0 IS LEGACY 
C IGUESS IS WHETHER (1) OR NOT (0) THERE IS A GUESS FIELD USED FOR QC OR 
C BACKGROUND.  IN THIS WAVENUMBER 0 + MEAN CASE IGUESS SHOULD BE 0
C IREVERSE WHETHER POSITIVE DOPPLER VELOCITY IS DEFINED OUTWARD (0) 
C OR INWARD (1)--SOME LEGACY DATA HAD THE VELOCITY DEFINED IN REVERSE
C IREADABCD (Y(1)/N(0)) IS A VARIABLE DETERMINING WHETHER SUMFILES HAVE BEEN 
C READ--THIS WILL GENERALLY BE ZERO AND IS SET THAT WAY **LEGACY REMOVE**
C 
      INTEGER IGRAPHICS,IACROSS,IGUESS,IREVERSE,IREADABCD
C
C IWRITEABCD (Y(1)/N(0)) WHETHER SUMFILE(S) ARE TO BE WRITTEN, DEFAULT = 1
C IVSPEED (Y(1)/N(0)) WHETHER TANGENTIAL ADVECTION SPEED SHOULD BE USED
C IVSPEED IS PRESENTLY LEGACY AND IS SET TO 0 **LEGACY REMOVE**
C RAMSFILES WERE FILES PRODUCED IN THE PAST FROM FLIGHT LEVEL DATA TO 
C IMPROVE LOCATION/MOVEMENT INFORMATION FOR RADAR.  THEY ARE LEGACY
C **LEGACY REMOVE** IRAMSFILES = 1 IF RAMSFILES ARE OPENED AND READ
C IERR IS ONLY USED WHEN OPENING A RAMSFILE **LEGACY REMOVE**
      INTEGER IWRITEABCD,IVSPEED,IRAMSFILES,IERR
C
C TOTAL MAXIMUM NUMBER OF GRID POINTS IN 3D CYCLINDRICAL FILES IS N1
C THE OTHER NUMBERS ARE MULTIPLES OF THAT 
C N1 SHOULD BE <= IMAX*JMAX*KMAX
C
      PARAMETER(N1=6000000,N2=12000000,N3=18000000,N8=48000000)
C
C TSTART IS THE SAME AS STIME (TIME IN SECS OF BEGINNING OF INTERPOLATION)
C TEND IS THE END TIME.  iF ETIME HAS ERRONEOUSLY BEEN ENTERED AS LESS THAN
C STIME THEN TEND IS ETIME+86400
C SLOPE1 IS A REFLECTIVITY CALIBRATION NUMBER.  A VALUE OF 1 (DEFAULT) MEANS
C THAT OUTPUT REFLECTIVITY VARIES AT THE SAME RATE AS INPUT REFLECTIVITY
C CENTIME IS THE TIME IN SECONDS PAST MIDNIGHT WHEN THE ORIGIN IS LOCATED
C AT OLAT/OLON
C
      REAL TSTART,TEND,SLOPE1,CENTIME
C
C TSTARTARRAY AND TENDARRAY ARE JUST ARRAY VALUES FOR TSTART AND TEND AS
C DEFINED ABOVE
C
      REAL TSTARTARRAY(40),TENDARRAY(40)
C 
C XSHIFT,YSHIFT AMOUNT (KM) TO SHIFT DATA INTERPOLATION FROM WHAT IS DEFINED
C BY OLAT,OLON,SMOTIONU,SMOTIONV
C XSHIRT,YSHIFT ARE REALLY LEGACY **LEGACY REMOVE**
C DBZFACT IS USED TO SET SLOPE1 SO DEFAULT IS ALSO 1.0
C
      REAL XSHIFT(80),YSHIFT(80),DBZFACT(80)
C
C RRMAX RADIAL RADIUS OF INFLUENCE FOR INTERPOLATION IN KM
C RTMAX AZIMUTHAL RADIUS OF INFLUENCE FOR INTERPOLATION IN DEG
C RZMAX VERTICAL RADIUS OF INFLUENCE FOR INTERPOLATION IN KM
C ERMAX RADIAL EFOLDING DISTANCE OF GAUSSIAN INTERPOLATER IN KM
C ETMAX AZIMUTHAL EFOLDING DISTANCE OF GAUSSIAN INTERPOLATER IN DEG
C EZMAX VERTICAL EFOLDING DISTANCE OF GAUSSIAN INTERPOLATER IN KM
C
      REAL RRMAX,RTMAX,RZMAX,ERMAX,ETMAX,EZMAX
C
C XACC, YACC, ZACC NO LONGER USED IN INTERPOLATION PROGRAMS
C XACC, YACC, ZACC **LEGACY REMOVE**
C PIMAX NOT USED IN WAVENUMBER 0 PLUS MEAN INTERPOLATION
C PIMAX **LEGACY REMOVE**
C
      REAL XACC,YACC,ZACC,PIMAX
C
C SINTOL MAXIMUM VALUE OF ABSOLUTE VALUE OF SINE OF ELEVATION ANGLE FOR
C DOPPLER RADIALS TO BE USED IN INTERPOLATION
C CTR CONVERSION FACTOR TO GO FROM DEGREES TO RADIANS
C RFLAG VALUE TO USE FOR FLAGGING A DATA POINT
C DATARATE IS USED ONLY FOR CALL TO ACCESS RAMSFILES **LEGACY REMOVE**
C
      REAL SINTOL,CTR,RFLAG,DATARATE
C
C DBZTEST MINIMUM REFLECTIVITY TO BE INCLUDED AT A RADIUS OF RRRR KM
C RRRR USED TO MODIFY DBZTEST AS A FUNCTION OF RANGE
C **LEGACY REMOVE**
C VSPEED0 CONSTANT AZIMUTHAL SPEED TO ADVECT TARGETS IN M/S
C VFACTOR ALLOWS ONE TO KEEP VSPEED0 AT A GIVEN VELOCITY AND MULTIPLY
C VSPEED0 TO MODIFY ADVECTION **LEGACY REMOVE**
C
      REAL DBZTEST,RRRR,VSPEED0,VFACTOR
C
C SET UP ALLOCATION OF LARGE ARRAYS SEE "abcd_scan_rt4_giv_uvw0.f" for
C DEFINITIONS OF SUM1 TO SUM24
C
      REAL,ALLOCATABLE::SUM1(:),SUM2(:),SUM3(:)
      REAL,ALLOCATABLE::SUM4(:),SUM5(:),SUM6(:)
      REAL,ALLOCATABLE::SUM7(:),SUM8(:),SUM9(:)
      REAL,ALLOCATABLE::SUM10(:),SUM11(:),SUM12(:),SUM13(:)
      REAL,ALLOCATABLE::SUM14(:),SUM15(:),SUM16(:)
      REAL,ALLOCATABLE::SUM17(:),SUM18(:),SUM19(:)
      REAL,ALLOCATABLE::SUM20(:),SUM21(:),SUM22(:)
      REAL,ALLOCATABLE::SUM23(:),SUM24(:)
      REAL,ALLOCATABLE::DISTXYZ(:)
      REAL,ALLOCATABLE::SUMWTSAVE(:),SUMDBZ(:)
      REAL,ALLOCATABLE::VELS(:)
      REAL,ALLOCATABLE::UGUESS(:),VGUESS(:),WGUESS(:)
C
C TATF IDENTIFIES WHETHER A GIVEN INPUT FILE IS FORE OR AFT OR TRACK NORMAL
C ONLY USE AT THE MOMENT IS IF THE VALUE IN THIS PROGRAM WAS SET TO INDICATE
C TRACK NORMAL SCANNING TATF(I) = "TN"
C NO LONGER USED **LEGACY REMOVE**
C
      CHARACTER TATF(80)*2
C
C COMYES INDICATES WHETHER TO USE A COMMAND "ja*" FILE DEFAULT = Y
C        NOT REALLY NEEDED FOR AUTOMATED ANALYSES **LEGACY REMOVE**
C GRAPHICSYES, GRAPHICSYES2, AND GRAPHICSYES3 ARE USED TO SAVE VALUES
C IN ARGUMENT LIST WHEN CALLING THIS ROUTINE
C
      CHARACTER COMYES*1,GRAPHICSYES*1,GRAPHICSYES2*2,GRAPHICSYES3*3
C
C OSUMFILENAME IS THE NAME OF THE FILE CONTAINING THE SUMS (SUMFILE)
C THERE CAN BE UP TO TWO OF THESE WHEN AUTOMATED (FORE AND AFT) AND WHEN
C DATA ARE RVP5 IN ONE FILE
C FOR RVP8 OR LATER IT IS LEGACY **LEGACY REMOVE**
C RAMSFILES ARE ONLY USED IN LEGACY CASES WHERE RAMSFILES EXIST AND 
C     IMPROVE THE FLIGHT LEVEL DATA COMPARED TO THOSE STORED IN THE RADAR FILES
C
      CHARACTER OSUMFILENAME(80)*80,RAMSFILES(80)*80
C     N1 IS MAXIMUM VALUES OF 2*IMAX*JMAX*KMAX FOR SUM1-SUM24--SEE THEIR 
C     DEFINITIONS BELOW
C     N2, N3, AND N8 ARE SIMPLY N1 * 2, 3 OR 8
C     N1, N2, N3, AND N8 ARE USED TO ALLOCATE THE LARGE ARRAYS WHICH HAVE MULTIPLE DIMENSIONS IN SUBROUTINES
C
C ... DESCRIPTION OF VARIABLES PASSED TO SUBROUTINES
C       
C     RAMSFILES            - RAMSFILE NAME
C     LUOUT                - LOGICAL UNIT NUMBER TO DISPLAY MESSAGES
C     STIME,ETIME          - START,END TIME (S)
C     DATARATE             - FILE DATA RATE
C     IERR                 - ERROR CONDITION FLAG
C     RRMAX,RTMAX,RZMAX    - RADIAL,AZI,VERTICAL SCALE OF INFLUENCE (KM,DEG,KM)
C     ERMAX,ETMAX,EZMAX    - RADIAL,AZI,VERTICAL E-FOLDING DISTANCE (KM,DEG,KM)
C     XACC,YACC,ZACC       - MAX ALLOWED RADIAL,AZI,VERTICAL DIST. BETWEEN AVG. OBS POS. AND GRID POINT
C     NF                   - FILE NO.
C     SUM1-13              - SUMS OF PRODUCTS ACCUMULATED DURING INTERP. PROCESS
C                            See ABCD subroutines for definition of sum1-sum13
C     KMIN2,KMAX2          - TYPICALLY MIN AND MAX VERTICAL LEVEL NO.
C     SINTOL               - SIN OF MAX ALLOWED DOPPLER RADIAL ANGLE FROM HORIZ.
C                            This is now generally 90 degrees, thus including 
C                            all radials
C     SX,SY,SZ             - RADIAL,AZI,VERTICAL GRID SPACING (KM,DEG,KM) 
C                            of gridded files
C     XZ,YZ,ZZ             - MIN RADIUS,AZI,HEIGHT (KM,DEG,KM)
C                            of gridded files
C     ROT                  - COORD. ROTATION (ALWAYS ZERO IN CYL COORDS)
C     IMAX,JMAX,KMAX       - RADIAL,AZI,VERTICAL ARRAY DIMENSION
C     SUMDBZ               - WEIGHTED AVG. REFLECTIVITY AT GRIDPOINT (I,J,K) 
C                            FOR FORE OR AFT SCAN
C                          - during interpolation SUMDBZ is an accumulator
C     SUMWTSAVE            - ACCUMULATED WEIGHT AT GRIDPOINT (I,J,K) FOR FORE OR AFT SCAN
C     VELS                 - WEIGHTED AVG. R,THETA,Z DIST. BETWEEN DATUM AND GRIDPOINT
C     OLAT,OLON            - LAT,LON OF GRID ORIGIN (STORM CENTER)
C     SLOPE1               - REFLECTIVITY SLOPE CORRECTION FACTOR SET TO ONE
C     CENTIME              - ANALYSIS TIME (S)
C     TSTART,TEND          - SEE STIME,ETIME
C     SMOTIONU,SMOTIONV    - STORM MOTION (M/S)
C     FLTNAME              - FLIGHT NAME
C     DBZTEST              - MIN DBZ TO INCLUDE
C     UGUESS,VGUESS,WGUESS - GUESS RADIAL, TANGENTIAL, AND VERTICAL WIND (ZERO, M/S)
C     DISTXYZ              - DISTANCE OF THE CLOSEST OBS THAT WAS INTERP. TO GRID POINT (I,J,K)
C     PIMAX                - MAX AZI ANGLE FOR OBS TO BE INCLUDED IN WT AVG
C     VSPEED0              - CONST. ADV. SPEED USED IN COMPOSITING (M/S)
C     VFACTOR              - FACTOR MULT. WIND SPEED TO USE IN COMPOSITING (M/S)
C     TATF                 - IDENTIFY SCAN TYPE 
C     LUW                  - LOGICAL UNIT NUMBER FOR OUTPUT SUMFILE
C     NFF                  - FORE OR AFT' FILE NO.
C    
      LUOUT=6
      CTR=3.14159/180.
      RFLAG=-1.0E+10
C 
      OPEN(1,FILE='/dev/null')
C 
C ... INITIALIZE DBZ VECTOR TO FLAGGED VALUE
C 
C DYNAMIC ALLOCATION IS A GOOD IDEA, SO WE CAN BE SURE THERE SHOULD ALWAYS BE
C ENOUGH MEMORY.  
C
      ALLOCATE(SUM1(N1))
      ALLOCATE(SUM2(N1))
      ALLOCATE(SUM3(N1))
      ALLOCATE(SUM4(N1))
      ALLOCATE(SUM5(N1))
      ALLOCATE(SUM6(N1))
      ALLOCATE(SUM7(N1))
      ALLOCATE(SUM8(N1))
      ALLOCATE(SUM9(N1))
      ALLOCATE(SUM10(N1))
      ALLOCATE(SUM11(N1))
      ALLOCATE(SUM12(N1))
      ALLOCATE(SUM13(N1))
      ALLOCATE(SUM14(N1))
      ALLOCATE(SUM15(N1))
      ALLOCATE(SUM16(N1))
      ALLOCATE(SUM17(N1))
      ALLOCATE(SUM18(N1))
      ALLOCATE(SUM19(N1))
      ALLOCATE(SUM20(N1))
      ALLOCATE(SUM21(N1))
      ALLOCATE(SUM22(N1))
      ALLOCATE(SUM23(N1))
      ALLOCATE(SUM24(N1))
C
C DISTXYZ IS USED TO DETERMINE IF A PARTICULAR GRID POINT IS SURROUNDED BY
C         DATA.  DESIGNED FOR BILINEAR INTERPOLATION.  LEGACY.
C         **LEGACY REMOVE**
C
      ALLOCATE(DISTXYZ(N8))
C 
C SUMWTSAVE SAVES THE SUMS OF ALL THE WEIGHTS THAT ARE USED TO COMPUTE
C           SUM1-SUM24
C
      ALLOCATE(SUMWTSAVE(N1))
C
C SUMDBZ IS THE WEIGHTED SUM OF ALL THE REFLECTIVITIES GOING INTO A GRID-POINT
C        INTERPOLATION.  OUTPUT WILL BE NORMALIZED TO A SUM OF WEIGHTS = 1.0
C
      ALLOCATE(SUMDBZ(N1))
C
C UGUESS, VGUESS, AND WGUESS ARE THE VALUES OF THE U,V,V IN THE INPUT GUESS
C FIELD, WHICH IN THIS WAVENUMBER 0 + MEAN WIND INTERPOLATION IS NOT NEEDED
C THESE MAY BE LEGACY IN THIS FIRST PASS **LEGACY REMOVE*
C
      ALLOCATE(UGUESS(N1))
      ALLOCATE(VGUESS(N1))
      ALLOCATE(WGUESS(N1))
C
C I THINK VELS IN SOME INCARNATION OF THIS PROGRAM WAS USED TO STORE VELOCITIES
C     NOT IT IS USED TO PASS/STORE VALUES BETWEEN/WITHIN ROUTINES SO IT IS
C     NOT LEGACY
C
      ALLOCATE(VELS(N3))
C
C INITIALIZE REFLECTIVITY OUTPUT AS ALL FLAGGED
C
      DO N=1,N1
       SUMDBZ(N)=RFLAG
      ENDDO
C 
C ... PROCESS ALL ARGUMENTS IN CALL TO PROGRAM
C
C ... CHECK FOR GRAPHICS OPTION AND SET FLAG
C 
C IF THERE IS A FILE NAMED "attenanswer" THEN READ IT TO DETERMINE
C WHETHER TO USE ALONG-RADIAL ATTENUATION CORRECTION
C IF IT DOESN'T EXIST DON'T APPLY ALONG-RADIAL ATTENUATION CORRECTION
C "attenanswer" IS A BACKDOOR FILE
C
      INQUIRE(FILE='attenanswer',EXIST=ATTENEXISTS)
      IF(ATTENEXISTS)THEN
         OPEN(88,FILE='attenanswer')
         READ(88,'(A1)')IATTEN
         CLOSE(88)
      ELSE
         IATTEN='N'
      ENDIF
      WRITE(6,*)'IATTEN = ',IATTEN
C
C DETERMINE HOW FAR FROM RADAR THE BACKGROUND REFLECTIVITY MASK WILL BE APPLIED
C IF "radmaskfile" DOES NOT EXIST MASK IS APPLIED AT TO EITHER RADMASK KM
C OR RADRAT TIMES THE RADAR ALTITUDE, WHICHEVER IS FARTHER
C "radmaskfile" IS A BACKDOOR FILE
C RADMASK IS A DISTANCE OUT IN KM TO USE MASK
C RADRAT IS A RATIO OF THE MAXIMUM DISTANCE TO APPLY MASK OVER THE 
C        AIRCRAFT ALTITUDE
C
      INQUIRE(FILE='radmaskfile',EXIST=RADMASKEXISTS)
      IF(RADMASKEXISTS)THEN
         OPEN(88,FILE='radmaskfile')
         READ(88,*)RADRAT
         READ(88,*)RADMASK
         CLOSE(88)
C
C IF RADRAT DOESN'T EXIST (DEFAULT) THE MASK IS USED OUT TO EITHER 10 KM 
C OR 4 TIMES THE ALTITUDE OF THE AIRCRAFT
      ELSE
         RADMASK=10.
         RADRAT=4.
      ENDIF
      WRITE(6,*)'RADIUSRATIOMAX,RADMASK = ',RADRAT,RADMASK
C
C BLANKING DATA WHEN REQUESTED AS A FUNCTION OF RADIUS (KM) OUT TO P3RADMIN
C OR BLANKING BECAUSE OVER LAND AND ABOVE MEAN SEA LEVEL (KM)
C GROUNDADJUST IS A SINGLE VALUE SO REALLY MEANT TO BE APPLIED OVER 
C FLAT LAND
C DEFAULT P3RADMIN=0.01 KM AND GROUNDADJUST = 0.0 KM
C
      INQUIRE(FILE='blankradius',EXIST=BLANKEXISTS)
      IF(BLANKEXISTS)THEN
         OPEN(87,FILE='blankradius')
         READ(87,*)P3RADMIN
         READ(87,*)GROUNDADJUST
C IF "blankradius" DOES NOT EXIST THEN DON'T REMOVE ANY DATA
      ELSE
         P3RADMIN=0.01
         GROUNDADJUST=0.
      ENDIF
      WRITE(6,*)'P3RADMIN,GROUNDADJUST = ',P3RADMIN,GROUNDADJUST
C
C GETARG GETS SPACE DELIMITED VALUES FROM THE COMMAND LINE
C THE VARIABLES GRAPHICSYESI (I IS NOT EXISTENT OR 2-3)
C ARE WHAT ARE READ FROM THE COMMAND LINE
C FIRST ARGUMENT IF FOR GRAPHICS
C UNLESS A "G" OR "g" IS THE FIRST ARGUMENT THE X SWEEPS GRAPHICS IS TURNED OFF
C
      CALL GETARG(1,GRAPHICSYES)
      IF(GRAPHICSYES.EQ.'G'.OR.GRAPHICSYES.EQ.'g')THEN
       IGRAPHICS=1
      ELSE
       IGRAPHICS=0
      ENDIF
C
C ... SET WHETHER THERE IS A BACKGROUND GUESS FIELD 
C ... IN THE CASE OF WAVENUMBER 0 PLUS MEAN ONLY GENERALLY THIS WILL 
C     ALWAYS BE IGUESS = 0
C
      CALL GETARG(2,GRAPHICSYES)
      IF(GRAPHICSYES.EQ.'G'.OR.GRAPHICSYES.EQ.'g')THEN
       IGUESS=1
      ELSE
       IGUESS=0
      ENDIF
C
C ... IPLANE = 1 INDICATES P3, IPLANE = 2  INDICATES G-IV
C     READ WHETHER A THE FILE IS FROM A G-IV OR NOT
C
      CALL GETARG(3,GRAPHICSYES)
      IF(GRAPHICSYES.EQ.'G'.OR.GRAPHICSYES.EQ.'g')THEN
       IPLANE=2
       WRITE(6,*)'IPLANE = ',IPLANE
      ELSE
       IPLANE=1
       WRITE(6,*)'IPLANE = ',IPLANE
      ENDIF
C
C ... DETERMINE GAP ALLOWED IN BARGEN-BROWN DE-ALIASING 
C     IF THE GAPS IS LARGER, THEN ALL VALUES OF DOPPLER RADIAL 
C     VELOCITY BEYOND GAP ARE FLAGGED
C
C GAP IS AN INTEGER VALUE IN KM
      CALL GETARG(4,GRAPHICSYES2)
      READ(GRAPHICSYES2,'(I2)')ISTORMLEVEL
C
C ... DETERMINE WHETHER THIS IS RESEARCH OR OPERATIONAL...FOR NOW THIS 
C     PARAMETER MAKES NO DIFFERENCE.  IT IS A PLACEHOLDER
C
      CALL GETARG(5,GRAPHICSYES)
      IF(GRAPHICSYES.EQ.'R'.OR.GRAPHICSYES.EQ.'r')THEN
       IREALTIME=1
      ELSE
       IREALTIME=0
      ENDIF
C
C IF THE 6TH ARGUMENT IS "V" OR "v" THEN VARIATIONAL SWEEP UNFOLDING 
C IS PERFORMED
C
      CALL GETARG(6,GRAPHICSYES)
      IF(GRAPHICSYES.EQ.'V'.OR.GRAPHICSYES.EQ.'v')THEN
       IVARIATIONAL=1
      ELSE
       IVARIATIONAL=0
      ENDIF
C
C THE 7TH ARGUMENT TELLS THE ROUTINE WHETHER THE SWEEP IS FROM THE
C AFT ANTENNA "A", FORE ANTENNA "F" OR SOMETHING ELSE, WHICH 
C MEANS EITHER BOTH FORE AND AFT SWEEPS (FRENCH) OR ALL SWEEPS (NOAA)
C BOTH OR ALL IS INDICATED GENERALLY BY A "b" in the argement
C THE b argument if for RVP5 data
C
      CALL GETARG(7,GRAPHICSYES)
      IF(GRAPHICSYES.EQ.'A'.OR.GRAPHICSYES.EQ.'a')THEN
       IAFTFORE=1
      ELSEIF(GRAPHICSYES.EQ.'F'.OR.GRAPHICSYES.EQ.'f')THEN
       IAFTFORE=2
      ELSE
       IAFTFORE=3
      ENDIF

C
C THE 8TH ARGUMENT TELLS THE ROUTINE WHETHER THE DATA ARE FROM RVP5 (ISIGMET=5)
C OR RVP8 OR LATER (ISIGMET=8)
C
      CALL GETARG(8,GRAPHICSYES)
      IF(GRAPHICSYES.EQ.'5')THEN
       ISIGMET=5
      ELSE
       ISIGMET=8
      ENDIF
C
C THE DEFAULT IS TO APPLY A MASK FOR RVP8 OR LATER DATA AND NOT TO APPLY IT
C FOR RVP5 DATA, ALTHOUGH ACTUALLY FOR RVP8 DATA BEFORE 2017, 
C REFLECTIVITY MASKING WAS NOT GENERALLY NEEDED
C IF "applymaskfile" EXISTS IN RUN DIRECTORY THEN IT WILL OVERRIDE THE DEFAULT
C "applymaskfile" IS A BACKDOOR FILE
C
      INQUIRE(FILE='applymaskfile',EXIST=APPLYMASKEXISTS)
      JTRAKAZMMIN=-1
      JTRAKAZMMAX=2100
      IF(APPLYMASKEXISTS)THEN
         OPEN(88,FILE='applymaskfile')
         READ(88,'(A)')APPLYMASKYESNO
         IF(APPLYMASKYESNO.EQ.'Y'.OR.APPLYMASKYESNO.EQ.'y')THEN
            READ(88,'(A)')APPLYUNDERONLY
            IF(APPLYMASKYESNO.EQ.'Y'.OR.APPLYMASKYESNO.EQ.'y')THEN
               IAPPLYMASK=1
            ELSE
               IAPPLYMASK=0
            ENDIF
         ENDIF
         IF(APPLYUNDERONLY.EQ.'Y'.OR.APPLYUNDERONLY.EQ.'y')THEN
            IUNDERONLY=1
            READ(88,*)JTRAKAZMMIN,JTRAKAZMMAX
         ELSE
            IUNDERONLY=0
         ENDIF
      ELSE
         IF(ISIGMET.EQ.8)THEN
            IAPPLYMASK=1
            IUNDERONLY=0
         ELSE
            IAPPLYMASK=0
            IUNDERONLY=0
         ENDIF
      ENDIF
      WRITE(6,*)'FIRST-PASS BARGEN-BROWN ALLOWABLE GAP = ',ISTORMLEVEL
C 
C THE 9TH ARGUMENT SAYS HOW MUCH AIRCRAFT ROLL IS ALLOWED (DEGREES) IN
C ORDER TO INTERPOLATE DATA
C
      CALL GETARG(9,GRAPHICSYES2)
      READ(GRAPHICSYES2,'(I2)')IROLLTOL
      ROLLTOL=IROLLTOL
C
C NSKIP MEANS EVERY NSKIPTH SWEEP IS INTERPOLATED SO NSKIP=1 MEANS
C EVERY SWEEP IS INTERPOLATED AND NSKIP=2 IS EVERY OTHER SWEEP, ETC
C THIS DIFFERS FROM nskip IN THE BIN SUBDIRECTORIES WHERE THE NUMBER
C IS ACTUALLY JUST THE SWEEPS THAT ARE SKIPPED BETWEEN EACH SWEEP INTERPOLATED
C
      CALL GETARG(10,GRAPHICSYES2)
      READ(GRAPHICSYES2,'(I2)')NSKIP
      ROLLTOL=IROLLTOL
C
C 11TH VARIABLE (IDBZADD) IS HOW MANY DB TO ADD TO THE DBZ FROM THE SWEEP FILES
C
      CALL GETARG(11,GRAPHICSYES3)
      READ(GRAPHICSYES3,'(I3)')IDBZADD
C
C 12TH VARIABLE (IDBZMASK) IS HOW MUCH THE REFLECTIVITY AT A GIVEN RADIUS AND
C DISTANCE HAS TO EXCEEED THE MASK TO INTERPOLATE THE REFLECTIVITY AND VELOCITY 
C DATA
C
      CALL GETARG(12,GRAPHICSYES3)
      ILEN=LEN_TRIM(GRAPHICSYES3)
      READ(GRAPHICSYES3,'(I3)')IDBZMASK
      IF(IPLANE.EQ.1.AND.ILEN.EQ.0)THEN
C
C IF A P3 AND ARGUMENTS NOT SUPPLIED THEN 5 DB ARE ADDED TO FORE DATA
C AND REFLECITIVY (AFT/FORE) HAVE TO EXCEED MASK BY (20/25) DB
         IF(IAFTFORE.EQ.1)THEN
            IDBZADD=0.
            IDBZMASK=20.
         ELSE
            IDBZADD=5.
            IDBZMASK=25.
         ENDIF
      ELSEIF(ILEN.EQ.0)THEN
C
C IF NOT A P3 IDBZADD IS - AND IDBZMASK IS 20
C
         IDBZADD=0.
         IDBZMASK=20.
      ENDIF
      WRITE(6,*)'IDBZMASK,IDBZADD,ILEN = ',IDBZMASK,IDBZADD,ILEN
      COMYES='Y'
      IF(COMYES.EQ.'Y'.OR.COMYES.EQ.'y')THEN
       LUIN=16
       FILNAM(1)='jobfile_radar_rt'
       OPEN(16,FILE=FILNAM(1),STATUS='OLD')
      ELSE
       LUIN=1
      ENDIF
C
C **** FLIGHT NAME
C 
      READ(LUIN,'(A8)')FLTNAME
      WRITE(6,1501)FLTNAME
1501  FORMAT('FLIGHT ID IS ',A8)
C
C DETERMINE FROM THE 7TH CHARACTER IN THE SHORT FLIGHT NAME 
C (YY RATHER THAN YYYY) WHETHER THE DATA ARE FROM NOAA42 (H), NOAA43 (I),
C OR NOAA49 (N)
C
      READ(FLTNAME,'(6X,A1)')AIRCHAR
      WRITE(6,*)'AIRCHAR IS ',AIRCHAR
C
C FROM THAT CHARACTER DETERMINE WHICH VERSION OF THE MASKADDFILE FILE
C SHOULD BE SEARCHED FOR
C
      IF(AIRCHAR.EQ.'H')THEN
         MASKADDFILE='maskadd_42'
      ELSEIF(AIRCHAR.EQ.'I')THEN
         MASKADDFILE='maskadd_43'
      ELSEIF(AIRCHAR.EQ.'N')THEN
         MASKADDFILE='maskadd_49'
      ELSE
         MASKADDFILE='nomaskfile'
      ENDIF
C
C NEXT IS WHERE WE SEE WHETHER maskadd_42, maskadd43, or maskadd49 exitsts
C
      WRITE(6,*)'MASKADDFILE = ',MASKADDFILE
      INQUIRE(FILE=MASKADDFILE,EXIST=I_EXIST)
C 
C ILEN IS DEFINED ABOVE BASED UPON WHETHER THE IDBZADD OR IDBZMASK 
C WERE DEFINED IN THE INPUT ARGUMENTS.  IF THEY WERE NOT (ILEN=0) 
C THEN USE THE VALUES IN THE MASKADDFILES
C
      IF(I_EXIST.AND.ILEN.EQ.0)THEN
         WRITE(6,*)'maskadd exists'
         OPEN(85,FILE=MASKADDFILE)
         READ(85,*)DBZADDA,DBZMASKA,DBZADDF,DBZMASKF
         CLOSE(85)
C
C RESET THE IDBZADD AND IDBZMASK VALUES TO THE ONES SET BY THE MASKADD FILE
C
         IF(IAFTFORE.EQ.1)THEN
            IDBZADD=NINT(DBZADDA)
            IDBZMASK=NINT(DBZMASKA)
         ELSE
            IDBZADD=NINT(DBZADDF)
            IDBZMASK=NINT(DBZMASKF)
         ENDIF
      ELSE
         WRITE(6,*)'maskadd does not exist'
C
C AT THIS POINT THE VALUES SET FROM THE COMMAND LINE ARGUMENTS ARE USED
C AND IF THEY WERE NOT SET THEN THE FINAL DEFAULT VALUES ABOVE FOR IDBZADD 
C AND IDBZMASK WILL BE USED
C
      ENDIF
      WRITE(6,*)'DBZADDA,DBZMASKA,DBZADDF,DBZMASKF = ',
     +           DBZADDA,DBZMASKA,DBZADDF,DBZMASKF
      WRITE(6,*)'FINAL IDBZADD,IDBZMASK = ',IDBZADD,IDBZMASK
C
C ... READ IN PARAMETERS AND FLAGS
C
C **** COMMAND FILE FLAG AND FILE NAME
C 
C
C **** EXPERIMENT NAME (32 CHARACTERS OR LESS)
C 
      READ(LUIN,'(A32)')EXPERIMENT
      WRITE(6,1502)EXPERIMENT
1502  FORMAT('EXPERIMENT NAME IS ',A32)
C
C **** NUMBER OF DOP3D FILES
C SET TO NFILE=2 WHICH ARE AFT AND FORE, BUT COULD BE CHANGED
C
      NFILE=2
      WRITE(6,1503)NFILE
1503  FORMAT('NUMBER OF UF FILES TO BE INTERPOLATED IN THIS RUN '/
     + 'BE ',I3)
C
C **** SUMMATION FILE NAMES--THE DATA, ACCUMULATED DURING INTERPOLATION,
C ARE USED IN SOLUTION MATRICES
C 
      OSUMFILENAME(1)='SUMFILE_aft_rt_auto_first'
      OSUMFILENAME(2)='SUMFILE_fore_rt_auto_first'
C
C **** BEGIN AND END TIMES
C **** IB,JB,KB ARE HOURS, MINUTES, SECONDS FOR BEGINNING OF INTERPOLATION
C **** IE,JE,KE ARE HOURS, MINUTES, SECONDS FOR END OF INTERPOLATION
C 
      READ(LUIN,'(3I2,X,3I2)')IB,JB,KB,IE,JE,KE
      WRITE(6,1506)IB,JB,KB
1506  FORMAT('BEGINNING TIME FOR INTERPOLATION WILL BE ',3I2)
      WRITE(6,1507)IE,JE,KE
1507  FORMAT('ENDING TIME FOR INTERPOLATION WILL BE ',3I2)
C
C SETTING THE BEGINNING AND END TIMES FOR INTERPOLATION IN SECONDS PAST MIDNIGHT
C
      TSTART=IB*3600.+JB*60+KB
      STIME=TSTART
      ETIME=IE*3600.+JE*60.+KE
C
C AN ATTEMPT TO ACCOUNT FOR AN ERROR WHEN 2400 IS NOT ADDED TO AND END
C TIME AFTER 0 GMT
C
      IF(ETIME.LT.STIME)THEN
       TEND=ETIME+86400.
      ELSE
       TEND=ETIME
      ENDIF
      WRITE(6,*)'STIME,ETIME,TSTART,TEND = ',
     +            STIME,ETIME,TSTART,TEND 
C
C     SUMMARY LOOP 
C            
      DO NF=1,2
       TATF(NF)='TA'
       TATF(NF)='TF'
       TSTARTARRAY(NF)=TSTART
       TENDARRAY(NF)=TEND
C
C DBZFACT IS THE FACTOR TO MULTIPLY INPUT REFLECTIVITY BY
C
       DBZFACT(NF)=1.
C XSHIFT AND YSHIFT AMOUNT IN KM TO SHIFT ANALYSIS BY (NO LONGER USED I BELIEVE)
       XSHIFT(NF)=0.
       YSHIFT(NF)=0.
C
C OSUMFILENAME(1) AND (2) SET ABOVE BY HARDWIRED
C
       WRITE(6,1508)NF,OSUMFILENAME(NF)
1508   FORMAT('OUTPUT INTERPOLATION SUMFILE FOR INPUT FILE NO. ',I3/
     + 'WILL BE ',A80)
       WRITE(6,11508)TATF(NF)
11508  FORMAT('SCAN TYPE WILL BE ',A2)
      ENDDO
C
C **** EASTWARD (SMOTIONU) AND NORTHWARD (SMOTIONV) STORM MOTION IN M/S
C 
      READ(LUIN,*)SMOTIONU,SMOTIONV
      WRITE(6,1509)SMOTIONU,SMOTIONV
1509  FORMAT('EASTWARD AND NORTHWARD ADVECTION VELOCITY FOR '
     + 'INTERPOLATION COMPOSITE '/
     + 'WILL BE ',2F8.3,' M/S')
C
C **** COMPOSITE CENTER TIME
C **** IH,IM,IS ARE THE HOURS, MINUTES AND SECONDS WHEN THE ORIGIN IS AT
C **** LATITUDE (OLAT) AND LONGITUDE (OLON) READ IN BELOW
C 
      READ(LUIN,'(3I2)')IH,IM,IS
      WRITE(6,1510)IH,IM,IS
1510  FORMAT('TIME OF ZERO ADVECTION IN COMPOSITE WILL BE ',3I2)
C
C **** CENTIME=TIME IN SECONDS SINCE MIDNIGHT OF COMPOSITE CENTER TIME
C
C TRYING TO DEAL WITH NOT CORRECTLY SPECIFYING END TIME PAST MIDNIGHT
C
      CENTIME=IH*3600+IM*60+IS
      IF(CENTIME.LT.STIME.AND.ETIME.GT.86400)CENTIME=CENTIME+86400.
C
C **** LATITUDE AND LONGITUDE OF ORIGIN AT CENTER TIME
C 
      READ(LUIN,*)OLAT,OLON
      WRITE(6,1511)IH,IM,IS,OLAT,OLON
1511  FORMAT('LATITUDE AND LONGITUDE OF ORIGIN AT TIME ',3I2/
     + 'WILL BE ',2F8.3)
C
C **** RADIAL, AZIMUTHAL, AND VERTICAL RESOLUTIONS OF ANALYSIS IN KM,DEG,KM
C 
      READ(LUIN,*)SX,SY,SZ
      WRITE(6,1512)SX,SY,SZ
1512  FORMAT('RADIAL-, AZIMUTHAL-, AND VERTICAL-DIRECTION GRID '/
     + 'RESOLUTIONS ARE ',F6.2,' KM, ',F6.2,' DEGREES, AND '/
     + F6.2,' KM, RESPECTIVELY')
C
C **** MINIMUM RADIUS (KM) FROM STORM CENTER, MINIMUM AZIMUTH (DEG) CCW FROM
C **** EAST, AND LOWEST HEIGHT (KM)
C 
      READ(LUIN,*)XZ,YZ,ZZ
C 
C     ROTATION IS SET TO ZERO SINCE CYLINDRICAL COORDINATES
C     ROTATION IS THE AZIMUTH OF Y-AXIS (NORMALLY ZERO)
C     THIS HAS NOT BEEN NON-ZERO IN YEARS, BE CAREFUL USING NON-ZERO ROTATION
C     YZ IS USUALLY SET TO SY AND GOES TO 360 DEG
C
      ROT=0.
      WRITE(6,1513)XZ
1513  FORMAT('MINIMUM RADIUS FROM STORM CENTER WILL BE ',F8.3)
      WRITE(6,1514)YZ
1514  FORMAT('MINIMUM AZIMUTH COUNTERCLOCKWISE FROM EAST WILL BE ',
     + F8.3,' DEGREES')
      WRITE(6,1515)ZZ
1515  FORMAT('HEIGHT OF LEVEL 1 WILL BE ',F8.3,' KM')
C
C **** RADIAL, AZIMUTHAL, AND VERTICAL DIMENSIONS
C 
      READ(LUIN,*)IMAX,JMAX,KMAX
      WRITE(6,1516)IMAX,JMAX,KMAX
1516  FORMAT('RADIAL, AZIMUTHAL, AND VERTICAL DIMENSIONS OF ARRAYS '/
     + 'WILL BE ',3I4)
C
C 10 LINES IN "jobfile_radar_rt" THAT ARE NOT NEEDED HERE
C
      DO IJK=1,10
       READ(LUIN,*)DUMMYIJK
      ENDDO
C
C HB2 HEIGHT OF MELTING BAND (HALFWAY VERTICALLY BETWEEN BOTTOM AND TOP)
C DPB2 THICKNESS OF MELTING BAND  HB2 AND DPB2 ARE NOMINAL VALUES WHICH
C ARE SOMETIMES CHANGED BY SOFTWARE
C ALL PRECIPITATION BELOW THE BOTTOM OF MELTING BAND CONSIDERED TO BE RAIN
C PRECIPITATION IS CONSIDERED TO BE ALL SNOW ABOVE TOP OF MELTING BAND
C IF DBZ < ZLOW
C PRECIPITATION IS CONSIDERED TO BE ALL RAIN ABOVE TOP OF MELTING BAND
C IF DBZ > ZHIGH
C THESE FOUR VARIABLES ARE USED TO COMPUTE PRECIPITATION FALL SPEED
C
      READ(LUIN,*)HB2,DPB2
      INQUIRE(FILE='changemeltingband',EXIST=CHANGEMELTBANDEXISTS)
      IF(CHANGEMELTBANDEXISTS)THEN
         OPEN(88,FILE='changemeltingband')
         READ(88,*)HB2,DPB2
         CLOSE(88)
      ENDIF
      WRITE(6,'(2F8.2)')HB2,DPB2
      READ(LUIN,*)ZLOW,ZHIGH
      INQUIRE(FILE='changenskip',EXIST=CHANGENSKIPEXISTS)
      IF(CHANGENSKIPEXISTS)THEN
         OPEN(88,FILE='changenskip')
         READ(88,*)NSKIP
         CLOSE(88)
      ENDIF
C
C **** RADIAL (RRMAX), AZIMUTHAL (RTMAX), AND VERTICAL (RZMAX) RADIA OF
C **** INFLUENCE (KM)
C 
c      RRMAX=2.*SX
c      RTMAX=3.*SY
c      RZMAX=2.*SZ
C
C RADIAL RADIUS OF INFLUENCE MADE MUCH BROADER TO PREVENT WILD CHANGES WITH
C RADIUS IN FIRST GUESS
C
      RRMAX=10.
C
C ISTORMLEVEL = 1 INDICATES THAT THE STORM IS CHARACTERIZED AS MAJOR HURRICANE
C AND MEANS THAT THERE CANNOT BE A GREATER THAN 1-KM GAP BEFORE DATA BEYOND
C ARE FLAGGED SINCE BARGEN-BROWN DE-ALIASING IS CONSIDERED UNRELIABLE.
C RADIAL GRADIENTS ARE CONSIDERED TOO HIGH TO USE A WIDER RADIUS OF INFLUENCE
C ACTUALLY THE ROUTINE IN THIS MODULE IS NOT RUN FOR MAJOR HURRICANES
C IN THIS ROUTINE ISTORMLEVEL IS THE MAXIMUM ALLOWABLE GAP, EVEN FOR 
C WEAKER SYSTEMS, WHERE ISTORMLEVEL IS GENERALLY HIGHER
C
      IF(ISTORMLEVEL.LE.1)RRMAX=SX
      RTMAX=15.
      RZMAX=1.
      WRITE(6,1517)RRMAX,RTMAX,RZMAX
1517  FORMAT('RADIAL, AZIMUTHAL, AND VERTICAL RADII (KM) OF '/
     + 'INFLUENCE OF DOPPLER DATA WILL BE ',3F8.2)
C
C **** RADIAL, AZIMUTHAL, AND VERTICAL E-FOLDING DISTANCE (KM)
C 
      ERMAX=SX
      ETMAX=SY
      EZMAX=SZ
      WRITE(6,1518)ERMAX,ETMAX,EZMAX
1518  FORMAT('RADIAL, AZIMUTHAL, AND VERTICAL E-FOLDING DISTANCE '/
     + 'FOR GAUSSIAN INTERPOLATION WILL BE ',3F8.2,' KM')
C
C **** "parameters.txt" FILE WILL BE USED TO ADD METADATA TO 3D NETCDF
C **** WIND FILES
C **** ONLY WRITE ON AFT SINCE THESE DATA ARE THE SAME FOR FOR AND AFT
C
      IF(IAFTFORE.NE.2)THEN
C
C **** "jobfiletoparameters" HAS ALREADY WRITTEN TO "parameters.txt"
C **** SO POSITION='APPEND' IS USED
C
       OPEN(65,FILE='parameters.txt',action='write',
     1  position='append')
C
C TELL THE NETCDF FILE MAKER THAT THE FIRSTPASS WAS RUN, WHICH WILL BE
C NEED WHEN WRITING OUT THE GLOBAL ATTRIBUTES
C
       WRITE(65,'(A)')'firstpass'
C
C WRITE BARGEN-BROWN ALLOWABLE GAP IN KM TO 'parameters.txt'
C
       WRITE(65,'(I2)')ISTORMLEVEL
C
C WRITE RADIUS OF INFLUENCE AND E-FOLD PARAMETERS FOR FIRST 
C       PASS TO 'parameters.txt'
C
       WRITE(65,'(3F8.2)')RRMAX,RTMAX,RZMAX
       WRITE(65,'(3F8.2)')ERMAX,ETMAX,EZMAX
       CLOSE(65)
      ENDIF
C XACC,YACC,ZACC NO LONGER USED IN INTERPOLATION PROGRAMS SO THEY ARE SET
C VERY LARGE  **LEGACY REMOVE*
      XACC=99.
      YACC=99.
      ZACC=99.
C
C **** MAXIMUM AZIMUTHAL DISTANCE (IN DEGREES) THAT AN OBSERVATION 
C **** CAN BE FROM A GRID POINT AND BE INCLUDED IN THE WEIGHTED AVERAGE (PIMAX)
C 
      PIMAX=45.
      WRITE(6,1520)PIMAX
1520  FORMAT('MAXIMUM AZIMUTHAL DISTANCE (IN DEGREES) '/
     + ' THAT AN OBSERVATION CAN BE FROM A GRID POINT AND BE '/
     + ' INCLUDED IN THE WEIGHTED AVERAGE WILL BE ',F8.2)
C
C **** AZIMUTHAL COVERAGE FLAG IACROSS SAYS TO INTERPOLATE ACROSS THE
C           0/360 DEGREE BOUNDARY.  ONLY TIME THIS WOULDN'T BE DONE IS
C IF AN ARC ANALYSIS IS BEING DONE, WHICH HAS EITHER NEVER BEEN DONE
C OR HAS BEEN A VERY LONG TIME
C 
      IACROSS=1
      IF(IACROSS.EQ.1)THEN
C
C     AZIMUTHS START BEFORE AZI=0 AND EXTEND BEYOND AZI=0, OR FULL 360
C 
       WRITE(6,*)'J=1 AND J=JMAX WILL BE CONSIDERED ADJACENT'
      ELSE
C
C     WEDGE STARTS AT AZI>0 AND ENDS AT AZI<360 
C     WEDGE IS OBSOLETE
       WRITE(6,*)'J=1 AND J=JMAX WILL NOT BE CONSIDERED ADJACENT ',
     + '(SECTOR ONLY)'
      ENDIF
C
C **** ALLOWS A DIFFERENT NUMBER OF LEVELS BETWEEN SYNTHESIS AND 
C **** ORIGINAL INTERPLOATION (LEGACY)
C 
      KMIN2=1
      KMAX2=KMAX
      WRITE(6,1521)KMIN2,KMAX2
1521  FORMAT('MINIMUM AND MAXIMUM LEVELS OF INTERPOLATION FILE ',
     + 'TO BE FILLED ARE ',2I4)
C
C **** SET MAXIMUM ANGLE OF DOPPLER RADIAL RELATIVE TO HORIZONTAL 
C **** (EARTH-RELATIVE ELEVATION ANGLE) TO BE ACCEPTABLE FOR 
C **** INTERPOLATION (THEN TAKE SIN)
C 
      SINTOL=90.
      WRITE(6,1522)SINTOL
1522  FORMAT('MAXIMUM ANGLE OF DOPPLER RADIAL RELATIVE TO '/
     + 'HORIZONTAL (EARTH-RELATIVE ELEVATION ANGLE) TO BE '/
     + 'ACCEPTABLE FOR INTERPOLATION WILL BE ',F8.2,' DEGREES')
      IF(SINTOL.GE.90.)THEN
       SINTOL=1.
      ELSE
C CTR IS A CONVERSION FACTOR BETWEEN DEGREES AND RADIANS
       SINTOL=SINTOL*CTR
       SINTOL=SIN(SINTOL)
      ENDIF
C
C **** MINIMUM DBZ AT RANGE RRRR TO INCLUDE IN ANALYSIS
C      RRRR WILL BE USED FOR DISTANCE SQUARED LAW
C 
      DBZTEST=-2000.
      RRRR=10.
C
C **** AZIMUTHAL ADVECTION FLAG AND SPEED FOR COMPOSITE IVSPEED
C 
C      IGUESS=0
C **** THIS CANNOT BE USED FOR AUTOMATED ANALYSES
C BELOW IS LEGACY, SINCE THIS WILL CAUSE THE PROGRAM TO HALT SINCE
C INPUT OF VSPEED0 WILL NOT HAPPEN IN AUTOMATED RUN
C
      IVSPEED=0
      IF(IVSPEED.EQ.1)THEN
       WRITE(6,*)'Enter advection speed'
       READ(1,*)VSPEED0
       VFACTOR=1.
      ELSE
       IF(IGUESS.EQ.5)THEN
        WRITE(6,*)'Enter factor to multiply wind speed by for advection'
        READ(1,*)VFACTOR
       ELSE
        VFACTOR=0.
       ENDIF
       IVSPEED=0
      ENDIF
C
C **** RAMSFILE FLAG AND FILE NAME
C **** RAMS FILES HAVE NOT BEEN USED IN AUTOMATED ANALYSES
C IRAMSFILES IS A YES (1) OR NO (0) ANSWER AS TO WHETHER RAMSFILES WILL BE USED
C
      IRAMSFILES=0
      IF(IRAMSFILES.EQ.1)THEN
       DO NF=1,NFILE
        READ(LUIN,'(A80)')RAMSFILES(NF)
        WRITE(6,1530)NF,RAMSFILES(NF)
1530    FORMAT('RAMS FILE FOR UF FILE NO. ',I3,' WILL BE: '/A80)
       ENDDO
      ENDIF
C
C ... INITIALIZE LEGACY VARIABLE
C 
      DO IJK=1,N1
       UGUESS(IJK)=0.
       VGUESS(IJK)=0.
       WGUESS(IJK)=0.
      ENDDO
C
C     ONLY ONE INPUT FILE WHEN WORKING WITH REAL TIME DATA STREAM 
C 
      NF=1
      write(6,*)'at the beginning of nfile do loop nf = ',nf
C
C ... ABCD READS SCAN FILE NO. NF, SUMS EFFECTS FROM PRESENT WIND FILE, 
C     AND COMPUTES WINDS IF LAST FILE IN ITERATION 
C 
      WRITE(6,*)'CALLING ABCD'
C 
      IF(IRAMSFILES.EQ.1)THEN
       CALL OPENRAMFILE(RAMSFILES(NF),LUOUT,STIME,ETIME,DATARATE,IERR)
      ENDIF
C 
      TSTART=TSTARTARRAY(NF)
      TEND=TENDARRAY(NF)
      SLOPE1=DBZFACT(NF)
C 
      IREVERSE=0
      IREADABCD=0
C 
C **** ISX=1 MEANS A MAJOR HURRICANE AND ISX = 0 MEANS NOT
C
      ISX=0
      WRITE(6,*)'IAPPLYMASK = ',IAPPLYMASK
C
C ABCD IS THE ROUTINE THAT INTERPOLATES SWEEP DATA TO THE CYLINDRICAL 
C COORDINATES.  USING RVP8 OR LATER ONLY EITHER THE AFT OR FORE SUMS WILL
C BE POPULATED, BUT WITH RVP5 FILES BOTH AFT AND FORE SUMS WILL BE POPULATED
C
      
      CALL ABCD
     1   (RRMAX,RTMAX,RZMAX,ERMAX,ETMAX,EZMAX,XACC,YACC,ZACC,NF,
     2   SUM1,SUM2,SUM3,SUM4,SUM5,SUM6,SUM7,SUM8,SUM9,
     2   SUM10,SUM11,SUM12,SUM13,SUM14,SUM15,SUM16,SUM17,SUM18,
     2   SUM19,SUM20,SUM21,SUM22,SUM23,SUM24,
     3   KMIN2,KMAX2,
     4   SINTOL,SX,SY,SZ,XZ,YZ,ZZ,ROT,IMAX,JMAX,KMAX,SUMDBZ,
     6   SUMWTSAVE,VELS(1),VELS(1+N1),VELS(1+2*N1),
     6   IGUESS,
     7   IREADABCD,OLAT,OLON,
     9   SLOPE1,CENTIME,TSTART,TEND,
     1   SMOTIONU,SMOTIONV,FLTNAME,DBZTEST,RRRR,
     1   UGUESS,VGUESS,WGUESS,IREVERSE,IRAMSFILES,
     1   DISTXYZ,PIMAX,IACROSS,IVSPEED,VSPEED0,VFACTOR,TATF,IGRAPHICS,
     1   ZLOW,ZHIGH,HB2,DPB2,ISTORMLEVEL,IPLANE,IREALTIME,IVARIATIONAL,
     1   ISX,IAFTFORE,ISIGMET,ROLLTOL,NSKIP,IDBZADD,IDBZMASK,P3RADMIN,
     1   GROUNDADJUST,IATTEN,RADRAT,RADMASK,IAPPLYMASK,IUNDERONLY,
     1   JTRAKAZMMIN,JTRAKAZMMAX)
C
C ... CLOSE FILE OPENED IN SUBROUTINE ABCD
C IT APPEARS THIS CLOSE(98) IS NOT NEEDED BUT DOES NOT CAUSE CRASH
C
      CLOSE(98)
C 
C THIS IS A PROGRAM THAT SHOULD WRITE SUMFILES 
C
      IWRITEABCD=1 
C 
      IF(IWRITEABCD.EQ.1)THEN
C
C      LUW IS THE LOGICAL UNIT NUMBER FOR OUTPUT SUMFILE. FILE IS OPENED
C      IN MAIN PROGRAM BUT CLOSED IN A SUBROUTINE
C 
       LUW=95
       NFF=1
C
C IF IAFTFORE EQUALS 1 OR 2 THEN ONLY FORE OR AFT DATA ARE INTERPOLATED
C IN THIS ROUTINE
C IF IAFTFORE EQUALS 3 THEN THERE WAS ONLY ONE ANTENNA AND FORE AND AFT
C DATA FROM THAT ANTENNA ARE ACCUMULATED SEPARATELY BUT SIMULTANEOUSLY 
C IN THIS ROUTINE
C
       IF(IAFTFORE.EQ.1.OR.IAFTFORE.EQ.3)THEN
C
C WRITE SUMMATIONS TO AFT SUMFILE
C
        OPEN(LUW,FILE=OSUMFILENAME(NFF),FORM='UNFORMATTED')
C
C .... WRITEABCD WRITES OUT THE SUMMATIONS OF PRODUCTS THAT ARE NEEDED FOR
C      THE LEAST SQUARES WIND SOLUTION IN THE SYNTHESIS PROGRAMS
C **** WRITEABCD24 IS THE VERSION OF THE SUMMATION FILE WRITER FOR THE 
C **** WAVENUMBER ZERO AND LEVEL BY LEVEL MEAN FLOW INTERPOLATION
C 
        CALL WRITEABCD24(LUW,IMAX,JMAX,KMAX,SUM1,SUM2,SUM3,
     +   SUM4,SUM5,SUM6,SUM7,SUM8,SUM9,SUM10,SUM11,SUM12,SUM13,
     +   SUM14,SUM15,SUM16,SUM17,SUM18,SUM19,SUM20,SUM21,SUM22,
     +   SUM23,SUM24,SUMDBZ,
     +   VELS(1),VELS(N1+1),VELS(2*N1+1),NFF)
        write(6,*)'ended writeabcd for file ',NFF
C
C      APPARENTLY FILE LUW IS CLOSED IN WRITEABCD
C 
       ENDIF
       IF(IAFTFORE.EQ.2.OR.IAFTFORE.EQ.3)THEN
C
C WRITE SUMMATIONS TO FORE SUMFILE
C
        NFF=2
        OPEN(LUW,FILE=OSUMFILENAME(NFF),FORM='UNFORMATTED')
        CALL WRITEABCD24(LUW,IMAX,JMAX,KMAX,SUM1,SUM2,SUM3,
     +   SUM4,SUM5,SUM6,SUM7,SUM8,SUM9,SUM10,SUM11,SUM12,SUM13,
     +   SUM14,SUM15,SUM16,SUM17,SUM18,SUM19,SUM20,SUM21,SUM22,
     +   SUM23,SUM24,SUMDBZ,
     +   VELS(1),VELS(N1+1),VELS(2*N1+1),NFF)
        write(6,*)'ended writeabcd for file ',NFF
       ENDIF
      ENDIF
      STOP
      END
