	program check_fix_hdrs
C 
	implicit none
	include "iris_f90_structures.h"
	include "TDR_hdr_f90.h"
	include "sigmet_dsp_data_types_f90.h"
	include "hrd_radar_common_blocks.f"
	integer num_hdrs
C
	type ( TDR_hdr ) good_hdr	


	integer fix_lu, caca
	character*19 ext_fn
	character*80 aux_list
	real dt, delt_min, delt_max
C
	integer nh
	real p_ave,d_ave,r_ave,lat_ave,lon_ave
	real wspd_ave, wdir_ave, vws_ave
	real irs_age_ave, gps_age_ave, aamps_age_ave
	real irs_age, gps_age, aamps_age
C header flags:
	integer*4 nav_flag, alt_flag, attitude_flag,
     +	   gdspd_flag, wind_flag
C
	fix_lu = 12
	nav_flag = 2
	alt_flag = 2
	attitude_flag = 1
	gdspd_flag = 1
	wind_flag = 3

	call set_hdr_flags(nav_flag, alt_flag, attitude_flag,
     +	   gdspd_flag, wind_flag)


	call getarg(1,aux_list)
	if(aux_list .eq. ' ')then
	  write(6,*)'enter fixed header aux file list'
	  read(5,'(a)')aux_list
	end if
	open(15,file=aux_list)
223	read(15,'(a)',end=999)ext_fn
	open(fix_lu,file=ext_fn,form='unformatted')
	delt_max = 0.0
	delt_min = 3600.0
	read (fix_lu)ext_fn
	caca = 1
	num_hdrs = 0
	nh = 0
	p_ave = 0
	d_ave = 0
	r_ave = 0
	lat_ave = 0
	lon_ave = 0
	wspd_ave = 0
	wdir_ave = 0
	vws_ave = 0
	irs_age_ave = 0
	gps_age_ave = 0
	aamps_age_ave = 0
C
	do while(caca .gt. 0)
C for each ray, read the fix
	  read(fix_lu,end = 100)dt,good_hdr
Cout	write(fix_lu)-999.9, air_hdr(i)
	gps_age = good_hdr%gps_age    ! /**< Time in milliseconds since last GPS Input */
	irs_age = good_hdr%irs_age    ! /**< Time in milliseconds since last IRS Input */
	aamps_age = good_hdr%aamps_age  ! /**< Time in milliseconds since last AAMPS Input */

	if(dt .ge. 0)then ! replace
	  if(dt.lt.delt_min)delt_min = dt
	  if(dt.gt.delt_max)delt_max = dt
	  nh= nh + 1
	  call read_TDR_hdr(0, good_hdr)

	  p_ave = p_ave + pitch
	  d_ave = d_ave + drift
	  r_ave = r_ave + roll
	  lat_ave = lat_ave + rlat
	  lon_ave = lon_ave + rlon
	  wspd_ave = wspd_ave + ws
	  wdir_ave = wdir_ave + wd
	  vws_ave = vws_ave + vws
	  irs_age_ave = irs_age_ave + irs_age
	  gps_age_ave = gps_age_ave + gps_age
	  aamps_age_ave = aamps_age_ave + aamps_age

	end if
	  num_hdrs = num_hdrs + 1
cout	  write(6,123)num_hdrs,dt
123	  format(i4,1x,f10.5)
	end do
100	close(fix_lu)
C
	if(nh .gt. 0) then
	p_ave = p_ave / nh
	d_ave = d_ave / nh
	r_ave = r_ave / nh
	lat_ave = lat_ave / nh
	lon_ave = lon_ave / nh
	wspd_ave = wspd_ave/nh
	wdir_ave = wdir_ave/nh
	vws_ave = vws_ave/nh
	irs_age_ave = irs_age_ave/nh
	gps_age_ave = gps_age_ave/nh
	aamps_age_ave = aamps_age_ave/nh
C
	write(6,124)ext_fn,num_hdrs,delt_min,delt_max
124	format(a19,1x,i4, 2(1x,f6.4))
C
	write(6,125)lat_ave, lon_ave, p_ave, r_ave, d_ave, nh
125	format("Nav ",2(1x,f7.2),3(1x,f5.2),1x,i4)
	write(6,1251)ext_fn,wspd_ave, wdir_ave, vws_ave
1251	format(a19,1x, "Winds: ", 3(1x,f7.2))
	write(6,1252)ext_fn,irs_age_ave,gps_age_ave,aamps_age_ave
1252	format(a19," Ages: ",3(1x,f8.1) )
C
	else
	  write(6,127)ext_fn
127	  format(a19,' has no fixed headers')
	end if
C
	go to 223
C
999	close(15)
C
C
	end
