	program chk_rvp8_hdr
C Read one rvp8 RAW file and tead and check all the 
C extended geaders, to lliik for crap...
C
C
C==== ddeclarations ================================
	implicit none 
	integer nh, num_rays 
	real p_ave,d_ave,r_ave,lat_ave,lon_ave
	real wspd_ave, wdir_ave, vws_ave
	real irs_age_ave, gps_age_ave, aamps_age_ave
	real irs_age, gps_age, aamps_age
C header flags:
	integer*4 nav_flag, alt_flag, attitude_flag,
     +	   gdspd_flag, wind_flag

	integer max_rays, max_gates
	parameter(max_rays = 500, max_gates = 2048)

C IRiS files probalby only hold 5 or less but  I keep it  big just in case...

	integer*4 swapped, read_stuff
	character*80 sweep_fn
C swp_lu is actually a pointer to a file descriptor. On thor
C pointersare 4 byte but on helios, a 64 bit machine, thr pointers are 8 bytes
	integer*8 swp_lu
	integer*4 iostat
	integer*4 nrem, tot_read
	integer*4 num_fields
	integer*4 io_error

	include "iris_f90_structures.h"
	include "TDR_hdr_f90.h"
	include "sigmet_dsp_data_types_f90.h"
					
	type ( struct_hdr ) str_hdr
	type ( product_config ) prod_conf
	type ( product_end ) prod_end
	type ( ingest_configuration) i_config
	type ( task_sched_info ) t_si
	type ( task_dsp_info ) t_dsp
	type ( task_calib_info ) t_calib
	type ( task_range_info ) t_range
	type ( task_scan_info ) t_scan

	type ( ymds_time ) start_time_str
	type ( ymds_time ) end_time_str
	real sweep_start_time
	
	type ( task_misc_info ) t_misc
	type ( task_end_info ) t_end

	type ( task_rhi_scan_info ) t_rhi
	type ( task_ppi_scan_info ) t_ppi
	
	type ( ingest_data_hdr ) idh(MAX_FIELDS) ! /* should be more general! */
	type ( raw_prod_bhdr ) rpbh
	type ( ray_hdr ) rh(max_rays)
	type ( TDR_hdr ) air_hdr(max_rays)



C and here are the arrays for the pther data types:
	real*4 dbz(max_gates)
	real*4 dop(max_gates)
	real*4 wid(max_gates)
	real*4 vel_nyq
C  and 3 arrays i can use for displaying sweeps
	real dbz_sweep(max_gates, max_rays)
	real dop_sweep(max_gates, max_rays)
	real spw_sweep(max_gates, max_rays)
	real az_el( 2, max_rays)

C HRD radar tape/file data structures
C Radar tape/file stuff
C 

	character*4 time_string

c note thr read_* suntoutines will fill the varaibles intse
C common blocks
	include "hrd_radar_common_blocks.f"

	logical french_antenna
	character*1 antenna_type
C array of flags to select data
	integer data_sel_flags(3)
C
	real good_time(max_rays)
C
	character*132 swp_fn
	character prefix*15, ext_fn*19
C
	integer year,day

	integer jday_start,jday
 
	integer igood_read
	integer isweep, ifl, ir, i
	integer num_sweeps, num_bins(max_rays)
	integer ir_want, ifl_want
	real dt_min, del_time
C shit for midnight crossing:
	real day_secs

C === end declarations =========================
C
C default data types to retrieve
	data_sel_flags(1) = DB_DBZ2
	data_sel_flags(2) = DB_VEL2
	data_sel_flags(3) = DB_WIDTH2
C
	day_secs = 24.0 * 3600.0
C

	igood_read = 1 ! for testing io_error in get tdr ray
	nav_flag = 2
	alt_flag = 2
	attitude_flag = 1
	gdspd_flag = 1
	wind_flag = 3

	call set_hdr_flags(nav_flag, alt_flag, attitude_flag,
     +	   gdspd_flag, wind_flag)
c
C get sweep file:
	call getarg(1,sweep_fn)
	if(sweep_fn .eq. ' ')then
	  write(6,*)'entefsweep file name:'
	  read(5,'(a)')sweep_fn
	end if
C
C ======  open file, read in data, save array of hdrs..
C
	call open_iris_file(swp_lu, sweep_fn, iostat)
	call check_byte_swapping(swp_lu, swapped)
	call read_iris_record_1(swp_lu, swapped, read_stuff,
     +		prod_conf, prod_end )
	call read_product_hdr(0, prod_conf, prod_end)
	call read_iris_record_2(swp_lu, swapped, read_stuff, 
     +		 i_config, t_si, 
     +		t_dsp, t_calib, t_range, t_scan,  t_misc, t_end,
     +		t_rhi)
	tot_read = 2 * BLK_LENGTH
	call read_task_hdr(0, t_si, t_dsp, t_calib,
     +		t_range, t_scan, t_misc, t_end, 
     +		t_rhi)
C print task_calib_info.flag bits
C get Nyquist vel from stuff stored in tasd header structures in m/x
C get Nyquist vel from stuff stored in tasd header structures in m/x
C There  may be multiple sweeps per file (although I hpe not ) so
C I need a so loop here.
	num_sweeps = t_scan%num_sweeps
C change 19 June 2012
C file with multiple sweeps will list more than one
C associated file for each variable...
	num_fields = i_config%num_assoc_files/num_sweeps
C
	do isweep = 1, num_sweeps !  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

C Now we need to get the ingest darta structures that
C describe each parameter stored in the rays. These are
C sotired in data blocks, so first read the raw product
C block header, then the ingest structures.
	call read_iris_sweep_start(swp_lu, swapped, read_stuff,
     +		rpbh, idh(1), num_fields, nrem, tot_read)
	start_time_str = idh(1)%date
	call read_time_structure(6, iyear, month, iday,
     +		 ih, im, is, is100, start_time_str)
	time = start_time_str%seconds + is100 * 0.01

	sweep_start_time= time
C dump ingest data header variavles

	num_rays = idh(1)%num_rays_in_file
	call flush(6)

C finally read the rays and expand the data, including the extended headers
	  num_rays = idh(num_fields)%expected_num_rays
	  do i = 1, num_rays

	   call read_iris_tdr_ray( swp_lu, swapped, read_stuff,
     +		vel_nyq, idh(1), rpbh, rh(i), 
     +		air_hdr(i), dbz, dop, wid, 
     +		data_sel_flags, num_fields, nrem, tot_read,
     +		io_error)
	   if( io_error .ne. igood_read) then
		write(6,*)'crud. read ray error: ', io_error
		go to 333 ! break out
	   end if
D update time:
	  good_time(i) = sweep_start_time + 
     +		air_hdr(i)%time_since_sweep_start * 0.001
	  call convert_time(good_time(i),ih,im,is)
	  is100 = (time-ih*3600.0-im*60.0-is)*100
C
	   num_bins(i) = rh(i)%num_bins_in_ray
	  end do ! rays loop

	  if(nrem .gt. 0) then
	     call skip_iris_words(swp_lu, nrem)
	     nrem = 0
	  end if
	end do !  end sweeps loop <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<


333	call close_iris_file(swp_lu)

C ===============================
C check hdrs for age, weird values...
	nh = 0
	p_ave = 0
	d_ave = 0
	r_ave = 0
	lat_ave = 0
	lon_ave = 0
	wspd_ave = 0
	wdir_ave = 0
	vws_ave = 0
	irs_age_ave = 0
	gps_age_ave = 0
	aamps_age_ave = 0
c
	do i = 1, num_rays
	 if(num_bins(i).gt.0) then
	  gps_age = air_hdr(i)%gps_age    ! /**< Time in milliseconds since last GPS Input */
	  irs_age = air_hdr(i)%irs_age    ! /**< Time in milliseconds since last IRS Input */
	  aamps_age = air_hdr(i)%aamps_age  ! /**< Time in milliseconds since last AAMPS Input */
	  nh= nh + 1
	  call read_TDR_hdr(0, air_hdr(i))

	  p_ave = p_ave + pitch
	  d_ave = d_ave + drift
	  r_ave = r_ave + roll
	  lat_ave = lat_ave + rlat
	  lon_ave = lon_ave + rlon
	  wspd_ave = wspd_ave + ws
	  wdir_ave = wdir_ave + wd
	  vws_ave = vws_ave + vws
	  irs_age_ave = irs_age_ave + irs_age
	  gps_age_ave = gps_age_ave + gps_age
	  aamps_age_ave = aamps_age_ave + aamps_age
	 end if
	end do
C
	if(nh .gt. 0) then
	p_ave = p_ave / nh
	d_ave = d_ave / nh
	r_ave = r_ave / nh
	lat_ave = lat_ave / nh
	lon_ave = lon_ave / nh
	wspd_ave = wspd_ave/nh
	wdir_ave = wdir_ave/nh
	vws_ave = vws_ave/nh
	irs_age_ave = irs_age_ave/nh
	gps_age_ave = gps_age_ave/nh
	aamps_age_ave = aamps_age_ave/nh
C
C 
	write(6,*)'Averages for Sweep: ',sweep_fn
	write(6,*)'Mum non-zero rays: ',nh
	write(6,1205)lat_ave, lon_ave
1205	format("Lat, Lon: ",2(1x,f7.2) )
	write(6,1215)p_ave, r_ave, d_ave
1215	format('Pitch, Drift, Roll: ',3(1x,f5.2) )
	write(6,1251)wspd_ave, wdir_ave, vws_ave
1251	format( "Wind dir, spd, vert spd: ", 3(1x,f7.2))
	write(6,1252)irs_age_ave,gps_age_ave,aamps_age_ave
1252	format(" Ages (msec) irs,gps, aamps: ",3(1x,f8.1) )
C
	else
	  write(6,*)sweep_fn,' has no non-zero rays'
	end if


	end
