C mod ij bilenear (non)interpolator from polar to cart, to just disopl;ay rays as 
c az on ver axis, tange on horiz acis
C 26 August 2013
C NON-INTERPOLATING VERSION
C p dodge 7 Jan 2003
	subroutine rvp8_bscan_nointerp(data_type, 
     +		elmin, elmax,iz,maxx,maxy,iun,
     +		az_el, sweep_data, max_bins, num_bins, numrad, ierror,
     +		imax, jmax, sx, sy, xdis, ydis, rlat, rlon,
     +		slat, slon, rmx, rdel, time, nmosm, itflg,
     +		gate_length,bad_val)
	integer data_type ! =1 for dBZ, =2 for Dopppler
	integer*2 iz(maxx, maxy) ! output
	integer*2 IZ_val
	real sweep_data(max_bins, numrad) ! holds one sweep
	real az_el(2,numrad) ! holds az and el for each ray
	real gate_length(max_bins)
	real bad_val
* 	Version of smconvt for DORADE data.
* Data is passed in array sweep_data and interpolated into iz.
* Note: if sweep data contains reflectivity it will be in Z, NOT dBZ
*  But iz will be returned as dBZ * 10 !!!
*     The coordinate system window is [(0,0) , (imax*sx,jmax*sy)]. Data 
* in that space is interpolated to the array defined by 
* [(1,1) , (imax,jmax)]. Thus, indices i,j represent the point  
* (i*sx-0.5,j*sy-0.5) and conversely x,y will map to nint(x/sx+0.5) 
* and nint(y/sy+0.5) or, equivalently, trunc(x/sx+0.5), trunc(y/sy+0.5) 
* to gen array indices in bounds the clipping window is:
c 	* { ( sx/2 , sy/2 ) , ( (imax-1/2)*sx , (jmax-1/2)D*sy) ) } ...aug 18, 87 
c         xz,yz - position of radar in grid 
c         xdis,ydis - storm position in grid ( for moving coordinate systems) 
C         x0,y0 - (x,y) COORDINATE WITH RESPECT TO RADAR
C         R - RANGE FROM RADAR TO (X0,Y0) 
C         S,T - ANGULAR and radial interplolation FACTORs 
C         numrad - NUMBER OF RADIALS THAT MAKE UP SWEEP 
C         NAZ - MAX NUMBER OF RADiaLS THAT COULD MAKE UP 1 SWEEP
C if rem_storm then remove storm u, v from velocities
      DIMENSION BIN1(1024), BIN2(1024)
      dimension w(4) 
      logical done, vis1, vis2
	parameter( num_aux = 1023) ! should be big enough for HRD displays
	integer aux_array(0:num_aux)
C
	do j = 1, maxy
		do i = 1, maxx
			iz(i,j) = -9999
		end do
	end do
C 
	pi = acos(-1.0)
	pi180 = pi /180.0
      ierror=0
C
C interpolate 
Cout      azm1 = az_el(1,1)
cout      ev1 = az_el(2,1)
	do j = 1, numrad
	  jptr = az_el(1,j)
	   if(jptr .lt. 1) then
		jptr = jptr + 360
	   else if(jptr .gt. 360) then
		jptr = jptr - 360
	   end if
	do i = 1, maxx ! bins loop
      		Z = sweep_data(i,j)
C
		if( data_type .eq. 1) then ! convert to dBZ
C Z < 0.0 should not happen anymore, but just in case...
		   IF(Z .LE. 0.0) then
			iz(i,jptr) = -9999 ! should only happen on edges of bad data
		   else 
		   	idBZ = ALOG10(Z)*10.0
C only replace dBZ if > what is already there
			if( idBZ .gt. (iz(i,jptr)*0.1) )then
				iz(i,jptr) = idBZ * 10.0 ! 0.1 dBZ res
			end if
		   end if
		else
		   if(Z .gt. bad_val) then
		     IZ_val = z *10.0
C preserve largest Doppler
		     if(iz(i,jptr) .gt. -9999) then
			if(abs(IZ_val) .gt. abs(iz(i,jptr)) ) then
				iz(i, j) = IZ_val
			end if
		     else
			iz(i, j) = IZ_val
		     end if
		   else
			iz(i,jptr) = -9999
		   end if
		end if
C
	end do ! <<<<  nins loop
	end do ! <<<<  rays loop
      return
      end 

