      program rvp8_map
C version of radar_tape_map for rvp8 data recordede from the giv and, someday, the p3s.

C Modified 24 April 2007 to check that wind maxima do not
C hevw radical changes... ti try to catch cases when flt level data
C are briefly out to lunch. There is probably no way to deal with
C every possible f***up in real time but I think this code will 
C catch most cases. IMHO
C Version to run from tapes or from HRD airborne workstation
C read in rams file and estomate center, to test 
C stuff to then be applied to radar tapes or disc files
C I have included logic to deal with cases where legs azimuths are less than
C 90 deg as ,ight happen in NESDIS flights, so we can still define
C legs for partial Doppler analyses.
C Of course I could switch task order, find center first, then legs
C but I like the idea of limiting search within RMW.
C center finder could be improved if pressure or D values were available,
C ala Rahn/Willoughby

	character*36 directory
	integer lu, lu_errors

	character*80 ps_file
      character cmd*1
	character create_time*32
	character yesno*1, cstr*60
C
	character time_string*4, out_fn*80
	character*2 tape_string
C Radar tape/file stuff
	include "hrd_radar_common_blocks.f"

	character*80 radar_fn
      REAL SECONDS,time_start,time_end,TIME1,TIME2,
     +     AZMCOR,ELCOR,PCOR,RCOR,DCOR
	logical found_tail, want_port
 	integer*4 maxpts, badz
	integer*4 taplu, irdwr, tape, outlu, ierr, method
	character*32 time_stamp ! for writing out current time
	logical exist
C Arrays
	parameter ( max_smpl = 7200) ! 2 h worth of 1 sec data
	real ws_s(max_smpl), wd_s(max_smpl), time_s(max_smpl)
	real rlat_s(max_smpl), rlon_s(max_smpl), track_s(max_smpl)
C
	pi = acos(-1.0)
	pi180 = pi / 180. 
C
C Then will find radial legs at most this long:
	radial_leg_length = 90.0
C
C get tape, and  output file
C  From Nancy Griffin's documentation
C	openradarfile(nameradarfile,lut,lup,ierr)
C     nameradarfile(character) - name of disc file to be opened.
C    lut(integer) - logical unit number of disc file, for the open statement.
C     lup(integer) - lu for messages, either 1 or 6.
C     ierr(integer) - lu for error messages.
C
C	radardiscread(LUT,KINDRADAR,IHEADERFLAG,IDATAFLAG, IERR)
C	radardiscrewind(lut)
C 2) You may search for times and sweeps with:
C     discsearch(lut,kindradar,iop,rkey,ierr)
C      This subroutine reads the SIGMET format data and searches for a
C     specified sweep number or a specified time.  It positions the disc at
C     the beginning he specified sweep number or the specified time.
C     lut - disc logical unit number, from open    (integer)
	kindradar = 2

cout	call getarg(1, radar_fn)
cout	if(radar_fn .eq. ' ')then
cout	  write(6,*)' Radar disc file: '
cout	  read(5,'(a)')radar_fn
cout	end if
cout	call getarg(1, tape_string)
cout	if(tape_string .eq. ' ')then
cout	  write(6,*)' Enter tape drive: '
cout	  read(5,*)taplu
cout	else
cout	  read(tape_string,'(i2)')taplu
cout	end if
Cout	tape = 20

	lu = 10
	iout_lu = 21

	write(6,*)'enter sweep directry'
	read(5,'(a)')directory
	call open_rvp8_file(directory, lu, lu_errors, ierr)

cout	call openradarfile(radar_fn, tape,1,ierr)
cout	call tapeopen(taplu, irdwr, tape)
C	CALL RADARTAPEREWIND(tape)
C	call tapecontrol(tape, 2,1) ! backspace one file
	IHEADERFLAG=0 !DON'T WANT BIG HEADER INFO
	IDATAFLAG = 6   ! DBZ ARRAY (BIT 2= ON), vel array bit1 = on.
C
C
	write(iout_lu,*)'Radial leg lengths: ',radial_leg_length

	call getarg(2,time_string)
	if(time_string .eq. ' ') then
	  write(6,*)' Enter start time (hhmm) '
	  read(5,'(2i2)')ihs,ims
	else
	  read(time_string(1:4), '(2i2)')ihs,ims
	end if
	call getarg(3, time_string)
	if(time_string .eq. ' ') then
	  write(6,*)' Enter end time (hhmm) '
	  read(5,'(2i2)')ihe,ime
	else
	  read(time_string(1:4), '(2i2)')ihe, ime
	end if
	iss = 0
	ise = 0
	call getarg(4, out_fn)
	if(out_fn .eq. ' ') then
		out_fn = 'radar_legs_estimate.txt'
	end if
	open(iout_lu, file=out_fn,form='formatted')
	write(iout_lu,"('Searched ',3i2.2,1x,3i2.2)")ihs,ims,iss,i
     +     he,ime,ise
	time_start = 3600.0 * ihs + 60.0 * ims + iss
	time_end = 3600.0 * ihe + 60.0 * ime + ise
	if (time_end .lt. time_start) time_end = time_end + 24.0 *3600.0
C
C space to start time:
	iswp1 = -1
	time = -1.0
	iop = 2 ! 1-> search by sweep number, 2-> search by time
	rkey = time_start
	call rvp8_search(lu,kindradar,iop,rkey,ierr)
c

cout	call discsearch(tape, kindradar,iop,time_start,ierr)
cout	call tapesearch(tape, kindradar,iop,time_start,ierr)
C Now load temp array between time_start and time_end so we dont have to keep reading
C Radar tape or discfile
	is_iprev = -1
	n_smpl = 0
	do while( time .lt. time_end)
	  call radar_rvp8_read(lu,KINDRADAR,IHEADERFLAG,
     +		IDATAFLAG, IERR)


cout	  CALL RADARdiscREAD(tape,KINDRADAR,IHEADERFLAG,
cout     +			IDATAFLAG,IERR)
cout	  CALL RADARTAPEREAD(tape,KINDRADAR,IHEADERFLAG,
cout     +			IDATAFLAG,IERR)
	  if(ierr .lt. 0) then
	   if( ierr .gt. -2 ) then
		write(6,*) ' taperead error ',ierr,' will try next.'
	   else
		write(6,*)ierr, ' eot.'
		go to 900
	   end if
	  end if
	  if(is .ne. is_prev) then ! save sample
		n_smpl = n_smpl + 1
		if(n_smpl .gt. max_smpl) then
			n_smpl = max_smpl
			go to 900 ! break out
		end if
		is_prev = is
		ws_s(n_smpl) = ws
		wd_s(n_smpl) = wd
		time_s(n_smpl) = time
		rlat_s(n_smpl) = rlat
		rlon_s(n_smpl) = rlon
		track_s(n_smpl) = heading + drift
	  end if
	end do
900	write(iout_lu,*)' Sampling ',n_smpl,' points'
c only need this if code ckanged to di more than ine map per call
Cout	call radardiscrewind(tape)
C 
C
	dt= 1.0
C
C plot
        width = 200.0
        height = 200.0
cout	write(6,*)'enter plot center lat and lon'
cout	read(5,*)ctr_lat, ctr_lon
	imiddle = n_smpl / 2
	ctr_lat = rlat_s(imiddle)
	ctr_lon = rlon_s(imiddle)
	write(6,*)'plot center: ', ctr_lat, ctr_lon
	write(6,*)'enter width in km'
	read(5, *)width
	height = width
        ps_file = 'rvp8_track_map.ps'
	call fltlvl_only_map_sub(ctr_lat, ctr_lon, 
     +	  width, height, n_smpl,
     +    time_s, wd_s, ws_s, rlat_s, rlon_s, 
     +    ps_file)
C chec for jumps and bad winds
	prev_lat = rlat_s(1)
	PREV_LON = RLON_S(1)
	prev_wd = wd_s(1)
	prev_ws = ws_s(1)
	dlat_max = 0.01
	dlon_max = dlat_max
	dwd_max = 5
	dws_max = 5
444	format(a7,1x,f8.2,1x,f8.2,1x,i4)
	do i = 2, n_smpl
	   dlat = abs(rlat_s(i)-prev_lat)
	   dlon = abs(rlon_s(i)-prev_lon)
	   dws = abs(ws_s(i) - prev_ws)

	   if(dlat .gt. dlat_max)then
		write(6,444)'bad lat',rlat_s(i),prev_lat,i
	   end if

	   if(dlon .gt. dlon_max)then
		write(6,444)'bad lon',rlon_s(i),prev_lon,i
	   end if

	   if(dws .gt. dws_max)then
		write(6,444)'bad  ws',ws_s(i),prev_ws,i
	   end if


	   prev_lat = rlat_s(i)
	   prev_lon = rlon_s(i)
	   prev_ws = ws_s(i)
	   prev_wd = wd_s(i)
	end do
1000      END 
