      SUBROUTINE SWEEPIN(SWEEP,SWEEPZ,MAX_RAYS,MAX_GATES,NUM_RAYS,
     + RDTAI2,
     + AZ_EL,ICALLSWEEPIN,NUMREC,VRRAD,UNFVEL,TMP1,TMP2,
     + NYQ,ILATERSWEEP,SWEEPSAVE,U,V,W,IMX,JMX,KMX,SX,SY,SZ,
     + OLAT,OLON,XZ,YZ,ZZ,IUSEWIND,EAZM,EEV,TMSWEEP,RRLAT,RRLON,RRA,
     + SMOTIONU0,SMOTIONV0,CENTIME0,PELEV,MAXI,ANGTEST,AZMSLOPE,IAZM,
     + IPLANE,IVARIATIONAL,IAFTFORE,ISIGMET,IREALTIME,ROLLTOL,NDO,
     + IDBZADD,IDBZMASK,G4P3RADMIN,ALLOWEDDIFF,GROUNDADJUST,IATTEN,
     + RADRAT,RADMASK,IAPPLYMASK,IUNDERONLY,JTRAKAZMMIN,JTRAKAZMMAX)
C 
C     Doppler/Reflectivity processing program. 
C     This program reads the radar tapes and writes rays of Doppler data on
C     disc.  The file contains time in seconds, radar altitude in meters, 
C     latitude and longitude in degrees, earth relative azimuths in degrees,
C     earth relative elevation in degrees and 256 doppler velocities at 300
C     meter intervals.  The data is written to disc and then transfer via 
C     ftp to NCEP.
C 
C     To use: ncepwrite_file ncepwrite_file.job
C     ncepwrite_file.job - data file containing input information. 
C 
C  Subroutines use: 
C     READTAPE - Reads merged tapes and returns 1 record.
C 
C  Logical units: 
C     unit(1) - user's terminal 
C     unit(LUNR) - tape drive LU #
C     unit(LP) - line printer LU #. (6/7 dot-matrix printer)
C  Variables in Common Block and Main Program:
C     NIX - Flag for end-of-file/end-of-tape.(NIX=-100).
C     NGATE1 - Gate number to start mapping the data, for negative range del.
C     IFLT/INM - Flight date/ project name.
C     STIME/ETIME - Starting/Ending times of disc file in seconds.
C     WD/WS - Wind direction(deg) and Wind Speed (m/s).
C     IVT - flag to calculate  and subtract the terminal velocity (y/n).
C     RAMFL - flag to open and read the ram data with the GPS information.
C     XR,YR,ZR - east-west,north-south,and vertical distances of radar gate
C      from the radar
C 
      COMMON /AREA1/ INM,IFLT,STIME,ETIME,WD,WS,NIX,NGATE1,LP,LUNR,
     +               IVT,RAMFL
      include "hrd_radar_common_blocks_johns.f"
c      include "flag_common_block.f"
      COMMON /PARAMS/ trakazm,trakelev,driftnew,
     +                rot,track,htbb,dbb,thresh,swthresh,dbzrs,ibst(2),
     +                inob(2),ileg,xniq,irsw,maxnbins,v0,
     +                pcor,dcor,rcor,azmcor,elcor,dbzcor,dbzslope,
     +                iunfoldflag,iattenflag,
     +                badstabflag,surfelimflag,echoflag,atmflag
      common /tsearch/ kountrec,firstsweep(2),keylf(1024,2),
     +                 keyta(4096,2),
     +                 numsweep(2),itimex(2),lastpoint(2),
     +                 iheadertime,ioldsweep(2),kwords,nwords,krays,
     +                 ibuf(2048)
      LOGICAL badstabflag, surfelimflag, echoflag, atmflag
      LOGICAL ALTITUDERINGEXISTS,IBSTFILEEXISTS,ZRDIFFMAXEXISTS
      LOGICAL CHANGEMELTBANDEXISTS
      CHARACTER ALTRINGREMOVE*1
      LOGICAL G4NUMBEREXISTS,SQIEXISTS,VTADDEXISTS,USEHTMELTEXISTS
      LOGICAL DESPECKLEEXISTS
      CHARACTER*4 SWEEPTYPE
      CHARACTER*1 DESPECKLEYESNO,USEMELTYES
      DOUBLE PRECISION DOUBLETM,DOUBLETMJUL
      INTEGER ICOL(MAX_HRD_DIM,800),JCOL(MAX_HRD_DIM,800)
C      REAL TIMEONE,RLATONE,RLONONE,RAONE,AZMONE,EVONE
      REAL BINONE(MAX_HRD_DIM),REFONE(MAX_HRD_DIM)
      REAL BINOUT(MAX_HRD_DIM),RDTAONE(MAX_HRD_DIM)
      INTEGER ITAGSECOND(MAX_HRD_DIM,800)
      REAL RDVWS(800)
      REAL SWEEPVT(MAX_HRD_DIM,800)
      REAL SWEEPZVT(MAX_HRD_DIM,800)
      INTEGER ISWEEPVT(MAX_HRD_DIM,800),RADIIATTEN(MAX_HRD_DIM)
      INTEGER FASTON
      INTEGER IAZM(MAX_RAYS)
      REAL AVGDBZ1(610,360),AVGDBZ2(610,360),AVGDBZ3(610,360)
      REAL FILTMASKJ(5)
      INTEGER OLDTIME,IITEST(9),JJTEST(9),IKEEP(MAX_HRD_DIM,MAX_RAYS)
      REAL UNFVEL(MAX_GATES,MAX_RAYS)
      REAL TMP1(MAX_GATES,MAX_RAYS),TMP2(MAX_GATES,MAX_RAYS)
      INTEGER JINDEX(MAX_GATES,MAX_RAYS),JIINDEX(MAX_GATES,MAX_RAYS)
      REAL SWEEP(MAX_GATES,MAX_RAYS),RDTAI(MAX_GATES),AZ_EL(2,MAX_RAYS)
      REAL RDTAI2(MAX_GATES)
      REAL AZEL(2,800),TMSWEEP2(800)
      REAL PAZM(800)
      REAL PELEV(MAX_RAYS),RDTAIIN(MAX_HRD_DIM)
      REAL SWEEPSAVE(MAX_GATES,MAX_RAYS)
      REAL PCORS(2),DCORS(2),RCORS(2)
      REAL AZMCORS(2),RDELCORTAS(2),ELCORS(2)
      REAL RAY(MAX_HRD_DIM),URAY(MAX_HRD_DIM),V0SAVE(800)
      REAL VRRAD(MAX_GATES,MAX_RAYS),NYQ(MAX_GATES,MAX_RAYS)
      REAL VROUT(MAX_HRD_DIM,800),ZOUT(MAX_HRD_DIM,800)
      INTEGER ISWEEP(MAX_HRD_DIM,800)
      REAL XRSWEEP(MAX_HRD_DIM,800),YRSWEEP(MAX_HRD_DIM,800)
      REAL ZRSWEEP(MAX_HRD_DIM,800)
      REAL RADSWEEP(MAX_HRD_DIM,800)
      REAL XRMIN(MAX_HRD_DIM,800),YRMIN(MAX_HRD_DIM,800)
      REAL ZRMIN(MAX_HRD_DIM,800)
      REAL XRMAX(MAX_HRD_DIM,800),YRMAX(MAX_HRD_DIM,800)
      REAL ZRMAX(MAX_HRD_DIM,800)
      REAL AZMIN(MAX_HRD_DIM,800),AZMAX(MAX_HRD_DIM,800)
      REAL SWEEPZ(MAX_GATES,MAX_RAYS),ZDIFF(MAX_HRD_DIM,800)
c      REAL ZMIN(MAX_HRD_DIM,MAX_RAYS),ZMAX(MAX_HRD_DIM,MAX_RAYS)
      REAL XR(MAX_HRD_DIM),YR(MAX_HRD_DIM),ZR(MAX_HRD_DIM)
      REAL U(IMX,JMX,KMX),V(IMX,JMX,KMX),W(IMX,JMX,KMX)
      REAL EAZM(MAX_RAYS),EEV(MAX_RAYS),RRLAT(MAX_RAYS)
      REAL RRLON(MAX_RAYS),RRA(MAX_RAYS)
      REAL TRACKSTORE(800),HEADSTORE(800)
      REAL TMSWEEP(MAX_RAYS)
      INTEGER ISEG(MAX_HRD_DIM,800),ISEGB(MAX_HRD_DIM,800)
      INTEGER ISEGE(MAX_HRD_DIM,800)
      CHARACTER*1 CAIRCRAFT(3),CCHECK
      CHARACTER CDUMMY*80
      CHARACTER DUMMYREAD*1
      CHARACTER IFLT*8, INM*12
      CHARACTER *1 TAPE, RAMFL, IVT, IATTEN
      CHARACTER *80 NAMERAM, IFILE, NAMEO
      CHARACTER*80 RADARFILE
      CHARACTER*8 IFLTCHK,IFLTCHK2
      CHARACTER CHARDATE*8,CHARTIME*10,CHARZONE*5
      INTEGER TIMEVALUES(8)
      DIMENSION BIN(MAX_HRD_DIM),REF(MAX_HRD_DIM)
      DIMENSION BIN1(MAX_HRD_DIM),REF1(MAX_HRD_DIM)
c      SAVE RATESTOLD,RATEST
c      SAVE ISWEEPCHECK,BINONE,REFONE,TIMEONE,RLATONE,RLONONE
c      SAVE RAONE,AZMONE,EVONE,RCAZM,AZELONE,AZELTWO,PELEVONE
c      SAVE ICONSERVE,ITAPEOPEN,RDTAIIN,RADTEST,RADTEST2
c      SAVE V0ONE,PAZMONE,IFRANCE
c      SAVE PCORS,DCORS,RCORS,RDELCORTAS,AZMCORS,ELCORS
c      SAVE TIME,TIMES,WFLAG
c      SAVE IHS,IMS,ISS,IHE,IME,ISE,IADD86400
c      SAVE IFASTCHECK,RDVWS,RDVWSONE,IFLIGHTCHECK
c      SAVE AZIIN,AZIOUT,NBINSMAXSAVE
c      SAVE IYEARTAPE,MONTHTAPE,IDAYTAPE
      SAVE
      DATA AT1/5.33E-5/, AT2/0.889/
      write(6,*)'rolltol = ',rolltol
      write(6,*)'entered sweepread'
      write(6,*)'IDBZADD,IDBZMASK = ',IDBZADD,IDBZMASK
      WRITE(6,*)'ALLOWEDDIFF = ',ALLOWEDDIFF
      WRITE(6,*)'IAPPLYMASK = ',IAPPLYMASK
      WRITE(6,*)'RADRAT,RADMASK = ',RADRAT,RADMASK
c      pause
 4275 DBZRADIUSMIN=100.
      INQUIRE(FILE='altitude_ring_remove',EXIST=ALTITUDERINGEXISTS)
      WRITE(6,*)'JTRAKAZMMIN,JTRAKAZMMAX = ',JTRAKAZMMIN,JTRAKAZMMAX
      IBLANKSWEEP=0
      IMAXBINS=MAX_HRD_DIM
      JMAXRAYS=MAX_RAYS
      SXBIG=SX
      CAIRCRAFT(1)='H'
      CAIRCRAFT(2)='I'
      CAIRCRAFT(3)='N'
      DO J=1,800
         DO I=1,MAX_HRD_DIM
            ITAGSECOND(I,J)=0
         ENDDO
      ENDDO
      IF(ABS(XZ).GE.ABS(YZ))THEN
       RADMAX=ABS(XZ)
      ELSE
       RADMAX=ABS(YZ)
      ENDIF
      WRITE(6,*)'IN SWEEPIN AND G4P3RADMIN = ',G4P3RADMIN
c      PAUSE
c      WRITE(6,*)'ENTERING SWEEPREAD AND IUSEWIND = ',IUSEWIND
c      PAUSE
c      WRITE(6,*)RADMAX
c      PAUSE      
c      DO K=1,KMX
c       DO J=1,JMX
c        WRITE(6,*)'J,K,U = ',J,K,(U(I,J,K),I=1,IMX)
c       ENDDO
c      ENDDO
c      PAUSE
      IF(SY.GT.SXBIG)SXBIG=SY
      IF(ICALLSWEEPIN.EQ.0)THEN
         IF(ALTITUDERINGEXISTS)THEN
            OPEN(88,FILE='altitude_ring_remove')
            READ(88,'(A1)')ALTRINGREMOVE
            IF(ALTRINGREMOVE.EQ.'Y'.OR.ALTRINGREMOVE.EQ.'y')THEN
               IALTRINGREMOVE=1
            ELSE
               IALTRINGREMOVE=0
            ENDIF
            CLOSE(88)
         ELSE
            IALTRINGREMOVE=0
         ENDIF
         IF(IALTRINGREMOVE.NE.1)THEN
            WRITE(6,*)'ALTITUDE RING NOT REMOVED'
         ELSE
            WRITE(6,*)'ALTITUDE RING REMOVED'
         ENDIF
         INQUIRE(FILE='maskzrdiffmax',EXIST=ZRDIFFMAXEXISTS)
         IF(ZRDIFFMAXEXISTS)THEN
            OPEN(88,FILE='maskzrdiffmax')
            READ(88,*)ZRDIFFMAX
            READ(88,*)ZSPECKLEMAX
            CLOSE(88)
            WRITE(6,'(A,F7.2)')'ZRDIFFMAX WAS READ AND IS',ZRDIFFMAX
         ELSE
            ZRDIFFMAX=100.
            ZSPECKLEMAX=100.
            WRITE(6,'(A,F7.2)')'ZRDIFFMAX WAS NOT READ AND IS',ZRDIFFMAX
         ENDIF
       IWRITETEST=0
       N1SUMV0=0
       SUM1V0=0
       SUM1V02=0
       N2SUMV0=0
       SUM2V0=0
       SUM2V02=0
       IBINAVG=8
       RATEST=13.
       IFASTCHECK=0
       IFILECHECK=0
       RADTEST=-1.
       RADTEST2=-1.
       IFRANCE=0
       IFLIGHTCHECK=0
C       IF(IAFTFORE.EQ.1)THEN
C       OPEN(95,FILE='inoutradazi_aft.txt')
C       ELSEIF(IAFTFORE.EQ.2)THEN
C       OPEN(95,FILE='inoutradazi_fore.txt')
C       ELSE
C       OPEN(95,FILE='inoutradazi_aft.txt')
C       ENDIF
      ELSE
       IFILECHECK=1
       IFLIGHTCHECK=1
       CALL CTME1(TIME,IIHH,IIMM,IISS)
c       WRITE(6,*)'SWEEP END TIME IS '
c       WRITE(6,'(3I2)')IIHH,IIMM,IISS
c       CALL TESTTIMING
      ENDIF
      IF(IUSEWIND.EQ.1)THEN
       SMOTIONU=SMOTIONU0
       SMOTIONV=SMOTIONV0
       CENTIME=CENTIME0
      ELSE
       SMOTIONU=0.
       SMOTIONV=0.
       CENTIME=CENTIME0
      ENDIF
      DO I=1,800
       RDVWS(I)=-999.9
      ENDDO
      deg2rad = acos(-1.0) / 180.0
      rad2deg = 1.0 / deg2rad
      if(iplane.eq.2)then
       half_beam_ta = 1.35 ! degrees, vertical
      else
       half_beam_ta = 1.00
      endif
c      half_beam_lf = 2.05 ! degrees, vertical
      beam_wid = 2.0 * half_beam_ta
      WFLAG=-1.0E+10
C 
C DOPPLER processing program
c      write(6,*)'icallsweepin = ',icallsweepin
      ISWEEPSET=2
      SWEEPOLD=0.
      NUM_RAYS=0
      DO I=1,MAX_GATES
       DO J=1,MAX_RAYS
        SWEEP(I,J)=-888.8
        SWEEPZ(I,J)=-32.0
        SWEEPVT(I,J)=-888.8
        ZRSWEEP(I,J)=-888.8
       ENDDO
      ENDDO
c      write(6,*)'imx,jmx,kmx = ',imx,jmx,kmx
c      write(6,*)'sx,sy,sz = ',sx,sy,sz
c      write(6,*)'xz,yz,zz = ',xz,yz,zz
      k=4
c       do j=1,100
c        write(6,*)'u k,j = ',k,j
c        write(6,'(10f16.3)')(u(i,j,k),i=1,imx)
c       enddo
c      enddo
      NBINSMAX=0
      IF(ICALLSWEEPIN.EQ.0)THEN
       DO I=1,MAX_HRD_DIM
        RDTAIIN(I)=1000.
       ENDDO
      ENDIF
      IF(ICALLSWEEPIN.EQ.1)THEN
       NUM_RAYS=0
c       IF(IYEARTAPE.GE.2017.AND.IPLANE.EQ.1)THEN
c       ENDIF
      ENDIF
      IF(ICALLSWEEPIN.EQ.0)THEN
       SWEEPTYPE='FORE'
       ISWEEPSET=0
c       OPEN(1,FILE='/dev/tty')
       IF(IUSEWIND.NE.1)THEN
c        WRITE(6,*)'be conservative on first pass y(1)/n(0)'
c        READ(5,*)ICONSERVE
        ICONSERVE=1
       ELSE
        ICONSERVE=0
       ENDIF
       ICONSERVE=0
c       WRITE(6,*)'Enter job file name'
c       READ(5,'(A80)')IFILE
       IFILE='jobfile_radar'
       OPEN(84,FILE=IFILE,IOSTAT=IERR,ERR=998,STATUS='OLD')
C The Following Parameters are read from input file  - ncepwrite_file.job
C Read Flight ID and Storm Name
      READ(84,'(A8)')IFLT
      READ(IFLT,'(I2)')IYEAR
      IF(IYEAR.LT.50)THEN
         IYEARTAPE=IYEAR+2000
      ELSE
         IYEARTAPE=IYEAR+1900
      ENDIF
      READ(84,'(A12)')INM
      DO JIJ=1,7
       READ(84,'(A1)')DUMMYREAD
      ENDDO
C      READ(84,'(A8,1X,A12)',IOSTAT=IERR,ERR=999) IFLT,INM
C Read Line Printer LU#, Tape LU# & flag for printing parameters
       LP=6
       READ(84,*)LUNRT
C       READ(84,'(I2,1X,I2)',IOSTAT=IERR,ERR=999) LP,LUNRT
C1       READ(84,*)ITAPEOPEN
C       IF(LUNRT.GT.6)THEN
C        WRITE(6,*)'YOU ARE USING TAPE DRIVE ',LUNRT
C        WRITE(6,*)'IF CORRECT ENTER 1, OTHERWISE 0'
C        READ(5,*)ILUNRT
C        IF(ILUNRT.NE.1)THEN
C         WRITE(6,*)'REENTER TAPE DRIVE UNIT NUMBER'
C         WRITE(6,*)'IF YOU MEANT TO USE A FILE ENTER 0'
C         READ(5,*)LUNRT
C        ENDIF
C       ELSE
C        WRITE(6,*)'YOU WILL BE READING FROM A RADAR FILE'
C       ENDIF
C       READ(84,'(A80)')RADARFILE
       RADARFILE='DUMMY'
       IF(LUNRT.GT.6)THEN
        ITAPEOPEN=1
       ELSE
        ITAPEOPEN=0
       ENDIF
c       IF(ITAPEOPEN.EQ.1)THEN
c        CALL TAPEOPEN(LUNRT,0,LUNR)
c        CALL TAPECONTROL(LUNR,2,1) !back up 1 file
c       ELSE
c        OPEN(80,FILE=RADARFILE,FORM='UNFORMATTED',RECL=2,
c     1       ACCESS='DIRECT')
c       ENDIF
       WRITE(LP,'(1X,"NCEP program to write doppler on disc: ",A)')
     +      IFILE
       WRITE(LP,'(2X,"Date:",1X,A8,2X,"Name: ",A12,/,
     +        2X,"Line-Printer:",1X,I2,2X,"Tape-LU#:",I2)')
     + IFLT,INM,LP,LUNRT
C Read Ram File Flag{Y/N} and the Ram File Name 
C       READ(84,'(A1,1X,A80)',IOSTAT=IERR,ERR=999) RAMFL,NAMERAM 
C       IF(RAMFL.EQ.'y')RAMFL='Y'
C       IF(RAMFL.EQ.'n')RAMFL='N'
       RAMFL='N'
C      CALL CASEFOLD(RAMFL)
C Open the Ram File 
       IF (RAMFL .EQ. 'Y') THEN
c          CALL OPENRAMFILE(NAMERAM,LP,STIMERAM,ETIMERAM,DATARATE,IERR)
          IF (IERR .NE. 0) GO TO 1050
          WRITE(LP,'(2X,"RAMFL= ",A1,1X,A80)') RAMFL,NAMERAM
       ENDIF 
C Read Unfolding Flag{Y/N},first guess wind and speed
C       READ(84,*,IOSTAT=IERR,ERR=999) IUNFOLDFLAG,WD,WS
C       INFOLDFLAG=1
       WD=0.
       WS=1.
       iunfoldflag=0
       WRITE(LP,'(2X,"IUNFOLDFLAG= ",I1," WD= ",F6.1," WS= ",F6.1)')
     +      IUNFOLDFLAG,WD,WS
C Read the starting bin and the number of bins for averaging
       READ(84,*,IOSTAT=IERR,ERR=999) IBST(1),INOB(1) 
       INQUIRE(FILE='ibstfile',EXIST=IBSTFILEEXISTS)
       IF(IBSTFILEEXISTS)THEN
        WRITE(6,*)'Substituting IBST(1) and INOB(1) from backdoor file'
          OPEN(92,FILE='ibstfile')
          READ(92,*)IBST(1),INOB(1)
          CLOSE(92)
       ENDIF
       WRITE(LP,'(2X,"IBST= ",I4," INOB= ",I4)') IBST(1),INOB(1)
C Enter AZM, Elevation & rdel corrs.
       READ (84,*,IOSTAT=IERR,ERR=999) AZMCORS(1),ELCORS(1),
     +                                  RDELCORTAS(1)
       WRITE(LP,'(2X,"TA AZMCOR=",F6.2,2X,"ELCOR= ",F6.2,
     +      2X,"RDELCORTA= ",F6.2)') AZMCORS(1),ELCORS(1),
     +                               RDELCORTAS(1)
       RDELCORTA=RDELCORTAS(1)
C Enter Pitch, drift and roll corrections:
       READ (84,*,IOSTAT=IERR,ERR=999) PCORS(1),DCORS(1),RCORS(1)
       WRITE(LP,'(2X,"TA PCOR= ",F5.1,2X,"DCOR= ",F5.1,
     +      2X,"RCOR= ",F5.1)') PCORS(1),DCORS(1),RCORS(1)
C Enter AZM, Elevation & rdel corrs.
       READ (84,*,IOSTAT=IERR,ERR=999) AZMCORS(2),ELCORS(2),
     +                                  RDELCORTAS(2)
       WRITE(LP,'(2X,"TF AZMCOR=",F6.2,2X,"ELCOR= ",F6.2,
     +      2X,"RDELCORTA= ",F6.2)') AZMCORS(2),ELCORS(2),
     +                               RDELCORTAS(2)
C Enter Pitch, drift and roll corrections:
       READ (84,*,IOSTAT=IERR,ERR=999) PCORS(2),DCORS(2),RCORS(2)
       WRITE(LP,'(2X,"TF PCOR= ",F5.1,2X,"DCOR= ",F5.1,
     +      2X,"RCOR= ",F5.1)') PCORS(2),DCORS(2),RCORS(2)
C Read threshold value
       READ (84,*,IOSTAT=IERR,ERR=999) THRESH,DBZRS,DBZCOR,DBZSLOPE
       WRITE(LP,'(2X,"NOISE VALUE= ",F5.1,2X,"DBZRS= ",F5.1,
     +          "DBZSLOPE= ",F5.1,2X,"DBZCOR= ",F5.1)')
     +       THRESH,DBZRS,DBZSLOPE,DBZCOR
C Read spectral width threshold value
       READ (84,*,IOSTAT=IERR,ERR=999) swthresh
       IF (SWTHRESH.LE.0.0 .OR. SWTHRESH.GT.16.0) SWTHRESH=99.0
       INQUIRE(FILE='changesqi',EXIST=SQIEXISTS)
       IF(SQIEXISTS)THEN
         OPEN(88,FILE='changesqi')
         READ(88,*)SWTHRESH
         CLOSE(88)
       ENDIF
       SWPASS=SWTHRESH
       SWTHRESH=99.
       WRITE(LP,'(2X,"SPECTRAL WIDTH THRESHOLD= ",F5.1)') swthresh
C Read Flag for adding the Terminal Velocity Corr. Value, the height &
C depth of the bright band, P. Willis or Joss VT.
       IVT='N'
       HTBB=5.5
       DBB=2.
       HTBBPT=HTBB
       DBBPT=DBB
       IRSW=0
C       READ (84,*,IOSTAT=IERR,ERR=999) IVT,HTBB,DBB,IRSW
       IF(IVT.EQ.'n')IVT='N'
       IF(IVT.EQ.'y')IVT='Y'
C      CALL CASEFOLD(IVT)
       WRITE(LP,'(2X,''VT= '',A1," HTBB= ",F6.2," DBB= ",F6.2, 
     +           " IRSW= ",I1)') 
     +      IVT,HTBB,DBB,IRSW
      IF (IVT .EQ. 'N') HTBB= -99.0
C Read flag to add the intervening attenuation
C      IATTEN='N'
C       READ (84,*,IOSTAT=IERR,ERR=999) IATTEN
       CALL MAKEATTENTABLE1(2)
       IF(IATTEN.EQ.'y')IATTEN='Y'
       IF(IATTEN.EQ.'n')IATTEN='N'
C      CALL CASEFOLD(IATTEN) 
       IF (IATTEN .EQ. 'Y') THEN 
C compute attenuation table if flag is on 
          WRITE(LP,'(1X,"Intervening attenuation: A=",E10.2, 
     +   "*Z**",F4.2)') AT1,AT2
          IATTENFLAG = 1
       ELSE
          IATTENFLAG = 0
       ENDIF   
C Read Start Time and End Time
       READ(84,'(3I2,1X,3I2)',IOSTAT=IERR,ERR=999)
     +     IHS,IMS,ISS,IHE,IME,ISE
       WRITE(LP,'(2X,"Start Time:",3I2.2,2X,"End Time:",3I2.2)')
     +IHS,IMS,ISS,IHE,IME,ISE
C Read a second tape:
       TAPE='N'
C       READ(84,'(A1)',IOSTAT=IERR,ERR=999) TAPE
       IF(TAPE.EQ.'y')TAPE='Y'
       IF(TAPE.EQ.'n')TAPE='N'
C      CALL CASEFOLD(TAPE)
C 
C Read Disk File Name 
C       READ(84,'(A)',IOSTAT=IERR,ERR=999) NAMEO
      READ(84,*)DUMMY
c      READ(84,*)DUMMY1,DUMMY2
c      READ(84,*)DUMMY1,DUMMY2
      READ(84,*)HTBB,DBB
      INQUIRE(FILE='changemeltingband',EXIST=CHANGEMELTBANDEXISTS)
      IF(CHANGEMELTBANDEXISTS)THEN
         OPEN(88,FILE='changemeltingband')
         READ(88,*)HTBB,DBB
         CLOSE(88)
      ENDIF
      WRITE(6,'("MELTING BAND HEIGHT THICKNESS ARE",2F8.2)')HTBB,DBB
      READ(84,*)ZLOW,ZHIGH
       HTBBPT=HTBB
       DBBPT=DBB
       IRSW=0
c      ZLOW=99.
c      ZHIGH=100.
      READ(84,'(A80)')CDUMMY
      READ(84,*)AZIIN,AZIOUT
      READ(84,'(A80)')RADARFILE
      IF(LUNRT.GT.6)THEN
       ITAPEOPEN=1
      ELSE
       ITAPEOPEN=0
C       WRITE(6,*)'Enter name of radar file'
C       READ(84,'(A80)')RADARFILE
      ENDIF
      READ(84,*)IFRANCENO
      IF(IFRANCENO.EQ.3)THEN
       IFRANCE=2
      ELSE
       IFRANCE=IFRANCENO
      ENDIF
      INQUIRE(FILE='useg4number',EXIST=G4NUMBEREXISTS)
      IF(G4NUMBEREXISTS)THEN
         OPEN(88,FILE='useg4number')
         READ(88,*)IFRANCEINPUT
         IF(IFRANCEINPUT.EQ.2)THEN
            IFRANCENO=2
         ENDIF
      ENDIF
      INQUIRE(FILE='usehtmelt',EXIST=USEHTMELTEXISTS)
      IF(USEHTMELTEXISTS)THEN
         OPEN(55,FILE='usehtmelt')
         READ(55,'(A1)')USEMELTYES
         IF(USEMELTYES.EQ.'Y'.OR.USEMELTYES.EQ.'y')THEN
            IUSEMELT=1
         ELSE
            IUSEMELT=0
         ENDIF
      ELSE
         IUSEMELT=0
      ENDIF
      INQUIRE(FILE='despeckleyesno',EXIST=DESPECKLEEXISTS)
      IF(DESPECKLEEXISTS)THEN
         OPEN(37,FILE='despeckleyesno')
         READ(37,'(A1)')DESPECKLEYESNO
         IF(DESPECKLEYESNO.EQ.'0'.OR.DESPECKLEYESNO.EQ.'N'.OR.
     +      DESPECKLEYESNO.EQ.'n')THEN
            IDESPECKLE=0
            IOLDDESPECKLE=0
         ELSEIF(DESPECKLEYESNO.EQ.'O'.OR.DESPECKLEYESNO.EQ.'o')THEN
            READ(37,*)NUMTIMES
            READ(37,*)NUMCONTIG
            IOLDDESPECKLE=1
            IDESPECKLE=1
         ELSE
            READ(37,*)NUMTIMES
            READ(37,*)NUMCONTIG
            IOLDDESPECKLE=0
            IDESPECKLE=1
         ENDIF
         CLOSE(37)
      ELSE
         IDESPECKLE=1
         NUMTIMES=3
         NUMCONTIG=3
         IOLDDESPECKLE=1
      ENDIF
      WRITE(6,*)'IFRANCE = ',IFRANCENO
      READ(84,*)IATCFNO
      WRITE(6,*)'IATCFNO = ',IATCFNO
      IF(ITAPEOPEN.EQ.1)THEN
       CALL TAPEOPEN(LUNRT,0,LUNR)
       CALL TAPECONTROL(LUNR,2,1) !back up 1 file
      ELSE
       LUNR=80
       IF(ISIGMET.NE.5)THEN
        WRITE(6,*)'OPENING RADAR DIRECTORY'
c       PAUSE
c       OPEN(LUNR,FILE='sweeps_list',form='formatted',iostat=ierropen)
        LUNRNC=LUNR
        CALL substitute_open_rvp8_file(RADARFILE,LUNRNC,1,IERROPEN)
C Use the following two lines when GPS data are not available in sweep files
c        nav_choice=1
c        alt_choice=3
        LUNR=LUNRNC
        WRITE(6,*)'TIME = ',TIME
c       CALL open_rvp8_file(RADARFILE,LUNR,1,IERROPEN)
        WRITE(6,*)'OPENED RADAR DIRECTORY'
c       PAUSE
       ELSE
       LUNRNC=LUNR
       CALL OPENRADARFILE(RADARFILE,LUNRNC,1,IERROPEN)
       LUNR=LUNRNC
c        OPEN(80,FILE=RADARFILE,FORM='UNFORMATTED',RECL=2,
c     1       ACCESS='DIRECT')
       ENDIF
      ENDIF
      IF(ISIGMET.EQ.5)THEN
       READ(84,*,END=842)SWTHRESH
       GO TO 841
 842   SWTHRESH=6.25
       GO TO 1840
      ENDIF
      IF(ISIGMET.EQ.8)THEN
         READ(84,*,END=840)SWPASS2
         WRITE(6,*)'SWPASS2,WIDTHTHRESTA = ',SWPASS2,WIDTHTHRESTA
         GO TO 841
 840     IF(IPLANE.EQ.2.OR.IYEARTAPE.GE.2019)THEN
          SWPASS2=SWPASS
         ELSEIF(IPLANE.EQ.1.AND.IYEARTAPE.GE.2017)THEN
          SWPASS2=0.63
         ELSE
          SWPASS2=0.
         ENDIF
         GO TO 1840
      ENDIF
 841  READ(84,*,END=1840)AFTVNYQ
      GO TO 1842
 1840 AFTVNYQ=-888.8
 1842 CLOSE(84)
      IF(ISIGMET.EQ.5)THEN
       WRITE(6,*)'SWTHRESH = ',SWTHRESH
      ELSE
       WRITE(6,*)'SWPASS,SWPASS2,AFTVNYQ = ',SWPASS,SWPASS2,AFTVNYQ
       WRITE(6,*)'IYEARTAPE,IPLANE = ',IYEARTAPE,IPLANE
      ENDIF
      NAMEO='DUMMY'
      ENDIF
c      WRITE(LP,'(2X,"NCEP Output File Name:",A)') NAMEO
c      WRITE(LP,*)trakazm,trakelev,driftnew,
c     +         rot,track,htbb,dbb,thresh,swthresh,dbzrs,ibst(1),ibst(2),
c     +         inob(1),inob(2),ileg,xniq,irsw,maxnbins,v0,
c     +         pcor,dcor,rcor,azmcor,elcor,dbzcor,dbzslope,
c     +         iunfoldflag,iattenflag,
c     +         badstabflag,surfelimflag,echoflag,atmflag
C Open Disk File
      OPEN(83,FILE='editfile',IOSTAT=IERR,ERR=1000,STATUS='UNKNOWN',
     +     FORM='unformatted') 
      OPEN(82,FILE='editfile.txt')
      IF(IAFTFORE.EQ.1)THEN
       OPEN(86,FILE='passeditfile_aft',IOSTAT=IERR,ERR=1000,
     +     STATUS='UNKNOWN',FORM='unformatted') 
       OPEN(87,FILE='passeditfile_aft.txt')
       OPEN(85,FILE='realtimefile_aft.txt')
      ELSEIF(IAFTFORE.EQ.2)THEN
       OPEN(86,FILE='passeditfile_fore',IOSTAT=IERR,ERR=1000,
     +     STATUS='UNKNOWN',FORM='unformatted') 
       OPEN(87,FILE='passeditfile_fore.txt')
       OPEN(85,FILE='realtimefile_fore.txt')
      ELSE
       OPEN(86,FILE='passeditfile',IOSTAT=IERR,ERR=1000,
     +     STATUS='UNKNOWN',FORM='unformatted') 
       OPEN(87,FILE='passeditfile.txt')
       OPEN(85,FILE='realtimefile.txt')
      ENDIF
      IF(IUSEMELT.EQ.1)THEN
         OPEN(65,FILE='htmelt_1second.txt')
         READ(65,*)TIMEMELT,HTMELT,TKMELT
         I65CLOSE=0
      ENDIF
C 
      STIME=FLOAT(IHS)*3600.0 + FLOAT(IMS)*60.0 + FLOAT(ISS)
      ETIME=FLOAT(IHE)*3600.0 + FLOAT(IME)*60.0 + FLOAT(ISE)
C
C Search for the start time:
c971   write(6,*)'itapeopen,icallsweepin = ',itapeopen,icallsweepin
971   IF(ICALLSWEEPIN.EQ.0)THEN
97100  ROLDTIME=200000.
c97100  WRITE(6,*)'CALLING READTAPE'
       kwords=0
       nwords=-1
       TIME=STIME
       write(6,*)'calling rvp8_search first'
       WRITE(6,*)'STIME,ETIME,TIME = ',STIME,ETIME,TIME
       IF(ISIGMET.NE.5)THEN
        LUNRNC=LUNR
        STIMENC=STIME
        CALL RVP8_SEARCH(LUNRNC,2,2,STIMENC,IERR)
        LUNR=LUNRNC
        STIME=STIMENC
        write(6,*)'returned from rvp8_search first'
        WRITE(6,*)'TIME = ',TIME
       ELSE
        LUNRNC=LUNR
        STIMENC=STIME
        CALL DISCSEARCH(LUNRNC,2,2,STIME,IERR)
        LUNR=LUNRNC
        STIME=STIMENC
       ENDIF
       CALL READTAPE(TIME,RLAT,RLON,RA,AZM,EV,BIN,REF,BIN1,REF1,RCAZM,
     +  ITAPEOPEN,RADARFILE,NUMREC,PCORS,DCORS,RCORS,AZMCORS,
     +  RDELCORTAS,ELCORS,ISIGMET,NDO)
       WRITE(6,*)'TIME = ',TIME
c       PAUSE
       IF(IFLIGHTCHECK.EQ.0)THEN
        IF(ISIGMET.NE.5)iyear=iyear-2000
        if(iyear.lt.0)iyear=iyear+100
        write(6,*)'inair = ',inair
        write(6,6104)iyear,month,iday,caircraft(inair)
        write(IFLTCHK,6104)iyear,month,iday,caircraft(inair)
6104    FORMAT(3I2.2,A)
        read(IFLT,'(A7)')IFLTCHK2
        WRITE(6,'(A7)')IFLTCHK
        write(6,'(A7)')IFLTCHK2
        WRITE(6,*)'IFLT = ',IFLT
        READ(IFLT,'(3I2,A1)')IYEAR,MONTHTAPE,IDAYTAPE,CCHECK
        IYEARTAPE=IYEAR
        IF(CCHECK.EQ.'H')THEN
         NAIRCRAFT=42
        ELSEIF(CCHECK.EQ.'I')THEN
         NAIRCRAFT=43
        ELSEIF(CCHECK.EQ.'N')THEN
         NAIRCRAFT=49
        ENDIF
        IFLIGHTCHECK=1
        INAIR=1
        IF(NAIRCRAFT.EQ.42)THEN
         INAIR=1
        ELSEIF(NAIRCRAFT.EQ.43)THEN
         INAIR=2
        ELSEIF(NAIRCRAFT.EQ.49.OR.NAIRCRAFT.EQ.0)THEN
         INAIR=3
         NAIRCRAFT=49
        ELSE
         WRITE(6,*)'NAIRCRAFT = ',NAIRCRAFT
         WRITE(6,*)'NAIRCRAFT DOES NOET EQUAL 42 OR 43'
c         STOP
        ENDIF
        IF(IAFTFORE.EQ.1.AND.NAIRCRAFT.EQ.42)THEN
         OPEN(58,FILE='aft_42.mask')
         WRITE(6,*)'OPENED aft_42.mask'
        ELSEIF(IAFTFORE.EQ.2.AND.NAIRCRAFT.EQ.42)THEN
         OPEN(58,FILE='fore_42.mask')
         WRITE(6,*)'OPENED fore_42.mask'
        ELSEIF(IAFTFORE.EQ.1.AND.NAIRCRAFT.EQ.43)THEN
         OPEN(58,FILE='aft_43.mask')
         WRITE(6,*)'OPENED aft_43.mask'
        ELSEIF(IAFTFORE.EQ.2.AND.NAIRCRAFT.EQ.43)THEN
         OPEN(58,FILE='fore_43.mask')
         WRITE(6,*)'OPENED fore_43.mask'
        ELSEIF(IAFTFORE.EQ.1.AND.NAIRCRAFT.EQ.49)THEN
         OPEN(58,FILE='aft_49.mask')
         WRITE(6,*)'OPENED aft_49.mask'
        ELSEIF(IAFTFORE.EQ.2.AND.NAIRCRAFT.EQ.49)THEN
         OPEN(58,FILE='fore_49.mask')
         WRITE(6,*)'OPENED fore_49.mask'
        ENDIF
        IF(IAFTFORE.LE.2)THEN
           DO J=1,360
              READ(58,'(A)')CDUMMY
              READ(58,'(A)')CDUMMY
              READ(58,*)(AVGDBZ1(I,J),I=1,610)
              READ(58,'(A)')CDUMMY
              READ(58,*)(AVGDBZ2(I,J),I=1,610)
              DO I=66,610
                 AVGDBZ2(I,J)=-60.
              ENDDO
           ENDDO
           CLOSE(58)
        ELSE
           DO J=1,360
              DO I=1,610
                 AVGDBZ1(I,J)=-60.
                 AVGDBZ2(I,J)=-60.
              ENDDO
           ENDDO
        ENDIF
        IFILTMASK=0
        IF(IFILTMASK.EQ.1)THEN
         FILTMASKJ(1)=1.
         FILTMASKJ(2)=4.
         FILTMASKJ(3)=6.
         FILTMASKJ(4)=4.
         FILTMASKJ(5)=1.
         WRITE(6,*)'I GOT HERE'
         DO J=1,360
            DO I=1,610
               AVGDBZSUM=0.
               FAVGDBZSUM=0
               DO IJ=1,5
                  JJ=J+IJ-3
                  JJJ=JJ
                  IF(JJ.LT.1)JJJ=JJ+360
                  IF(JJ.GT.360)JJJ=JJ-360
                  IF(AVGDBZ1(I,JJJ).GT.-32.)THEN
                    AVGDBZSUM=AVGDBZSUM+AVGDBZ1(I,JJJ)*FILTMASKJ(IJ)
                    FAVGDBZSUM=FAVGDBZSUM+FILTMASKJ(IJ)
                  ENDIF
c                  WRITE(6,*)'I,J,IJ,JJ,JJJ = ',I,J,IJ,JJ,JJJ
c                  WRITE(6,*)'AVGDBZ1,AVGDBZSUM,FAVGDBZSUM,FILTMASKJ = ',
c     1                AVGDBZ1(I,JJJ),AVGDBZSUM,FAVGDBZSUM,FILTMASKJ(IJ)
               ENDDO
               IF(FAVGDBZSUM.GT.0.)THEN
                 AVGDBZ3(I,J)=AVGDBZSUM/FAVGDBZSUM
               ELSE
                 AVGDBZ3(I,J)=-999.9
               ENDIF
c               WRITE(6,*)'AVGDBZ3 = ',AVGDBZ3(I,J)
            ENDDO
         ENDDO
         DO J=1,360
            DO I=1,610
               AVGDBZ1(I,J)=AVGDBZ3(I,J)
            ENDDO
         ENDDO
        ENDIF
        IF(IYEARTAPE.GE.50)THEN
         IYEARTAPE=IYEARTAPE+1900
        ELSE
         IYEARTAPE=IYEARTAPE+2000
        ENDIF
        WRITE(6,'(A8)')IFLT
        WRITE(6,*)IYEARTAPE,MONTHTAPE,IDAYTAPE
        CALL FINDIDAYS(IDAYSCHK,NAIRCHK,IFLTCHK)
        CALL FINDIDAYS(IDAYSCHK2,NAIRCHK2,IFLTCHK2)
        WRITE(6,*)'IDAYS FROM JOBFILE = ',IFLTCHK2
        WRITE(6,*)'IDAYS FROM TAPE = ',IFLTCHK
        WRITE(6,*)'IYEAR,IYEARTAPE = ',IYEAR,IYEARTAPE
        IDAYSDIFF=IDAYSCHK-IDAYSCHK2
        IF(IDAYSDIFF.EQ.1)THEN
         IADD86400=1
        ELSE
         IADD86400=0
        ENDIF
        IF(IFLTCHK2.NE.IFLTCHK)THEN
         write(6,*)'flight id on jobfile inconsistent with tape'
c         write(6,*)'do you want to continue?'
c         OPEN(1,FILE='/dev/tty')
c         READ(5,'(A1)')IYES
c         CLOSE(1)
c         IF(IYES.EQ.'N'.OR.IYES.EQ.'n')THEN
c          WRITE(6,*)'rerun jobfilemaker and continue'
c          STOP
c         ENDIF
        ENDIF
c        PAUSE
       ENDIF
       IADD86400=0
       IF(IADD86400.EQ.1)TIME=TIME+86400.
       IF(IRCU.EQ.6.OR.IFRANCE.EQ.1)THEN
        FASTON=1
       ELSEIF(IRCU.EQ.2)THEN
        FASTON=0
       ELSE
        write(6,*)'faston not determine correctly'
        FASTON=1
       ENDIF
c       WRITE(6,*)'TIME,RLAT,RLON = ',TIME,RLAT,RLON
c       WRITE(6,*)'TIME,OLDTIME = ',TIME,ROLDTIME
       IF(TIME.EQ.ROLDTIME)GO TO 97100
       TIMEMSTIME=TIME-STIME
c       WRITE(6,*)'TIME,STIME,TIMEMSTIME = ',TIME,STIME,TIMEMSTIME
       IF(TIMEMSTIME.LT.-72000..AND.ITAPEOPEN.EQ.1)THEN
        WRITE(6,*)'BACKSPACING'
c        write(6,*)'should not get here 3'
c        stop
        CALL TAPECONTROL(LUNR,2,1)
        CALL TAPECONTROL(LUNR,2,1)
        ROLDTIME=TIME
        GO TO 97100
       ENDIF
       write(6,*)'calling tapesearch'
97101  IF(IADD86400.EQ.1)THEN
        STIMESEARCH=STIME-86400.
       ELSE
        STIMESEARCH=STIME
       ENDIF
       IF(LUNR.NE.80)THEN
        CALL TAPESEARCH(LUNR,2,2,STIMESEARCH,IERR)
        ELSE
        IF(ISIGMET.EQ.5)THEN
         WRITE(6,*)'CALLING DISCSEARCH'
         LUNRNC=LUNR
         CALL DISCSEARCH(LUNR,2,2,STIMESEARCH,IERR)
         LUNR=LUNRNC
        ENDIF
C          WRITE(6,*)'CALLING RVP8_SEARCH'
c        PAUSEc
C        WRITE(6,*)'STIMESEARCH,STIME,IADD86400 = ',
C     1             STIMESEARCH,STIME,IADD86400
C        CALL RVP8_SEARCH(LUNR,2,2,STIMESEARCH,IERR)
C        WRITE(6,*)'CALLED RVP8_SEARCH'
c        PAUSE
        NTIMER=0
        write(6,*)'called discsearch'
        timetest=itimex(2)
c        write(6,*)'timetest,etime = ',timetest,etime
        if(timetest.gt.etime)then
         itimex(2)=1
         time=itimex(2)
c         write(6,*)'new time,itimex = ',time,itimex(2)
         ierr=20
         go to 97101
        endif
       ENDIF
       IF (IERR.LT.0) GO TO 970
      CALL READTAPE(TIME,RLAT,RLON,RA,AZM,EV,BIN,REF,BIN1,REF1,RCAZM,
     +ITAPEOPEN,RADARFILE,NUMREC,PCORS,DCORS,RCORS,AZMCORS,
     +RDELCORTAS,ELCORS,ISIGMET,NDO)
       IF(IADD86400.EQ.1)TIME=TIME+86400
       WRITE(6,*)'IRCU = ',IRCU
       IF(IRCU.EQ.6.OR.IFRANCE.EQ.1)THEN
        FASTON=1
       ELSEIF(IRCU.EQ.2)THEN
        FASTON=0
       ELSE
        write(6,*)'faston not determine correctly'
        FASTON=1
       ENDIF
       IF((TIME-STIME).LT.-60000.)THEN
        CALL TAPECONTROL(LUNR,2,1) !back up 1 file
        CALL TAPECONTROL(LUNR,2,1) !back up 1 file
        GO TO 97101
c        write(6,*)'should not get here 4'
c        stop
       ELSEIF((TIME-STIME).LT.1.)THEN
c        WRITE(6,*)'SETTING IFILECHECK TO 1'
        IFILECHECK=1
c       ELSE
c        WRITE(6,*)'TIME IS ',TIME
       ENDIF
      ENDIF
      OLDTIME=0
      ITIMECHECK=0
C      WRITE(6,*)'START XNIQ AND XNIQTA = ',XNIQ,XNIQTA
c7040  write(6,*)'calling readtape'
      IF(IAFTFORE.EQ.2)RDELCORTA=RDELCORTAS(2)
7040  CALL READTAPE(TIME,RLAT,RLON,RA,AZM,EV,BIN,REF,BIN1,REF1,RCAZM,
     +ITAPEOPEN,RADARFILE,NUMREC,PCORS,DCORS,RCORS,AZMCORS,
     +RDELCORTAS,ELCORS,ISIGMET,NDO)
c      WRITE(6,*)'RA,GROUNDADJUST = ',RA,GROUNDADJUST
      RA=RA-GROUNDADJUST
c      WRITE(6,*)'CORRECTED RA = ',RA
      TIMES=TIME
      ISCANDIM=NBINS
      IF((IYEARTAPE.GE.2019.and.INAIR.EQ.1).OR.
     +   (IYEARTAPE.GE.2020.AND.INAIR.EQ.2))THEN
         DO I=1,76
            IF(REF(I).GT.-32.)REF(I)=REF(I)+9.
         ENDDO
      ENDIF
      CALL VRLOCATER(TIMES,OLAT,OLON,RLAT,RLON,RA,EV,AZM,RADIITA,
     +XR,YR,ZR,ISCANDIM,SMOTIONU,SMOTIONV,CENTIME,BIN,REF)
      IF(IAFTFORE.EQ.1.AND.ELEV.GE.0..AND.ICALLSWEEPIN.NE.0)GO TO 7040
      IF(IAFTFORE.EQ.2.AND.ELEV.LE.0..AND.ICALLSWEEPIN.NE.0)GO TO 7040
      IF(ABS(RADVWS).GT.100.)GO TO 7040
      IF(NDO.NE.0)GO TO 76583
C temporary kluge
      IF(IAFTFORE.EQ.1.AND.AFTVNYQ.GT.0.)THEN
         XNIQ=AFTVNYQ
         XNIQTA=AFTVNYQ
      ENDIF
c      WRITE(6,*)'TIMES = ',TIMES
c      WRITE(6,529)(RADIITA(I),I=1,40)
c      WRITE(6,529)(BIN(I),I=1,40)
c 529  FORMAT(10F8.2)
c      PAUSE
c      WRITE(6,*)'7040 NUM_RAYS,TIME,RADAZM,TRAKAZM,TRAKELEV = ',
c     1   NUM_RAYS,TIME,RADAZM,TRAKAZM,TRAKELEV
c      WRITE(6,*)'7040 PITCH,DRIFT,ROLL,HEADING,ELEV = ',
c     1                PITCH,DRIFT,ROLL,HEADING,ELEV
c      CALL look_tdr_hdr(agelook,agepitch,agedrift,ageroll,ageheading)
c      write(6,*)'hdr AGE,PITCH,DRIFT,ROLL,HEADING = ',agelook,agepitch,
c     1           agedrift,ageroll,ageheading
c      WRITE(6,*)'V0,XXNIQ = ',V0,XNIQTA
c      WRITE(6,*)'VELBUFFER = '
c      WRITE(6,591)(VELBUFFER(I),I=1,100)
c      WRITE(6,*)'BIN = '
c      WRITE(6,591)(BIN(I),I=1,100)
c      write(6,*)'7040 time,nbins = ',time,nbins
      DO I=NBINS+1,MAX_HRD_DIM
         BIN(I)=-888.8
         REF(I)=-32.
      ENDDO
      IF(IYEARTAPE.GT.2016.AND.IPLANE.EQ.1)THEN
         DO I=1,NBINS
            IF(RADIITA(I).GT.44.)THEN
               BIN(I)=-888.8
               REF(I)=-32.
            ELSEIF(RADIITA(I).GT.0..AND.REF(I).LT.-10.)THEN
               BIN(I)=-888.8
               REF(I)=-32.
            ENDIF
         ENDDO
      ENDIF
      RLATDIFF=ABS(OLAT-RLAT)
      RLONDIFF=ABS(OLON-RLON)
c      WRITE(6,*)'RLATDIFF,RLONDIFF = ',RLATDIFF,RLONDIFF
      IF(RLATDIFF.GT.10..OR.RLONDIFF.GT.10.)GO TO 7040
c      WRITE(6,*)'NIX = ',NIX
      IF(NIX.EQ.-200)GO TO 7040
c      WRITE(6,*)'NBINS = ',NBINS
      IF(NBINS.EQ.0)GO TO 7040
      IF(NBINS.GT.NBINSMAX)NBINSMAX=NBINS
      IF(ABS(V0).GT.100.)THEN
       DO I=1,MAX_HRD_DIM
        BIN(I)=-888.8
       ENDDO
      ENDIF
      do i=1,max_hrd_dim
         radiiatten(i)=radiita(i)
      enddo
      do i=2,max_hrd_dim
       if(radiita(i).lt.radiita(i-1))then
        radiita(i)=1000.
       endif
      enddo
c      if(num_rays.eq.3)then
c       write(6,*)'gtlnta = ',gtlnta
c       write(6,*)'radiita = ',(radiita(i),i=1,max_hrd_dim)
c       pause
c      endif
      if(nbins.lt.max_gates)then
       do i=nbins+1,max_gates
        ref(i)=-32.
        bin(i)=-888.8
       enddo
      endif
c      write(6,*)'nbins,num_rays,ref = ',nbins,num_rays,
c     + (ref(i),i=1,max_gates)
c      write(6,*)'nbins,num_rays,dbzbuffer = ',nbins,num_rays,
c     + (dbzbuffer(i),i=1,max_gates)
c      WRITE(6,*)'SWPASS = ',SWPASS
c      SWPASSTEST=SWPASS*XNIQTA
c      SWPASSTEST7=SWPASSTEST*.7
c      WRITE(6,*)'SWPASSTEST = ',SWPASSTEST
      IF(ISIGMET.EQ.5)THEN
         SWPASSTEST=SWPASS
         SWPASSTEST7=SWPASSTEST*.7
      ENDIF
      RA1000=RA/1000.
c      WRITE(6,*)'IYEARTAPETEST,SWPASS,SWPASS2 = ',
c     +           IYEARTAPETEST,SWPASS,SWPASS2
      IF(IAFTFORE.EQ.2.AND.IYEARTAPE.GE.2017.AND.IPLANE.EQ.1)THEN
         SWPASS1TEST=SWPASS-0.03
         SWPASS2TEST=SWPASS2-0.03
      ELSEIF(ISIGMET.EQ.8)THEN
         SWPASS1TEST=SWPASS
         SWPASS2TEST=SWPASS2
      ENDIF
      DO I=1,NBINS
       RADDIFF=ABS(RDTAIIN(I)-RA/1000.)
       RATEST=RDTAIIN(I)/RA1000
c       IF(IYEARTAPE.GT.2016.AND.IPLANE.EQ.1.AND.REF(I).LT.-10)THEN
c        REF(I)=-32.
c        BIN(I)=-888.8
c       ENDIF
       IF(IYEARTAPE.GT.2016.AND.RDTAIIN(I).LT.10..AND.IPLANE.EQ.1)THEN
c       IF(IYEARTAPE.GT.2016.AND.RATEST.LT.3.0)THEN
          IYEARTAPETEST=1
       ELSE
          IYEARTAPETEST=0
       ENDIF
c       IF(WIDTHBUFFER(I).LT.SWPASS.AND.ISIGMET.EQ.8)THEN
c       IF(IYEARTAPETEST.EQ.1.AND.WIDTHBUFFER(I).LT.SWPASS2)THEN
c       WRITE(6,*)'ISIGMET,WIDTHBUFFER,SWPASS1TEST,SWPASS2TEST = ',
c     +            ISIGMET,WIDTHBUFFER(I),SWPASS1TEST,SWPASS2TEST
       IF(ISIGMET.EQ.8.AND.WIDTHBUFFER(I).LT.SWPASS2TEST)THEN
         BIN(I)=-888.8
         REF(I)=-32.
       ENDIF
c       WRITE(6,*)'I,IPLANE,RADDIFF,IYEARTAPETEST = ',
c     +            I,IPLANE,RADDIFF,IYEARTAPETEST
       IF(WIDTHBUFFER(I).LT.SWPASS1TEST.AND.ISIGMET.EQ.8)THEN
        IF(IPLANE.NE.1.OR.RADDIFF.LT.2..OR.IYEARTAPETEST.EQ.1)THEN
c         IF((REF(I).LT.20..AND.ZR(I).GT.2.).OR.
c     +      (REF(I).LT.30..AND.ZR(I).LE.2.))THEN
          BIN(I)=-888.8
          REF(I)=-32.
        ENDIF
       ENDIF
c       IF(REF(I).LT.20..AND.ISIGMET.EQ.8.AND.IPLANE.EQ.1.AND.
c     +        (RADDIFF.LT.2..OR.IYEARTAPETEST.EQ.1.OR.ZR(I).LE.2.))THEN
c          BIN(I)=-888.8
c          REF(I)=-32.
c       ENDIF
       IF(ISIGMET.EQ.5.AND.
c     + (((WIDTHBUFFER(I).GT.SWPASSTEST7.OR.REF(I).LT.15.).
     + ((WIDTHBUFFER(I).GT.SWPASSTEST.
     +  AND.RADDIFF.LT.2.).OR.
     +  WIDTHBUFFER(I).LE.-30000.))THEN
c     +  WIDTHBUFFER(I).LE.0.02))THEN
        BIN(I)=-888.8
        REF(I)=-32.
C        WRITE(6,*)'I,ISIGMET-5-1 WIDTHBUFFER,SWPASSTEST,RADDIFF = ',
C     + I,WIDTHBUFFER(I),SWPASSTEST,RADDIFF
       ELSEIF(ISIGMET.EQ.5.AND.
c     + ((WIDTHBUFFER(I).GT.SWPASSTEST.AND.RATEST.LT.2..AND.
     + ((WIDTHBUFFER(I).GT.SWPASSTEST7.
     +   AND.RATEST.LT.2..AND.
     +   ZR(I).LT.3.).OR.
     +  WIDTHBUFFER(I).LE.-30000.))THEN
c     +  WIDTHBUFFER(I).LE.0.02))THEN
C        write(6,*)'i,widthbuffer,ra,rdtaiin,ratest,zr,swpasstest = ',
C     + i,widthbuffer(i),ra,rdtaiin(i),ratest,zr(i),swpasstest
        BIN(I)=-888.8
        REF(I)=-32.
       ENDIF
      ENDDO
      DO I=1,NBINS
       IF(REF(I).GT.-32..AND.RADIITA(I).GT.0.)THEN
        DBZRADIUS=REF(I)-10*ALOG10(RADIITA(I)/10.)
        IF(DBZRADIUS.LT.DBZRADIUSMIN)DBZRADIUSMIN=DBZRADIUS
c        WRITE(6,*)'I,REF,RADIITA,DBZRADIUS = ',
c     +   I,REF(I),RADIITA(I),DBZRADIUS
        IF(DBZRADIUS.LE.-100.)THEN
         VELBUFFER(I)=-888.88
         DBZBUFFER(I)=-32.00
         REF(I)=-888.88
         BIN(I)=-888.88
        ENDIF
       ENDIF
      ENDDO
c      WRITE(6,*)'DBZRADIUSMIN = ',DBZRADIUSMIN
      TRACKLATLON=180./3.14159*ATAN2(GSE,GSN)
      IF(TRACKLATLON.LT.0.)TRACKLATLON=TRACKLATLON+360.
      TRACKDIFF=TRACK-TRACKLATLON
      IF(TRACKDIFF.GT.180.)TRACKDIFF=TRACKDIFF-360.
      IF(TRACKDIFF.LT.-180.)TRACKDIFF=TRACKDIFF+360.
      IF(TRACKDIFF.GT.2.)THEN
c      IF(ABS(TRACKDIFF).GT.2..OR.ABS(PITCH).LT..1.OR.
c     +   ABS(HEADING).LT..1)THEN
C     +   ABS(ROLL).LT..1.OR.ABS(HEADING).LT..1)THEN
       DO I=1,MAX_GATES
        BIN(I)=-888.8
        BIN1(I)=-888.8
        REF(I)=-32.
        REF1(I)=-32.
       ENDDO
      ENDIF
c      IF(ISIGMET.EQ.5)THEN
c      WRITE(6,*)'NUM_RAYS = ',NUM_RAYS
c      WRITE(6,'(10F8.2)')(REF(I),I=1,100)
c      IF(IPLANE.EQ.1)THEN
       DO I=1,MAX_HRD_DIM
        IF(REF(I).GT.-32.)REF(I)=REF(I)+FLOAT(IDBZADD)
       ENDDO
c      ENDIF
c      WRITE(6,*)'NUM_RAYS = ',NUM_RAYS
c      WRITE(6,'(10F8.2)')(REF(I),I=1,100)
      IF(IADD86400.EQ.1)TIME=TIME+86400.
c       WRITE(6,*)'GO TO 7040 HEADING = ',HEADING
       IF(ABS(HEADING).LT..1)GO TO 7040
       DIFFHDTRK=HEADING-TRACK
c       WRITE(6,*)'GO TO 7040 DIFFHDTRK = ',DIFFHDTRK
       IF(ABS(DIFFHDTRK).LT..1)GO TO 7040
       IF(ABS(ELEV).LT..001.OR.ABS(ROLL).GT.ROLLTOL)THEN
        DO I=1,MAX_GATES
         BIN(I)=-888.88
        ENDDO
       ENDIF
       IF(ABS(ELEV).LT..001)THEN
        DO I=1,MAX_GATES
         REF(I)=-888.88
        ENDDO
       ENDIF
       IF(ABS(RADVGS).GT.15)THEN
        DO I=1,NBINS
         BIN(I)=-888.88
        ENDDO
       ENDIF
       DO I=1,NBINS
        IF(REF(I).GT.60.)THEN
         REF(I)=-32.
         BIN(I)=-888.88
        ENDIF
       ENDDO
c       write(6,*)'iheader(491),ifrance,faston = ',
c     +  iheader(491),ifrance,faston
       IF(IRCU.EQ.6.OR.IFRANCE.EQ.1)THEN
c        write(6,*)'i got to slot 1'
        FASTON=1
       ELSEIF(IRCU.EQ.2)THEN
c        write(6,*)'i got to slot 2'
        FASTON=0
        IF(IFASTCHECK.EQ.0)THEN
         WRITE(6,*)'ANTENNA NOT IN FAST'
         WRITE(6,*)'DO YOU WANT TO CONTINUE? IF SO TYPE go'
c         PAUSE
         FASTON=1
         IFASTCHECK=1
        ENDIF
       ELSE
c        write(6,*)'i got to slot 3'
c        write(6,*)'faston not determined correctly'
        FASTON=1
       ENDIF
c      write(6,*)'back from readtape'
c      WRITE(6,*)'TIME,NTASWEEP,ISWEEPSET,ISWEEPCHECK = ',
c     + TIME,NTASWEEP,ISWEEPSET,ISWEEPCHECK
c      write(6,*)'time,stime = ',time,stime
      IF(TIME.GT.ETIME)THEN
c       write(6,*)'time,etime = ',time,etime
       IF(TIME-ETIME.GT.1000..AND.NTIMER.LT.100)THEN
        TIME=1
        ITIMEX(2)=1
        NTIMER=NTIMER+1
        WRITE(6,*)'NTIMER,TIME,ETIME = ',NTIMER,TIME,ETIME
        GO TO 7040
       ELSE
        NTIMER=0
       ENDIF
      ENDIF
      IF(TIME.GT.STIME.AND.IFILECHECK.EQ.0.AND.ITAPEOPEN.EQ.1)THEN
       WRITE(6,*)'BACKING UP TWO FILES LOOKING FOR STARTIME'
c       write(6,*)'I should not get here 5'
c       stop
       CALL TAPECONTROL(LUNR,2,1) !back up 1 file
       CALL TAPECONTROL(LUNR,2,1) !back up 1 file
       IFILECHECK=1
       GO TO 971
      ELSE
       IFILECHECK=1
      ENDIF
      OOLAT=RLAT
      OOLON=RLON
      ALAT=.5*(RLAT+OLAT)
      ALON=.5*(RLON+OLON)
      XMOVE=(CENTIME-TIME)*SMOTIONU/1000.
      YMOVE=(CENTIME-TIME)*SMOTIONV/1000.
      DELX=XMOVE+(111.1*COS(ALAT*3.14159/180.)*(RLON-OLON))
      DELY=YMOVE+(111.1*(RLAT-OLAT))
      OLATDRIFT=OLAT-YMOVE/111.1
      OLONDRIFT=OLON-XMOVE/111.1/COS(ALAT*3.14159/180.)
      IF(ABS(DELX).LT..0001.AND.ABS(DELY).LT..0001)THEN
       STORMRADIUS=.0001
       DELX=.0001
       DELY=.0001
      ELSE
       STORMRADIUS=SQRT(DELX*DELX+DELY*DELY)
      ENDIF
      STORMAZIMUTH=180./3.14159*ATAN2(DELY,DELX)
      IF(STORMRADIUS.GT.1000.)THEN
       STORMRADIUS=.0001
       DELX=.0001
       DELY=.0001
      ENDIF
      VRAD=(UCOM*DELX+VCOM*DELY)/STORMRADIUS
      VTAN=(VCOM*DELX-UCOM*DELY)/STORMRADIUS
      IF(STORMAZIMUTH.LT.0.)STORMAZIMUTH=STORMAZIMUTH+360.
      TIMES=TIME
      TIMESINCE=TIMES-TIMESLAST
      AZITEST1=90.-AZIIN
      IF(AZITEST1.LT.0.)AZITEST1=AZITEST1+360.
      AZITEST2=90.-AZIOUT
      IF(AZITEST2.LT.0.)AZITEST2=AZITEST2+360.
      AZIDIFF1=STORMAZIMUTH-AZITEST1
      IF(AZIDIFF1.GT.180.)AZIDIFF1=AZIDIFF1-360.
      IF(AZIDIFF1.LT.-180.)AZIDIFF1=AZIDIFF1+360.
      AZIDIFF1=ABS(AZIDIFF1)
      AZIDIFF2=STORMAZIMUTH-AZITEST2
      IF(AZIDIFF2.GT.180.)AZIDIFF2=AZIDIFF2-360.
      IF(AZIDIFF2.LT.-180.)AZIDIFF2=AZIDIFF2+360.
      AZIDIFF2=ABS(AZIDIFF2)
C      WRITE(6,*)'STORMAZIMUTH,AZIDIFF1,AZIDIFF2 = ',
C     + STORMAZIMUTH,AZIDIFF1,AZIDIFF2
      IF(AZIDIFF1.LT.45..AND.TIMES.LT.CENTIME)THEN
       INOUT=1
      ELSEIF(AZIDIFF2.LT.45..AND.TIMES.GT.CENTIME)THEN
       INOUT=2
      ELSE
       INOUT=0
      ENDIF
c      write(6,*)'times,timeslast,timesince,inout,radius,azi = ',
c     + times,timeslast,timesince,inout,stormradius,stormazimuth
c      WRITE(6,'(4F10.4)')RLAT,OLAT,RLON,OLON
      INTTIME=INT(TIMES)
      ITH=INTTIME/3600
      ITM=(INTTIME-IH*3600)/60
      ITM1=ITM/10
      ITM2=ITM-ITM1*10
      ITS=INTTIME-IH*3600-IM*60
      ITS1=ITS/10
      ITS2=ITS-ITS1*10
      IF(TIMESINCE.GE.1.)THEN
       RAOUTPUT=RA/1000.
C       WRITE(95,5207)INOUT,STORMRADIUS,STORMAZIMUTH,
C     + ITH,ITM1,ITM2,ITS1,ITS2,RAOUTPUT
       WRITE(96,5207)INOUT,STORMRADIUS,STORMAZIMUTH,ITH,ITM1,ITM2,
     + ITS1,ITS2,VRAD,VTAN,DELX,DELY,UCOM,VCOM,OLATDRIFT,OLONDRIFT,
     + RADVWS,RADGS,RADVGS
c       WRITE(95,*)'AZITEST1,AZIDIFF1 = ',AZITEST1,AZIDIFF1
c       WRITE(95,*)'AZITEST2,AZIDIFF2 = ',AZITEST2,AZIDIFF2
5207   FORMAT(I1,2F8.2,1X,I2,4I1,6F8.2,5F10.4)
       TIMESLAST=TIMES
      ENDIF
c      WRITE(95,'(8F10.4)')RLAT,OLAT,RLON,OLON,
c     1 DELX,DELY,STORMRADIUS,STORMAZIMUTH
      IF(IUSEWIND.NE.1)CENTIME=TIME
      ISCANDIM=NBINS
      IBINS=MAX_GATES
      I150BEFORE=I150
      IF(GTLNTA(1).GT..075)THEN
       I150=1
      ELSE
       I150=0
      ENDIF
      IF(ISIGMET.EQ.8)I150=1
      IF(I150BEFORE.NE.I150.AND.ICALLSWEEPIN.NE.0)IBLANKSWEEP=1
      RADRES=GTLNTA(1)
c      SXBIBINAVG=.150
      SXBIBINAVG=SX/4.
      IF(SXBIBINAVG.GT.1.2)SXBIBINAVG=1.2
      IBINAVG=INT((SXBIBINAVG+.001)/RADRES/2)*2
      IF(IBINAVG.LT.2)IBINAVG=2
c      IBINAVG=1
c      WRITE(6,*)'IBINAVG,RADRES,SXBIBINAVG = ',IBINAVG,RADRES,SXBIBINAVG
      IF(RADTEST.GT.0..AND.RADIITA(50).NE.RADTEST)THEN
       INEWRAD=1
       RADTEST=RADIITA(50)
      ELSE
       INEWRAD=0
      ENDIF
      INEWRAD=0
      IF(TIME.LT.STIME)THEN
c       write(6,*)'calling int'
       ITIME=INT(TIME)
c       write(6,*)'returned from int'
       IF(ITIME.GT.ITIMECHECK)THEN
c        WRITE(6,*)'TIME,STIME = ',TIME,STIME
        ITIMECHECK=ITIME
       ENDIF
c       write(6,*)'going to 7040 time,stime = ',time,stime
       GO TO 7040
      ENDIF
      TANAZM=TAN(TRAKAZM*3.14159/180.)
      COSAZM=COS(TRAKAZM*3.14159/180.)
      COSEV=COS(TRAKELEV*3.14159/180.)
      RALTITUDE=RA*.001
      IF(COSAZM.GT.0.)THEN
       VLENGTH=20.-RALTITUDE
       IEV=1
       XLENGTH=VLENGTH*TANAZM*COSEV
      ELSEIF(COSAZM.LT.0.)THEN
       VLENGTH=RALTITUDE
       IEV=-1
       XLENGTH=-VLENGTH*TANAZM*COSEV
      ELSE
       IEV=0
       XLENGTH=1000.
      ENDIF
      IF(NUM_RAYS.GT.1)THEN
       XDIFF=XLENGTH-XLENGTHOLD
c       write(6,*)'vlength,xlength,tanazm,cosazm,cosev = ',
c     + VLENGTH,XLENGTH,TANAZM,COSAZM,COSEV
       IF(ABS(XDIFF).LT.SXBIG)THEN
        IAZM(NUM_RAYS)=0
       ELSE
        XLENGTHOLD=XLENGTH
        IAZM(NUM_RAYS)=1
       ENDIF
      ELSE
       XLENGTHOLD=XLENGTH
      ENDIF       
c      if(trakazm.gt.85.and.trakazm.lt.86)then
c       write(6,*)'bin = ',bin
c      endif
c      write(6,*)'calling vrlocater'
c      IF(IUSEWIND.NE.1)THEN
c       I=1
c       RA1000=(RA/1000.)-.2
c       DO I=1,30
c        IF(BIN(I).GT.-98..AND.REF(I).GT.20.)GO TO 29654
c        IF(RADIITA(I).GT.2.)THEN
cc         WRITE(6,*)'GOING TO 7040 I,RADIITA,RA = ',I,RADIITA(i),RA1000
c         GO TO 7040
c        ENDIF
c       ENDDO
cc       WRITE(6,*)'GOING TO 7040'
c       GO TO 7040
c      ENDIF
      CALL VRLOCATER(TIMES,OLAT,OLON,
     + RLAT,RLON,RA,EV,AZM,RDTAIIN,XR,YR,ZR,
     + ISCANDIM,SMOTIONU,SMOTIONV,CENTIME,BIN,REF)
c      WRITE(6,*)'NUM_RAYS,AZ_EL1,AZ_EL2,EV,AZM = ',
c     + NUM_RAYS+1,AZ_EL(1,NUM_RAYS+1),AZ_EL(2,NUM_RAYS+1),EV,AZM
c       WRITE(6,*)'RDTAIIN = ',(RDTAIIN(I),I=301,500)
c      write(6,*)'returned from vrlocater'
       IF(NUM_RAYS.GE.0.AND.IUSEWIND.EQ.1)THEN
c        write(6,*)'olat,olon,rlat,rlon = ',olat,olon,rlat,rlon
c        write(6,*)'smotionu,smotionv,centime',smotionu,smotionv,centime
c        WRITE(6,*)'TRAKAZM = ',TRAKAZM
c        WRITE(6,*)'NUM_RAYS SPOT,TIMES,EV,XR,YR,ZR AT 301 = ',
c     +   TIMES,EV,XR(301),YR(301),ZR(301)
c        WRITE(6,*)'IUSEWIND = ',IUSEWIND
c        PAUSE
        RADIANEV=EV*3.14159/180.
        RADIANAZM=AZM*3.14159/180.
        DIRCOSX=COS(RADIANEV)*COS(RADIANAZM)
        DIRCOSY=COS(RADIANEV)*SIN(RADIANAZM)
        DIRCOSZ=SIN(RADIANEV)
        XMIN=-XZ
        YMIN=-YZ
        XMAX=-XZ+IMX*SX
        YMAX=-YZ+JMX*SY
        ZZMAX=ZZ+(KMX-1)*SZ
c        WRITE(6,*)'IMX,JMX,KMX = ',IMX,JMX,KMX
c        WRITE(6,*)'SX,SY,SZ,XZ,YZ,ZZ = ',SX,SY,SZ,XZ,YZ,ZZ
c       WRITE(6,*)'XMIN,YMIN,ZZMIN = ',XMIN,YMIN,ZZMIN
c       WRITE(6,*)'XMAX,YMZX,ZZMAX = ',XMAX,YMAX,ZZMAX
        DO IR=1,NBINS
         RADSWEEP(IR,NUM_RAYS+1)=SQRT(XR(IR)*XR(IR)+YR(IR)*YR(IR))
c         IF(BIN(IR).GT.-800.)THEN
          IINT=INT((XR(IR)+XZ+.5*SX)/SX)
          JINT=INT((YR(IR)+YZ+.5*SY)/SY)
          KINT=1+INT((ZR(IR)-ZZ)/SZ)
          VRRAD(IR,NUM_RAYS+1)=0.
          VRSUM=0.
          if(num_rays.ge.398.and.num_rays.le.400.and.ir.eq.1)then
c           write(6,*)num_rays,pazm(num_rays),pelev(num_rays),
c     1               heading,track,
c     1               ev,azm,dircosx,dircosy,dircosz
          endif
          DO I=IINT,IINT+1
           DO J=JINT,JINT+1
            DO K=KINT,KINT+1
c             if(num_rays.ge.398.and.num_rays.le.400)then
c              write(6,*)'ir,i,j,k,xr,yr,zr = ',
c     1           ir,i,j,k,xr(ir),yr(ir),zr(ir)
c             endif
             IF(I.GE.1.AND.I.LE.IMX)THEN
              IF(J.GE.1.AND.J.LE.JMX)THEN
               IF(K.GE.1.AND.K.LE.KMX)THEN
c                 write(6,*)'num_rays,ir,wflag,i,j,k,u,v,w = ',
c     1              num_rays,ir,wflag,i,j,k,u(i,j,k),v(i,j,k),w(i,j,k)
                IF(U(I,J,K).GT.WFLAG)THEN
c                 if(num_rays.gt.0)then
c                 endif
c                 write(6,*)'num_rays,ir,wflag,i,j,k,u,v,w = ',
c     1              num_rays,ir,wflag,i,j,k,u(i,j,k),v(i,j,k),w(i,j,k)
                 XG=(I-1)*SX-XZ+.5*SX
                 YG=(J-1)*SY-YZ+.5*SY
                 ZG=(K-1)*SZ+ZZ
                 XI=XR(IR)-XG
                 YI=YR(IR)-YG
                 ZI=ZR(IR)-ZG
                 RADR=SQRT(XR(IR)*XR(IR)+YR(IR)*YR(IR))
                 RADG=SQRT(XG*XG+YG*YG)
                 VRAD=(U(I,J,K)*XG+V(I,J,K)*YG)/RADG
                 VTAN=(V(I,J,K)*XG-U(I,J,K)*YG)/RADG
                 URAD=(VRAD*XR(IR)-VTAN*YR(IR))/RADR
                 VRAD=(VRAD*YR(IR)+VTAN*XR(IR))/RADR
                 DISTPOINT=SQRT(XI*XI+YI*YI+ZI*ZI)
                 IF(DISTPOINT.GT.0.)THEN
                  RINT=1./DISTPOINT
                 ELSE
                  RINT=1000000.
                 ENDIF
                 VRRAD(IR,NUM_RAYS+1)=VRRAD(IR,NUM_RAYS+1)+
     1              RINT*(URAD*DIRCOSX+VRAD*DIRCOSY+
     1              W(I,J,K)*DIRCOSZ)
                 VRSUM=VRSUM+RINT
                ENDIF
               ENDIF
              ENDIF
             ENDIF
            ENDDO
           ENDDO
          ENDDO
          IF(VRSUM.GT.0..AND.ABS(PELEV(NUM_RAYS+1)).GT..001)THEN
           VRRAD(IR,NUM_RAYS+1)=VRRAD(IR,NUM_RAYS+1)/VRSUM
          ELSE
           VRRAD(IR,NUM_RAYS+1)=-888.8
          ENDIF
c         ELSE
c          VRRAD(IR,NUM_RAYS)=-888.8
c         ENDIF
        ENDDO
c        IF(NUM_RAYS.GE.398.AND.NUM_RAYS.LE.400)
c     1   WRITE(6,*)NUM_RAYS,(VRRAD(IR,NUM_RAYS),IR=1,NBINS)
        ISCANONE=1
        RDTAONE(1)=.0001
        BINONE(1)=0.
        REFONE(1)=0.
        CALL VRLOCATER(TIMES,OLAT,OLON,
     +  RLAT,RLON,RA,EV,AZM,RDTAONE,XR,YR,ZR,
     +  ISCANONE,SMOTIONU,SMOTIONV,CENTIME,BINONE,REFONE)
        IF(NAIRCRAFT.NE.42)GO TO 76542
        DO IR=1,1
         I=1
         IF(I.EQ.1)THEN
          IINT=INT((XR(IR)+XZ+.5*SX)/SX)
          JINT=INT((YR(IR)+YZ+.5*SY)/SY)
          KINT=1+INT((ZR(IR)-ZZ)/SZ)
          UFILE=0.
          VFILE=0.
          UFILESUM=0.
c          WRITE(6,*)'IINT,JINT,KINT = ',IINT,JINT,KINT
          DO I=IINT,IINT+1
           DO J=JINT,JINT+1
            DO K=KINT,KINT+1
             IF(I.GE.1.AND.I.LE.IMX)THEN
              IF(J.GE.1.AND.J.LE.JMX)THEN
               IF(K.GE.1.AND.K.LE.KMX)THEN
                IF(U(I,J,K).GT.WFLAG)THEN
                 XG=(I-1)*SX-XZ+.5*SX
                 YG=(J-1)*SY-YZ+.5*SY
                 ZG=(K-1)*SZ+ZZ
                 XI=XR(IR)-XG
                 YI=YR(IR)-YG
                 ZI=ZR(IR)-ZG
                 RADR=SQRT(XR(IR)*XR(IR)+YR(IR)*YR(IR))
                 RADG=SQRT(XG*XG+YG*YG)
                 VRAD=(U(I,J,K)*XG+V(I,J,K)*YG)/RADG
                 VTAN=(V(I,J,K)*XG-U(I,J,K)*YG)/RADG
                 URAD=(VRAD*XR(IR)-VTAN*YR(IR))/RADR
                 VRAD=(VRAD*YR(IR)+VTAN*XR(IR))/RADR
                 DISTPOINT=SQRT(XI*XI+YI*YI+ZI*ZI)
                 IF(DISTPOINT.GT.0.)THEN
                  RINT=1./DISTPOINT
                 ELSE
                  RINT=1000000.
                 ENDIF
                 UFILE=UFILE+RINT*URAD
                 UFILESUM=UFILESUM+RINT
                 VFILE=VFILE+RINT*VRAD
                ENDIF
               ENDIF
              ENDIF
             ENDIF
            ENDDO
           ENDDO
          ENDDO
          IF(UFILESUM.GT.0.)THEN
           UFILE=UFILE/UFILESUM
           VFILE=VFILE/UFILESUM
           WDFILE=180./3.14159*ATAN2(-UFILE,-VFILE)
           IF(WDFILE.LT.0.)WDFILE=WDFILE+360.
           WSFILE=SQRT(UFILE*UFILE+VFILE*VFILE)
          ELSE
           UFILE=UCOM
           VFILE=VCOM
           WDFILE=RADWD
           WSFILE=RADWS
          ENDIF
         ELSE
          UFILE=UCOM
          VFILE=VCOM
          WDFILE=RADWD
          WSFILE=RADWS
         ENDIF
        ENDDO
        HEADSTORM=ATAN2(XR(1),YR(1))
        HEADSTORM=HEADSTORM*180./3.14159
        IF(HEADSTORM.LT.0.)HEADSTORM=HEADSTORM+360.
        IF(HEADSTORM.GE.360.)HEADSTORM=HEADSTORM-360.
        TANDIR=HEADSTORM+90.
        IF(TANDIR.GE.360.)TANDIR=TANDIR-360.
c        pause
        IFLAGGING=0
        TANDIF=ABS(TANDIR-RADWD)
        IF(TANDIF.GT.180.)TANDIF=360-TANDIF
        WSTANTEST=RADWS*TANDIF
        IF(WSTANTEST.GT.1200.)THEN
         IFLAGGING=1
        ENDIF
        IF(UFILESUM.GT.0.)THEN
         DIFFVECT=SQRT((UFILE-UCOM)*(UFILE-UCOM)+
     +                 (VFILE-VCOM)*(VFILE-VCOM))
         DIFFDIR=ABS(RADWD-WDFILE)
         IF(DIFFVECT.GT.40.)THEN
          IFLAGGING=1
         ELSEIF((DIFFVECT.GT.15..AND.DIFFVECT.LE.40)
     +           .AND.DIFFDIR.GT.15.)THEN
          IFLAGGING=1
         ENDIF
        ENDIF 
        IFLAGGING=0
        IF(IFLAGGING.EQ.1)THEN
         WRITE(6,*)'FLAGGING RAY'
         write(6,*)'headstorm,tandir = ',headstorm,tandir
         write(6,*)'ucom,ufile,vcom,vfile = ',ucom,ufile,vcom,vfile
         write(6,*)'radws,wsfile,radwd,wdfile = ',
     +             radws,wsfile,radwd,wdfile
         DO I=1,MAX_GATES
          BIN(I)=-888.8
         ENDDO
        ENDIF
76542 ENDIF
C       write(6,*)'num_rays = ',num_rays
C       write(6,*)'bin'
C       write(6,*)(bin(ir),ir=1,512)
C       write(6,*)'vrrad'
C       write(6,*)(vrrad(ir,num_rays),ir=1,512)
CC       IF(XR(80).GE.XMIN.AND.XR(80).LE.XMAX)THEN
C        IF(YR(80).GE.YMIN.AND.YR(80).LE.YMAX)THEN
C         IF(ZR(80).GE.ZMIN.AND.YR(80).LE.ZMAX)THEN
C          ILOC=1+(XR(80)+XZ)/SX
C          JLOC=1+(YR(80)+YZ)/SY
C          KLOC=1+(ZR(80)-ZZ)/SZ
C          WRITE(6,*)'ILOC,JLOC,KLOC = ',ILOC,JLOC,KLOC
C         ENDIF
C        ENDIF
C       ENDIF
76583 IF(NUM_RAYS.GT.0.AND.NDO.EQ.0)THEN
c       WRITE(6,*)'NUM_RAYS,XR = ',NUM_RAYS,XR
c       WRITE(6,*)'NUM_RAYS,YR = ',NUM_RAYS,YR
c       WRITE(6,*)'NUM_RAYS,ZR = ',NUM_RAYS,ZR       
       CALL VRLOCATER(TIMES,OLAT,OLON,
     + RLAT,RLON,RA,EV,AZM,RDTAIIN,XR,YR,ZR,
     + MAX_GATES,SMOTIONU,SMOTIONV,CENTIME,BIN,REF)
       DO I=1,NBINS
        XRSWEEP(I,NUM_RAYS)=XR(I)
        YRSWEEP(I,NUM_RAYS)=YR(I)
        ZRSWEEP(I,NUM_RAYS)=ZR(I)
       ENDDO
      ENDIF
      SWEEPTEST=1.
      IF(ABS(ELEV).GT.0.1)THEN
       SWEEPTEST=ELEV*SWEEPOLD
       SWEEPOLD=ELEV
      ENDIF
      IF(IFRANCE.NE.1.OR.ISIGMET.NE.5)SWEEPTEST=1.
      IF(ISWEEPCHECK.NE.NTASWEEP.AND.IFRANCE.NE.1)SWEEPTEST=-1.
      IF(ISWEEPCHECK.NE.NTASWEEP.AND.ISIGMET.NE.5)SWEEPTEST=-1.
c      IF(IFRANCE.NE.1.AND.ISWEEPCHECK.NE.NTASWEEP)SWEEPTEST=-1.
c      IF(IFRANCE.NE.1.AND.ISWEEPCHECK.EQ.NTASWEEP)SWEEPTEST=1.
c      WRITE(6,*)'SWEEPTEST,ISWEEPSET = ',SWEEPTEST,ISWEEPSET
      IF(ISWEEPSET.EQ.0)THEN
       ISWEEPCHECK=NTASWEEP
       ISWEEPSET=1
c       WRITE(6,*)'ISWEEP 0 NTASWEEP = ',NTASWEEP
C       WRITE(6,*)'INITIAL READ XNIQ,XNIQTA = ',XNIQ,XNIQTA
       GO TO 7040
C      ELSEIF(ISWEEPSET.EQ.1.AND.NTASWEEP.EQ.ISWEEPCHECK)THEN
      ELSEIF(ISWEEPSET.EQ.1.AND.SWEEPTEST.GE.0.)THEN
c       WRITE(6,*)'ISWEEP 1 NTASWEEP = ',NTASWEEP
       GO TO 7040
C      ELSEIF(ISWEEPSET.EQ.1.AND.NTASWEEP.NE.ISWEEPCHECK)THEN
      ELSEIF(ISWEEPSET.EQ.1.AND.SWEEPTEST.LT.0.)THEN
       WRITE(6,*)'ISWEEPSET,SWEEPTEST = ',ISWEEPSET,SWEEPTEST
       WRITE(6,*)'NOT GOING BACK TO 7040'
c       WRITE(6,*)'ISWEEP 1-1 NTASWEEP = ',NTASWEEP
c       RDDIFF=RDTAIIN(IBST(1)+1)-RDTAIIN(1)
       IF(IBST(1).GE.1)THEN
        DO I=1,IBST(1)
         RDTAIIN(I)=1000.
         REF(I)=50.
         BIN(I)=-888.8
        ENDDO
       ENDIF
       DO I=IBST(1)+1,MAX_HRD_DIM
        RDTAIIN(I)=RADIITA(I)
       ENDDO
c       WRITE(6,*)'IBST(1) = ',IBST(1)
c       WRITE(6,*)'RADIITA = '
c       WRITE(6,529)(RADIITA(I),I=1,400)
c       WRITE(6,*)'RDTAIIN = '
c       WRITE(6,529)(RDTAIIN(I),I=1,400)
c       PAUSE
       IF(MAX_HRD_DIM.LT.MAX_GATES)THEN
        DO I=NBINSMAX+1,MAX_GATES
c         WRITE(6,*)'I,MAX_GATES = ',I,MAX_GATES
         RDTAIIN(I)=1000.
        ENDDO
       ENDIF
c       DO I=1,512-IBST(1)
c        RDTAIIN(I)=RADIITA(I+IBST(1))-RDDIFF
c       ENDDO
c       DO I=512-IBST(1)+1,512
c        RDTAIIN(I)=RDTAIIN(I-1)+.3
c       ENDDO
c       WRITE(6,*)'RDTAIIN = ',RDTAIIN
       ISWEEPSET=2
       ISWEEPCHECK=NTASWEEP
C      ELSEIF((ISWEEPSET.EQ.2.AND.NTASWEEP.NE.ISWEEPCHECK).
C     1        OR.NUM_RAYS.EQ.800)THEN
      ELSEIF((ISWEEPSET.EQ.2.AND.SWEEPTEST.LT.0.).
     1       OR.NUM_RAYS.EQ.799)THEN
c       WRITE(6,*)'ENDING,NTASWEEP,ISWEEPCHECK = ',
c     1                   NTASWEEP,ISWEEPCHECK
C       write(6,*)'backspacing 2 records'
C       CALL TAPECONTROL(LUNR,4,10)
       NUM_RAYS=NUM_RAYS+1
       RRLAT(NUM_RAYS)=RLAT
       RRLON(NUM_RAYS)=RLON
       RRA(NUM_RAYS)=RA
       EAZM(NUM_RAYS)=AZM
       EEV(NUM_RAYS)=EV
       TRACKSTORE(NUM_RAYS)=TRACK
       HEADSTORE(NUM_RAYS)=HEADING
       RDVWS(NUM_RAYS)=RADVWS
       TMSWEEP(NUM_RAYS)=TIME
       ISWEEPCHECK=NTASWEEP
c       WRITE(6,*)'ISWEEPCHECK SET TO ',ISWEEPCHECK
       CALL CTME1(TIME,IIHH,IIMM,IISS)
       OPEN(72,FILE='lastsweep.txt')
       WRITE(72,72726)IIHH,IIMM,IISS
72726  FORMAT('3D PROCESSING COMPLETED ON SWEEP ENDING AT ',3I2.2)
       WRITE(6,*)'SWEEP END TIME IS '
       WRITE(6,'(3I2)')IIHH,IIMM,IISS
       CALL DATE_AND_TIME(CHARDATE,CHARTIME,CHARZONE,TIMEVALUES)
       WRITE(72,72727)(TIMEVALUES(IJI),IJI=5,7),CHARDATE
       WRITE(6,72727)(TIMEVALUES(IJI),IJI=5,7),CHARDATE
72727  FORMAT('PROCESSOR TIME IS ',3I2.2,' on ',A)
       CLOSE(72)
       IF(NDO.NE.0)RETURN
c       DO I=1,512-IBST(1)
c        BINONE(I)=BIN(I+IBST(1))
c        BINONE(I)=REF(I+IBST(1))
c        REFONE(I)=REF(I+IBST(1))
c       ENDDO
c       DO I=512-IBST(1)+1,512
c        BINONE(I)=-888.8
c        REFONE(I)=-32.
c       ENDDO
       WRITE(6,*)'IYEARTAPE = ',IYEARTAPE
       IF(IPLANE.EQ.1.AND.IYEARTAPE.GE.2017)THEN
          TRAKAZM1=89.
          TRAKAZM2=271.
c          TRAKAZM1=500.
c          TRAKAZM2=-500.
          ISECONDTRIP=0
       ELSE
          TRAKAZM1=90.
          TRAKAZM2=270.
c          TRAKAZM1=500.
c          TRAKAZM2=-500.
          ISECONDTRIP=0
       ENDIF
       WRITE(6,*)'ISECONDTRIP = ',ISECONDTRIP
       IF(TRAKAZM.GT.TRAKAZM1.AND.TRAKAZM.LT.TRAKAZM2)THEN
c       WRITE(6,*)'J,RDTAIIN(1,60) = ',J,(RDTAIIN(LLL),LLL=1,60)
c       WRITE(6,*)'TIMES,TRAKAZM 0 = ',TIMES,TRAKAZM
c       WRITE(6,1039)(REF(I),I=1,200)
        IBST1=IBST(1)
        RMAXTATA=299792/2/PRF_HIGHTA
c        RMAXTATA=44.
        WRITE(6,*)'PRF_HIGHTA,RMAXTA = ',PRF_HIGHTA,RMAXTATA
        WRITE(6,*)'CALLING FIND_GROUND, AND ISECONDTRIP = ',ISECONDTRIP
        RASEND=RA
        CALL FIND_GROUND(RDTAIIN,DEG2RAD,BEAM_WID,RS_TH,RS_M,
     + DBZ_MAX,IBEG,NG2,IBST1,BIN,ISECONDTRIP,RMAXTATA,RASEND)
c       WRITE(6,*)'TRAKAZM,RS_TH,RS_M,DBZ_MAX,IBEG,NG2 = ',
c     +  TRAKAZM,RS_TH,RS_M,DBZ_MAX,IBEG,NG2
        IBEGNEW=IBEG
c        WRITE(6,*)'IBEG,IBEGNEW = ',IBEG,IBEGNEW
        REFL=-32.
        IF(IBEG.GT.1)THEN
c         DO L=1,20
c          IBEGL=IBEG-L+1
c          IF((IBEGL-1).GE.5)THEN
c          WRITE(6,*)'IBEGL,L,REF(IBEGL),REF(IBEGL-1) = ',
c     +               IBEGL,L,REF(IBEGL),REF(IBEGL-1)
c           IF(DBZBUFFER(IBEGL).GT.-31.95)REFL=DBZBUFFER(IBEGL)
c           IF(REFL.GT.-31.95.AND.DBZBUFFER(IBEGL-1).GT.-31.95)THEN
c            IF(REFL-DBZBUFFER(IBEGL-1).GT.5.)THEN
c             IBEGNEW=IBEGL
c            ENDIF
c           ENDIF
c          ENDIF
c         ENDDO
         IBEG=IBEGNEW-1
         IF(IBEG.LT.1)IBEG=1
         DO I=IBEG,NBINS
           BIN(I)=-999.9
           REF(I)=-999.9
         ENDDO
         NUMMAX=3.5*RA1000
         IF(IPLANE.EQ.2)NUMMAX=1.5*RA1000
         IF(IBEG.GT.NUMMAX)THEN
            IBEGPASS=IBEG-1
            EVPASS=EV
c            WRITE(6,*)'RA1000,NUMMAX = ',RA1000,NUMMAX
            CALL GROUNDCHECKI(REF,BIN,IBEGPASS,NBINS,EVPASS,NUMMAX)
         ENDIF
c        DO I=1,IBEG
c         IF(REF(I).GT.40.)THEN
c          WRITE(6,*)'TRAKAZM,IBEG = ',TRAKAZM,IBEG
c          WRITE(6,6927)(REF(I),DBZBUFFER(I),I=1,IBEG)
c6927      FORMAT(10F8.2)
c          GO TO 2222
c         ENDIF
c        ENDDO
C change with anxiety
C        ELSEIF(IBEG.LE.0)THEN
c***POSSIBLE SECOND TRIP
         ELSEIF(IBEG.EQ.-2)THEN
            WRITE(6,*)'I GOT TO IBEG = -2'
            DO I=1,NBINS
               IF(RADIITA(I).GT.0.)THEN
                  SECONDRADIUS=RADIITA(I)+RMAXTATA
                  POWERDIFF=(SECONDRADIUS/RADIITA(I))**4.
                  DBZPOWERDIFF=10.*ALOG10(POWERDIFF)
c        WRITE(6,*)'I,RADIITA,SECONDRADIUS,POWERDIFF,DBZPOWERDIFF = ',
c     +             I,RADIITA(I),SECONDRADIUS,POWERDIFF,DBZPOWERDIFF
               ENDIF
               DBZTEST=45.-DBZPOWERDIFF
c               WRITE(6,*)'REF(I),DBZTEST = ',REF(I),DBZTEST
c               IF(WIDTHBUFFER(I).LT..75)THEN
               IF(REF(I).LT.DBZTEST)THEN
                  ITAGSECOND(I,NUM_RAYS)=1
               ELSE
                  ITAGSECOND(I,NUM_RAYS)=0
               ENDIF
c               WRITE(6,*)'I,NUM_RAYS,ITAGSECOND = ',
c     +            I,NUM_RAYS,ITAGSECOND(I,J)
C               IF(REF(I).LT.DBZTEST)THEN
C                  BIN(I)=-999.9
C                  REF(I)=-999.9
C               ENDIF
            ENDDO
c***POSSIBLE SECOND TRIP
         ELSEIF(IBEG.LE.-1)THEN
C change with anxiety
          WRITE(6,*)'TRAKAZM, REMOVING RAY ',TRAKAZM
          DO I=1,NBINS
C change with anxiety
C          BIN(I)=-999.9
C          REF(I)=-999.9
C change with anxiety
          ENDDO 
         ENDIF
        ENDIF
c       IF(IYEARTAPE.GE.2017.AND.IPLANE.EQ.1)THEN
        DBZSUMMER=0.
        RADRES=RDTAIIN(101)-RDTAIIN(100)
c       WRITE(6,*)'TIMES,TRAKAZM 1 = ',TIMES,TRAKAZM
c       WRITE(6,1039)(REF(I),I=1,200)
 1039  FORMAT(8F10.2)
        CALL INTERVENATTEN2(REF,NBINS,RADIIATTEN,BINOUT)
        DO I=1,NBINS
           RADIUSTEST=RMAXTATA-1.
           IF(RDTAIIN(I).GT.RADIUSTEST)THEN
              BIN(I)=-888.8
              REF(I)=-32.
           ENDIF
        ENDDO
        DO I=1,MAX_GATES
C         IF(REF(I).GE.30.)DBZSUMMER=DBZSUMMER+RADRES*REF(I)*3.0
C         REFTESTSUB=DBZSUMMER/40.
C         IF(IATTENFLAG.EQ.1)REFTESTSUB=0.
         IF(REF(I).GT.-32.)THEN
            REFTESTSUB=10.**(BINOUT(I)/10)-10.**(REF(I)/10)
         ELSE
            REFTESTSUB=0.
         ENDIF
c         IF(ZR(I).LT.2.)REFTESTSUB=REFTESTSUB+
c     =                  FLOAT(IDBZMASK)*(2.-ZR(I))*0.5
c         REFTESTSUB=100.
c         IF(REF(I).GT.-32..AND.REFTESTSUB.GT.1.)
c     +    WRITE(6,*)'I,REF,REFTESTSUB = ',I,REF(I),REFTESTSUB
         RADIUSRATIO=RDTAIIN(I)*1000./RA
         ZRDIFF=ZR(I)-(RA/1000)
         IF((RADIUSRATIO.LE.RADRAT.OR.ABS(RDTAIIN(I)).LE.RADMASK).
     +     AND.ZRDIFF.LT.ZRDIFFMAX )THEN
          RADIUSDIFF=(RDTAIIN(I)-RA/1000.)
          IRADIUS1=NINT(RADIUSDIFF*10.)+110
          IRADIUS2=NINT(RDTAIIN(I)*10.)+10
          IF(IRADIUS1.GT.610.OR.IRADIUS1.LE.0)IRADIUS1=-1
          IF(IRADIUS2.GT.610.OR.IRADIUS2.LE.0)IRADIUS2=-1
          IF(TRAKAZM.LT.0.)THEN
           TRACKAZM=TRAKAZM+360.
          ELSE
           TRACKAZM=TRAKAZM
          ENDIF
          JTRAKAZM=NINT(TRACKAZM)+1
          IF(JTRAKAZM.GT.360)JTRAKAZM=1
c       WRITE(6,*)'I,J,RA,RDTAIIN(I),TRAKAZM,IRADIUS,JTRAKAZM = ',
c     1            I,J,RA,RDTAIIN(I),TRAKAZM,IRADIUS,JTRAKAZM
          IF(REF(I).GT.-32..AND.IRADIUS1.GT.0.AND.IRADIUS1.LE.610
     1       .AND.JTRAKAZM.GT.JTRAKAZMMIN.AND.
     1        JTRAKAZM.LT.JTRAKAZMMAX)THEN
c          REFTEST1=AVGDBZ1(IRADIUS1,JTRAKAZM)
           REFTEST2=AVGDBZ1(IRADIUS1,JTRAKAZM)+FLOAT(IDBZMASK)
           REFTEST102A=10.**(REFTEST2/10.)-REFTESTSUB
c          REFTEST101A=10.**(REFTEST1/10.)+10.**(FLOAT(IDBZMASK)/10.)
c     +     -REFTESTSUB
           RATEST=RA/1000.
c          IF(RDTAIIN(I).GT.2.*RATEST)THEN
c          IF(RDTAIIN(I).GT.10.)THEN
c          IF(REFTEST101A.LT.REFTEST102A)THEN
c             REFTEST10A=REFTEST101A
c          ELSE
c             REFTEST10A=REFTEST102A
c          ENDIF
c            REFTEST=AVGDBZ1(IRADIUS1,JTRAKAZM)+FLOAT(IDBZMASK)-
c     +             REFTESTSUB
c           IF(REF(I).LT.REFTEST)THEN
           REFTEST10B=10.**(REF(I)/10.)
           IF(REFTEST10B.LT.REFTEST102A.AND.IAPPLYMASK.EQ.1)THEN
            REF(I)=-32.
            BIN(I)=-999.9
           ENDIF
C         NUM1(IRADIUS,JTRAKAZM)=NUM1(IRADIUS,JTRAKAZM)+1
C         DBZSUMMER(IRADIUS,JTRAKAZM)=DBZSUMMER(IRADIUS,JTRAKAZM)
C     1    +REF(I)
          ENDIF
          IF(REF(I).GT.-32..AND.IRADIUS2.GT.0.AND.IRADIUS2.LE.610
     1       .AND.JTRAKAZM.GT.JTRAKAZMMIN.AND.
     1        JTRAKAZM.LT.JTRAKAZMMAX)THEN
           REFTEST=AVGDBZ2(IRADIUS2,JTRAKAZM)+FLOAT(IDBZMASK)-
     1             REFTESTSUB
           IF(REF(I).LT.REFTEST.AND.IAPPLYMASK.EQ.1)THEN
            REF(I)=-32.
            BIN(I)=-999.9
           ENDIF
C         NUM1(IRADIUS,JTRAKAZM)=NUM1(IRADIUS,JTRAKAZM)+1
C         DBZSUMMER(IRADIUS,JTRAKAZM)=DBZSUMMER(IRADIUS,JTRAKAZM)
C     1    +REF(I)
          ENDIF
         ENDIF
        ENDDO
c       WRITE(6,*)'TIMES,TRAKAZM 2 = ',TIMES,TRAKAZM
c       WRITE(6,1039)(REF(I),I=1,200)
c       ENDIF
       GO TO 2000
      ENDIF
      IF(NDO.NE.0)GO TO 7040
      IF(IFRANCENO.EQ.1.AND.ABS(ELEV).LT..001)GO TO 7040
      NUM_RAYS=NUM_RAYS+1
      IF(NIX.EQ.-100)GO TO 2000
      RRLAT(NUM_RAYS)=RLAT
      RRLON(NUM_RAYS)=RLON
      RRA(NUM_RAYS)=RA
      EAZM(NUM_RAYS)=AZM
      EEV(NUM_RAYS)=EV
      TRACKSTORE(NUM_RAYS)=TRACK
      HEADSTORE(NUM_RAYS)=HEADING
      RDVWS(NUM_RAYS)=RADVWS
      TMSWEEP(NUM_RAYS)=TIME
c      NBINS=MAX_GATES
c      write(6,*)'num_rays = ',num_rays
      IF(IPLANE.EQ.1.AND.IYEARTAPE.GE.2017)THEN
         TRAKAZM1=89.
         TRAKAZM2=271.
c         TRAKAZM1=500.
c         TRAKAZM2=-500.
         ISECONDTRIP=0
      ELSE
         TRAKAZM1=90.
         TRAKAZM2=270.
c         TRAKAZM1=500.
c         TRAKAZM2=-500.
         ISECONDTRIP=0
      ENDIF
      RMAXTATA=299792/2/PRF_HIGHTA
      IF(TRAKAZM.GT.TRAKAZM1.AND.TRAKAZM.LT.TRAKAZM2)THEN
c       WRITE(6,*)'J,RDTAIIN(1,60) = ',J,(RDTAIIN(LLL),LLL=1,60)
c       WRITE(6,*)'TIMES,TRAKAZM 0 = ',TIMES,TRAKAZM
c       WRITE(6,1039)(REF(I),I=1,200)
       IBST1=IBST(1)
        RMAXTATA=299792/2/PRF_HIGHTA
c        RMAXTATA=44.
c        WRITE(6,*)'PRF_HIGHTA,RMAXTA = ',PRF_HIGHTA,RMAXTATA
c        WRITE(6,*)'CALLING FIND_GROUND, AND ISECONDTRIP = ',ISECONDTRIP
c        WRITE(6,*)'RMAXTATA = ',RMAXTATA
       RASEND=RA
       CALL FIND_GROUND(RDTAIIN,DEG2RAD,BEAM_WID,RS_TH,RS_M,
     + DBZ_MAX,IBEG,NG2,IBST1,BIN,ISECONDTRIP,RMAXTATA,RASEND)
c       WRITE(6,*)'TRAKAZM,TIME,RS_TH,RS_M,DBZ_MAX,IBEG,NG2 = ',
c     +  TRAKAZM,TMSWEEP(NUM_RAYS),RS_TH,RS_M,DBZ_MAX,
c     +  IBEG,NG2
       IBEGNEW=IBEG
c        WRITE(6,*)'IBEG,IBEGNEW = ',IBEG,IBEGNEW
       REFL=-32.
       IF(IBEG.GT.0)THEN
c        DO L=1,20
c         IBEGL=IBEG-L+1
c         IF((IBEGL-1).GE.5)THEN
cc          WRITE(6,*)'IBEGL,L,REF(IBEGL),REF(IBEGL-1) = ',
cc     +               IBEGL,L,REF(IBEGL),REF(IBEGL-1)
c          IF(DBZBUFFER(IBEGL).GT.-31.95)REFL=DBZBUFFER(IBEGL)
c          IF(REFL.GT.-31.95.AND.DBZBUFFER(IBEGL-1).GT.-31.95)THEN
c           IF(REFL-DBZBUFFER(IBEGL-1).GT.5.)THEN
c            IBEGNEW=IBEGL
c           ENDIF
c          ENDIF
c         ENDIF
c        ENDDO
c        IBEG=IBEGNEW-100
        IBEG=IBEGNEW-1
        IF(IBEG.LT.1)IBEG=1
        DO I=IBEG,NBINS
         BIN(I)=-999.9
         REF(I)=-999.9
        ENDDO
        NUMMAX=3.5*RA1000
        IF(IPLANE.EQ.2)NUMMAX=1.5*RA1000
        IF(IBEG.GT.NUMMAX)THEN
           IBEGPASS=IBEG-1
           EVPASS=EV
c           WRITE(6,*)'RA1000,NUMMAX = ',RA1000,NUMMAX
           CALL GROUNDCHECKI(REF,BIN,IBEGPASS,NBINS,EVPASS,NUMMAX)
        ENDIF
        IBEGDONE=IBEG-NG2-1
        I=IBEG-1
        DO WHILE(I.GT.0.AND.I.GT.IBEGDONE)
c         IF(BIN(I).LT.-800.)REF(I)=-999.9
         I=I-1
        ENDDO
c        DO I=1,IBEG
c         IF(REF(I).GT.40.)THEN
c          WRITE(6,*)'TRAKAZM,IBEG = ',TRAKAZM,IBEG
c          WRITE(6,6927)(REF(I),DBZBUFFER(I),I=1,IBEG)
c6927      FORMAT(10F8.2)
c          GO TO 2222
c         ENDIF
c        ENDDO
c change with anxiety
C       ELSEIF(IBEG.LE.0.AND.(TRAKAZM.GT.91..AND.TRAKAZM.LT.269.))THEN
c***POSSIBLE SECOND TRIP
C TURN OFF FOR NOW BY USING AN UNUSED VALE FOR IBEG
       ELSEIF(IBEG.EQ.-2)THEN
            WRITE(6,*)'I GOT TO IBEG = -2'
            DO I=1,NBINS
               IF(RADIITA(I).GT.0.)THEN
                  SECONDRADIUS=RADIITA(I)+RMAXTATA
                  POWERDIFF=(SECONDRADIUS/RADIITA(I))**4.
                  DBZPOWERDIFF=10.*ALOG10(POWERDIFF)
c        WRITE(6,*)'I,RADIITA,SECONDRADIUS,POWERDIFF,DBZPOWERDIFF = ',
c     +             I,RADIITA(I),SECONDRADIUS,POWERDIFF,DBZPOWERDIFF
               ENDIF
               DBZTEST=45.-DBZPOWERDIFF
c               WRITE(6,*)'REF(I),DBZTEST = ',REF(I),DBZTEST
C               IF(WIDTHBUFFER(I).LT..75)THEN
               IF(REF(I).LT.DBZTEST)THEN
                  ITAGSECOND(I,NUM_RAYS)=1
               ELSE
                  ITAGSECOND(I,NUM_RAYS)=0
               ENDIF
c               WRITE(6,*)'I,NUM_RAYS,ITAGSECOND = ',
c     +            I,NUM_RAYS,ITAGSECOND(I,J)
C                  BIN(I)=-999.9
C                  REF(I)=-999.9
C               ENDIF
            ENDDO
c***POSSIBLE SECOND TRIP
       ELSEIF(IBEG.EQ.-1.AND.(TRAKAZM.GT.91..AND.TRAKAZM.LT.269.))THEN
c change with anxiety
        WRITE(6,*)'TRAKAZM, REMOVING RAY ',TRAKAZM
c change with anxiety
        DO I=1,NBINS
c change with anxiety
c         BIN(I)=-999.9
c         REF(I)=-999.9
c change with anxiety
        ENDDO 
       ENDIF
      ENDIF
c      IF(IYEARTAPE.GE.2017.AND.IPLANE.EQ.1)THEN
       DBZSUMMER=0.
       RADRES=RDTAIIN(41)-RDTAIIN(40)
c       WRITE(6,*)'TIMES,TRAKAZM 1 = ',TIMES,TRAKAZM
c       WRITE(6,1039)(REF(I),I=1,200)
       CALL INTERVENATTEN2(REF,NBINS,RADIIATTEN,BINOUT)
       DO I=1,NBINS
          RADIUSTEST=RMAXTATA-1.
          IF(RDTAIIN(I).GT.RADIUSTEST)THEN
             BIN(I)=-888.8
             REF(I)=-32.
          ENDIF
       ENDDO
C       WRITE(6,*)(I,REF(I),BINOUT(I),I=1,500)
       DO I=1,MAX_GATES
C        IF(REF(I).GE.30.)DBZSUMMER=DBZSUMMER+RADRES*REF(I)*3.0
C        REFTESTSUB=DBZSUMMER/40.
C        IF(IATTENFLAG.EQ.1)REFTESTSUB=0.
        IF(REF(I).GT.-32.)THEN
c           REFTESTSUB=(BINOUT(I)-REF(I))*2.
           REFTESTSUB=10.**(BINOUT(I)/10)-10.**(REF(I)/10)
        ELSE
           REFTESTSUB=0.
        ENDIF
c        REFTESTSUB=100.
c        IF(REF(I).GT.-32..AND.REFTESTSUB.GT.1.)
c     +    WRITE(6,*)'I,REF,REFTESTSUB = ',I,REF(I),REFTESTSUB
        RADIUSRATIO=RDTAIIN(I)*1000./RA
        ZRDIFF=ZR(I)-(RA/1000)
c        IF(RADIUSRATIO.LE.3.OR.ABS(RDTAIIN(I)).LE.10.)THEN
        IF((RADIUSRATIO.LE.RADRAT.OR.ABS(RDTAIIN(I)).LE.RADMASK).
     +     AND.ZRDIFF.LT.ZRDIFFMAX)THEN
         RADIUSDIFF=(RDTAIIN(I)-RA/1000.)
         IRADIUS1=NINT(RADIUSDIFF*10.)+110
         IRADIUS2=NINT(RDTAIIN(I)*10.)+10
         IF(IRADIUS1.GT.610.OR.IRADIUS1.LE.0)IRADIUS1=-1
         IF(IRADIUS2.GT.610.OR.IRADIUS2.LE.0)IRADIUS2=-1
         IF(TRAKAZM.LT.0.)THEN
          TRACKAZM=TRAKAZM+360.
         ELSE
          TRACKAZM=TRAKAZM
         ENDIF
         JTRAKAZM=NINT(TRACKAZM)+1
         IF(JTRAKAZM.GT.360)JTRAKAZM=1
c       WRITE(6,*)'I,J,RA,RDTAIIN(I),TRAKAZM,IRADIUS,JTRAKAZM = ',
c     1            I,J,RA,RDTAIIN(I),TRAKAZM,IRADIUS,JTRAKAZM
          IF(REF(I).GT.-32..AND.IRADIUS1.GT.0.AND.IRADIUS1.LE.610
     1       .AND.JTRAKAZM.GT.JTRAKAZMMIN.AND.
     1        JTRAKAZM.LT.JTRAKAZMMAX)THEN
c          REFTEST=AVGDBZ1(IRADIUS1,JTRAKAZM)+FLOAT(IDBZMASK)-
c     +            REFTESTSUB
c          IF(REF(I).LT.REFTEST)THEN
c          REFTEST1=AVGDBZ1(IRADIUS1,JTRAKAZM)
          REFTEST2=AVGDBZ1(IRADIUS1,JTRAKAZM)+FLOAT(IDBZMASK)
          REFTEST102A=10.**(REFTEST2/10.)-REFTESTSUB
c          REFTEST101A=10.**(REFTEST1/10.)+10.**(FLOAT(IDBZMASK)/10.)
c     +     -REFTESTSUB
          RATEST=RA/1000.
c          IF(RDTAIIN(I).GT.2.*RATEST)THEN
c          IF(RDTAIIN(I).GT.10.)THEN
c          IF(REFTEST101A.LT.REFTEST102A)THEN
c             REFTEST10A=REFTEST101A
c          ELSE
c             REFTEST10A=REFTEST102A
c          ENDIF
C          WRITE(6,*)'REFTEST1,REFTEST2 = ',REFTEST1,REFTEST2
C          WRITE(6,*)
C     +      'RADIUS,RATEST,REFTEST101A,REFTEST102A,REFTEST10A = ',
C     +       RDTAIIN(I),RATEST,REFTEST101A,REFTEST102A,REFTEST10A
c          REFTEST=AVGDBZ1(IRADIUS1,JTRAKAZM)+FLOAT(IDBZMASK)
c          REFTEST10A=(10.**(REFTEST/10.))-REFTESTSUB
          REFTEST10B=10.**(REF(I)/10.)
          IF(REFTEST10B.LT.REFTEST102A.AND.IAPPLYMASK.EQ.1)THEN
           REF(I)=-32.
           BIN(I)=-999.9
          ENDIF
C         NUM1(IRADIUS,JTRAKAZM)=NUM1(IRADIUS,JTRAKAZM)+1
C         DBZSUMMER(IRADIUS,JTRAKAZM)=DBZSUMMER(IRADIUS,JTRAKAZM)
C     1    +REF(I)
         ENDIF
          IF(REF(I).GT.-32..AND.IRADIUS2.GT.0.AND.IRADIUS2.LE.610
     1       .AND.JTRAKAZM.GT.JTRAKAZMMIN.AND.
     1        JTRAKAZM.LT.JTRAKAZMMAX)THEN
          REFTEST=AVGDBZ2(IRADIUS2,JTRAKAZM)+FLOAT(IDBZMASK)-
     +            REFTESTSUB
          IF(REF(I).LT.REFTEST.AND.IAPPLYMASK.EQ.1)THEN
           REF(I)=-32.
           BIN(I)=-999.9
          ENDIF
C         NUM1(IRADIUS,JTRAKAZM)=NUM1(IRADIUS,JTRAKAZM)+1
C         DBZSUMMER(IRADIUS,JTRAKAZM)=DBZSUMMER(IRADIUS,JTRAKAZM)
C     1    +REF(I)
         ENDIF
        ENDIF
       ENDDO
c       WRITE(6,*)'TIMES,TRAKAZM 2 = ',TIMES,TRAKAZM
c       WRITE(6,1039)(REF(I),I=1,200)
c      ENDIF
c      WRITE(6,*)'TIME,TRAKAZM,REF = ',TIME,TRAKAZM,(REF(I),I=1,512)      
c      IF (TIME.GT.ETIME .OR. NIX.EQ.-100)GO TO 2000
      IF (NIX.EQ.-100)GO TO 2000
      IF (TAPE .EQ. 'Y') THEN 
c          call radartaperewind(lunr)
          write(6,*)'should not get here'
          stop
          WRITE(6,'("Change Radar Tape; RETURN to continue")')
C 7060      PAUSE
 7060     WRITE(6,*)'1-continue, 2-pause ',nn
          READ(5,*,err=7060) irewind
          if (irewind .ne. 1) go to 7060
          TAPE='N'
          GO TO 7040
      ENDIF 
C 
C Write Radar Information To Disk  
      ITIME=TIME
C      WRITE(83,IOSTAT=IERR,ERR=1040) TIME,RLAT,RLON,RA,RADAZM,ELEV,
C     +                 (BIN(I),I=1,512)
c      WRITE(6,*)'TIME,RLAT,RLON,RA,AZM,EV = ',
c     +   TIME,RLAT,RLON,RA,AZM,EV
c      WRITE(6,*)'PRF_FLAGTA,PRF_HIGHTA = ',PRF_FLAGTA,PRF_HIGHTA
c      WRITE(6,*)'XNIQ,XNIQTA = ',XNIQ,XNIQTA
c      WRITE(6,*)'NTASWEEP = ',NTASWEEP
c      write(6,*)'num_rays = ',num_rays
      AZ_EL(1,NUM_RAYS)=TRAKAZM
      AZ_EL(2,NUM_RAYS)=TRAKELEV
      PELEV(NUM_RAYS)=ELEV
      PAZM(NUM_RAYS)=RADAZM
c      WRITE(6,*)'NUM_RAYS,AZIMUTH,ELEVATION,V0 = ',
c     1           NUM_RAYS,AZ_EL(1,NUM_RAYS),AZ_EL(2,NUM_RAYS),V0
c      WRITE(6,*)'GSE,GSN,UCOM,VCOM = ',GSE,GSN,UCOM,VCOM
c      WRITE(6,*)'RADLAT,RADLON,EV,AZM = ',RADLAT,RADLON,EV,AZM
      V0SAVE(NUM_RAYS)=V0
      IF(IBST(1).GE.1)THEN
       DO I=1,IBST(1)
        BIN(I)=-888.8
        REF(I)=-32.
       ENDDO
      ENDIF
      DO I=1,NBINS
       SWEEP(I,NUM_RAYS)=BIN(I)
c       SWEEP(I,NUM_RAYS)=BIN(I+IBST(1))
       SWEEPZ(I,NUM_RAYS)=REF(I)
c       IF(BIN1(I).NE.BIN(I))THEN
c        WRITE(6,'(I5,3F10.4)')I,VELBUFFER(I),BIN1(I),BIN(I)
c       ENDIF
      ENDDO
      IF(NBINS.LT.MAX_GATES)THEN
       DO I=NBINS+1,MAX_GATES
        SWEEP(I,NUM_RAYS)=-888.8
        SWEEPZ(I,NUM_RAYS)=-32.
       ENDDO
      ENDIF
c      WRITE(6,'(10F8.2)')(SWEEPZ(I,NUM_RAYS),I=1,100)
c      if(az_el(1,num_rays).gt.85..and.az_el(1,num_rays).lt.86.)then
c       write(6,*)'sweep = ',(sweep(i,num_rays),i=1,512)
c      endif
c      WRITE(6,*)'I,BIN,SWEEP = ',I,(SWEEP(I,NUM_RAYS),I=1,512)
C      IF(RADAZM.GT.270..AND.RADAZM.LT.277.)THEN
c       WRITE(6,*)'RADAZM,rdelta,ngate1,v0 = ',RADAZM,rdelta,ngate1,v0
C       WRITE(6,'(9F8.2)')(BIN(I),REF(I),WIDTHBUFFER(I),I=1,512)
C      ENDIF
C      WRITE(6,5674)(I,VELBUFFER(I),BIN1(I),BIN(I),I=42,100)
C      WRITE(6,5675)(I,SWEEPZ(I,NUM_RAYS),I=42,200)
C      WRITE(6,5675)(I,WIDTHBUFFER(I),I=42,200)
C5674  FORMAT(3(I4,3F10.4))
C 5674 FORMAT(3(I4,3F10.4))
C 5675 FORMAT(12(I4,F10.4))
      IF (MOD(ITIME,60).EQ.0 .AND. itime.NE.OLDTIME) THEN
         CALL CTME1(TIME,IH,IM,IS)
         WRITE(6,'(" Writing: ",3i2.2,1x,2(f8.3,1x),3(f12.4,1x))')
     +        IH,IM,IS,RLAT,RLON,RA,AZM,EV
      ENDIF
      OLDTIME=ITIME
c      WRITE(6,*)'GO TO 7040'
      GO TO 7040
C 
C <<<<<<Error Conditions<<<<<<
970   WRITE(LP,'(1X," Error searching for start time:",i6)') IERR
      GO TO 2000
998   WRITE(LP,'(1X,"Error Opening Input File: ",A,1X,"IERR= ",I6)')
     +      IFILE,IERR
      GO TO 2000
999   WRITE(LP,'(1X,"Bad Input Data",I4)') IERR 
      GO TO 2000
1000  WRITE(LP,1030)IERR,NAMEO
1030  FORMAT(1X,'Error on Creating Output File= ',I5,1X,A) 
      GO TO 2000
1040  WRITE(LP,1045)IERR,NAMEO
1045  FORMAT(1X,'Error on Write= ',I5,1X,A)
      GO TO 2000
1050  WRITE(LP,'("Error on opening Ram File: ",I5,1X,A80)') IERR,NAMERAM
2000  NUM_RAYS=NUM_RAYS-1
      NBINS=NBINSMAX
      IF(NUM_RAYS.GT.0)THEN
c       WRITE(6,*)'AZ_EL = '
c       WRITE(6,'(10F8.2)')(AZ_EL(1,J),J=1,NUM_RAYS)
c       WRITE(6,*)'PAZM = ',(PAZM(J),J=1,NUM_RAYS)
c       WRITE(6,*)'AZ_EL = ',(AZ_EL(1,J),J=1,NUM_RAYS)
c       WRITE(6,*)'VOSAVE = '
c       WRITE(6,591)(V0SAVE(J),J=1,NUM_RAYS)
 591   FORMAT(15F9.2)
       DO I=1,2
        DO J=1,NUM_RAYS
         AZEL(I,J)=AZ_EL(I,J)
        ENDDO
       ENDDO
c       WRITE(6,*)'AZEL = '
c       WRITE(6,'(10F8.1)')(AZEL(1,J),J=1,NUM_RAYS)
       CALL AZISORT(NUM_RAYS,AZ_EL,RDVWS)
       CALL AZISORT(NUM_RAYS,AZ_EL,PAZM)
       CALL AZISORT(NUM_RAYS,AZ_EL,PELEV)
       CALL AZISORT(NUM_RAYS,AZ_EL,EAZM)
       CALL AZISORT(NUM_RAYS,AZ_EL,EEV)
       CALL AZISORT(NUM_RAYS,AZ_EL,RRLAT)
       CALL AZISORT(NUM_RAYS,AZ_EL,RRLON)
       CALL AZISORT(NUM_RAYS,AZ_EL,RRA)
       CALL AZISORT(NUM_RAYS,AZ_EL,TMSWEEP)
       CALL AZISORT(NUM_RAYS,AZ_EL,V0SAVE)
       CALL AZISORT(NUM_RAYS,AZ_EL,TRACKSTORE)
       CALL AZISORT(NUM_RAYS,AZ_EL,HEADSTORE)
       CALL IAZISORT(NUM_RAYS,AZ_EL,IAZM)
       NUMI=2
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,AZEL)
       NUMI=MAX_GATES
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,SWEEPVT)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,UNFVEL)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,TMP1)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,TMP2)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,SWEEP)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,SWEEPSAVE)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,VRRAD)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,NYQ)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,VROUT)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,XRSWEEP)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,YRSWEEP)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,ZRSWEEP)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,RADSWEEP)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,XRMIN)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,YRMIN)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,ZRMIN)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,XRMAX)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,YRMAX)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,ZRMAX)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,AZMIN)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,AZMAX)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,SWEEPZ)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,ZDIFF)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,ZRMIN)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,ZRMAX)
       CALL IAZISORT2(NUMI,NUM_RAYS,AZ_EL,ITAGSECOND)
       CALL IAZISORT2(NUMI,NUM_RAYS,AZ_EL,JINDEX)
       CALL IAZISORT2(NUMI,NUM_RAYS,AZ_EL,JIINDEX)
       CALL IAZISORT2(NUMI,NUM_RAYS,AZ_EL,ISEG)
       CALL IAZISORT2(NUMI,NUM_RAYS,AZ_EL,ISEGB)
       CALL IAZISORT2(NUMI,NUM_RAYS,AZ_EL,ISEGE)
       CALL IAZISORT2(NUMI,NUM_RAYS,AZ_EL,IKEEP)
       CALL IAZISORT2(NUMI,NUM_RAYS,AZ_EL,ISWEEP)
c      WRITE(6,*)'JUST AFTER RAY SORTING'
c      DO J=1,NUM_RAYS
c       WRITE(6,*)'J SWEEP = ',J
c       WRITE(6,7777)(SWEEP(I,J),I=1,NBINS)
c       WRITE(6,*)'J SWEEPZ = ',J
c       WRITE(6,7777)(SWEEPZ(I,J),I=1,NBINS)
c      ENDDO
c      WRITE(6,*)'AZEL = '
c      WRITE(6,'(10F8.1)')(AZEL(1,J),J=1,NUM_RAYS)
c      WRITE(6,*)'TMSWEEP = '
c      WRITE(6,'(10F8.1)')(TMSWEEP(J),J=1,NUM_RAYS)
       DO I=1,2
        DO J=1,NUM_RAYS
         AZ_EL(I,J)=AZEL(I,J)
        ENDDO
       ENDDO
c       WRITE(6,*)'PAZM = ',(PAZM(J),J=1,NUM_RAYS)
c       WRITE(6,*)'AZ_EL = ',(AZ_EL(1,J),J=1,NUM_RAYS)
      ENDIF
      IF(IBST(1).GE.1)THEN
       DO I=1,IBST(1)
        RDTAIIN(I)=1000.
       ENDDO
      ENDIF
      DO I=IBST(1)+1,NBINSMAX
       RDTAIIN(I)=RADIITA(I)
      ENDDO
C
C THIS IS A NEW TEST FOR RADAR ALTITUDE RING
C
      IF(IALTRINGREMOVE.EQ.1)THEN
         WRITE(6,*)'REMOVING ALTITUDE RING'
         DO I=NBINS,1,-1
            RARATIO=RDTAIIN(I)*1000./RA
            IF(RARATIO.GT.2.0.AND.RDTAIIN(I).LT.999.)NBINSUSE=I
         ENDDO
         IF(IAFTFORE.EQ.1)THEN
            RARATIO1=.3
            RARATIO2=.8
            RARATIO3=1.5
            RARATIO4=2.0
         ELSE
            RARATIO1=.5
            RARATIO2=1.0
            RARATIO3=1.5
            RARATIO4=2.0
         ENDIF
         DO J=1,NUM_RAYS
            SUMDBZIN=0.
            NSUMDBZIN=0
            SUMDBZAT=0.
            NSUMDBZAT=0
            SUMDBZOUT=0.
            NSUMDBZOUT=0.
            DO I=1,NBINSUSE
               RARATIO=RDTAIIN(I)*1000./RA
c          WRITE(6,*)'I,RALT,RDTAIIN,RARATIO = ',
c     +               I,RALT,RDTAIIN(I),RARATIO
               IF(RARATIO.GT.RARATIO1.AND.RARATIO.LT.RARATIO2)THEN
                  SUMDBZIN=SUMDBZIN+SWEEPZ(I,J)
                  NSUMDBZIN=NSUMDBZIN+1
               ELSEIF(RARATIO.GE.RARATIO2.AND.RARATIO.LE.RARATIO3)THEN
                  SUMDBZAT=SUMDBZAT+SWEEPZ(I,J)
                  NSUMDBZAT=NSUMDBZAT+1
               ELSEIF(RARATIO.GT.RARATIO3.AND.RARATIO.LT.RARATIO4)THEN
                  SUMDBZOUT=SUMDBZOUT+SWEEPZ(I,J)
                  NSUMDBZOUT=NSUMDBZOUT+1
                  IF(ZRSWEEP(I,J).LT..5)THEN
                     NSUMDBZOUT=NSUMDBZOUT+1
                     SUMDBZOUT=SUMDBZOUT+100.
                  ELSE
                     SUMDBZOUT=SUMDBZOUT+SWEEPZ(I,J)
                     NSUMDBZOUT=NSUMDBZOUT+1
                  ENDIF
               ENDIF
            ENDDO
            DBZIN=SUMDBZIN/NSUMDBZIN
            DBZOUT=SUMDBZOUT/NSUMDBZOUT
            DBZAT=SUMDBZAT/NSUMDBZAT
c         WRITE(6,*)'DBZIN,DBZAT,DBZOUT = ',DBZIN,DBZAT,DBZOUT
            IF(DBZAT.GT.DBZIN+4..AND.DBZAT.GT.DBZOUT+4.)THEN
               DO I=1,NBINSUSE
                  RARATIO=RDTAIIN(I)*1000./RA
                  IF(RARATIO.GE.RARATIO2.AND.RARATIO.LE.RARATIO3)THEN
                     SWEEP(I,J)=-888.8
                     SWEEPZ(I,J)=-32.
                  ENDIF
               ENDDO
            ENDIF
         ENDDO
      ENDIF
C
C END OF RING ADDITION
C
c       WRITE(6,*)'NBINSMAX = ',NBINSMAX
c       DO I=1,400
c        WRITE(6,*)'I, RADIITA,RDTAIIN = ',I,RADIITA(I),RDTAIIN(I)
c       ENDDO
c      pause
      IF(NBINSMAX.LT.MAX_GATES)THEN
       DO I=NBINSMAX+1,MAX_GATES
c         WRITE(6,*)'I,MAX_GATES = ',I,MAX_GATES
        RDTAIIN(I)=1000.
       ENDDO
      ENDIF
      if(num_rays.ge.1)then
       radvwmax=0.
       sumvw=0.
       do j=1,num_rays
        radvwtest=abs(rdvws(j))
        if(abs(radvwtest).gt.100.)then
         do i=1,nbins
          sweep(i,j)=-999.9
         enddo
        else
         sumvw=sumvw+rdvws(j)
         ssumvw=ssumvw+1
c         write(6,*)'j,rdvws,radvwtest,radvwmax = ',j,rdvws(j),
c     1   radvwtest,radvwmax
         if(radvwtest.gt.radvwmax)radvwmax=radvwtest
        endif
       enddo
       if(ssumvw.gt.0)then
        radvwmean=sumvw/ssumvw
       else
        radvwmean=999.9
       endif
       radvwmean=abs(radvwmean)
       if(radvwmax.gt.30..or.radvwmean.gt.15.)then
        do j=1,num_rays
         do i=1,nbins
          sweep(i,j)=-888.8
         enddo
        enddo
       endif
      endif
c      write(6,*)'num_rays = ',num_rays
c      pause
C      DO J=1,NUM_RAYS
C       WRITE(6,*)'BEFORE,J,EEV,SWEEP(1,10),SWEEPZ(1,10) = ',
C     + J,EEV(J),(SWEEP(I,J),I=1,10),(SWEEPZ(I,J),I=1,10)
C      ENDDO
c      WRITE(6,*)'RA = ',RA
      IF(RA.GT.0..AND.RA.LT.15000.)THEN
       RATEST=RA/1000.
      ELSE
       RATEST=RATESTOLD
      ENDIF
      RATESTOLD=RATEST
c      WRITE(6,*)'RATEST,RA = ',RATEST,RA
      JSTART=0
c      write(6,*)'i got here 1'
c      pause
c      DO J=1,NUM_RAYS
c       IF(AZ_EL(1,J).GT.90..AND.AZ_EL(1,J).LT.271.)THEN
c        JSTART=J
c        GO TO 18187
c       ENDIF
c      ENDDO
c      GO TO 19187
c18187 JEND=0
      JEND=0
c      write(6,*)'i got here 2'
c      pause
      DO J=JSTART+1,NUM_RAYS
       IF(AZ_EL(1,J).GT.270.)THEN
        JEND=J-1
        GO TO 18181
       ENDIF
      ENDDO
c18181 WRITE(6,*)'JSTART,JEND SET TO ',JSTART,JEND
18181 CONTINUE
c      pause
      IRINSIDE=0
      IROUTSIDE=NBINS
      RADIFFTEST=1.
      IF(IPLANE.EQ.2)RADIFFTEST=1.
c      WRITE(6,*)'NBINS,IROUTSIDE = ',NBINS,IROUTSIDE
c      WRITE(6,*)'RATEST = ',RATEST
c      pause
      DO I=IBST(1)+1,NBINS
       RALTDIFF=RDTAIIN(I)-RATEST
       IF(RALTDIFF.GT.-RADIFFTEST.AND.IRINSIDE.EQ.0)THEN
        IRINSIDE=I
       ENDIF
c       WRITE(6,*)'I,RDTAIIN,RATEST,RALTDIFF,RADIFFTEST,IRINSIDE = ',
c     1  I,RDTAIIN(I),RATEST,RALTDIFF,RADIFFTEST,IRINSIDE
      IF(RALTDIFF.GT.RADIFFTEST)THEN
C .AND.RDTAIIN(I).GT.3.)THEN
        IROUTSIDE=I-1
c        pause
        GO TO 18182
       ENDIF
      ENDDO
c      write(6,*)'i got here 3'
c      pause
18182 CONTINUE
      WRITE(6,*)'IRINSIDE,IROUTSIDE = ',IRINSIDE,IROUTSIDE
c      PAUSE
c      WRITE(6,*)'NBINS,IRINSIDE,IROUTSIDE = ',NBINS,IRINSIDE,IROUTSIDE
c      WRITE(6,*)'RATEST = ',RATEST
c      SUMNDBZ=0.
c      SUMRDBZ=0.
c      ALT2=RATEST*2.
c      RADIITEST1=RATEST*1.5
c      RADIITEST2=RATEST*2.5
c      DO J=1,NUM_RAYS       
c       DO I=1,200
c        IF(ZRSWEEP(I,J).GT.1.AND.ZRSWEEP(I,J).LE.ALT2.AND.
c     1  RDTAIIN(I).GT.RADIITEST1.AND.RDTAIIN(I).LE.RADIITEST2)THEN
c         IF(SWEEPZ(I,J).GT.-32.)THEN
c          ZTEST=10.**(SWEEPZ(I,J)/10.)
c         ELSE
c          ZTEST=0.
c         ENDIF
c         SUMNDBZ=SUMNDBZ+1.
c         SUMRDBZ=SUMRDBZ+ZTEST
c        ENDIF
c       ENDDO
c      ENDDO
c      IF(SUMRDBZ.GT.0.0001.AND.SUMNDBZ.GT.0.00001)THEN
c       ZTEST=SUMRDBZ/SUMNDBZ
c      ELSE
c       ZTEST=0.
c      ENDIF
c      WRITE(6,*)SUMNDBZ,SUMRDBZ,ZTEST
c      WRITE(6,*)RATEST,RADIITEST1,RADIITEST2
c      IF(ZTEST.LT.20.)THEN
c       WRITE(6,*)'REMOVE DATA INSIDE ',IROUTSIDE
c       DO I=1,200
c        DO J=1,NUM_RAYS
c         IF(RDTAIIN(I).LE.RADIITEST2.AND.ZRSWEEP(I,J).LE.ALT2)THEN
c          SWEEP(I,J)=-999.9
c          SWEEPZ(I,J)=-32.0
c         ENDIF
cc         WRITE(6,*)I,J,SWEEP(I,J),SWEEPZ(I,J)
c        ENDDO
c       ENDDO
c      ELSE
c       WRITE(6,*)'KEEP DATA'
c      ENDIF
c      IF(IPLANE.EQ.1)THEN
      DO I=1,NBINS
         DO J=1,NUM_RAYS
c            WRITE(6,*)'I,J,ITAGSECOND = ',I,J,ITAGSECOND(I,J)
c            IF(ITAGSECOND(I,J).EQ.1)THEN
            IF(ITAGSECOND(I,J).EQ.1.AND.ISIGMET.EQ.8)THEN
               IF(PAZM(J).GT.0.AND.PAZM(J).LT.180.0)THEN
                  IF(SWEEPZ(I,J-1).GT.-32.)THEN
                     IF(ABS(SWEEPZ(I,J)-SWEEPZ(I,J-1)).GT.5.)THEN
                        SWEEPZ(I,J)=-32.
                        SWEEP(I,J)=-888.8
                     ENDIF
                  ELSE
                     SWEEPZ(I,J)=-32.
                     SWEEP(I,J)=-888.8
                  ENDIF
               ENDIF
            ENDIF
         ENDDO
      ENDDO
      DO I=1,NBINS
         DO J=NUM_RAYS,1,-1
c            IF(ITAGSECOND(I,J).EQ.1.AND.ISIGMET.EQ.8)THEN
            IF(ITAGSECOND(I,J).EQ.1.AND.ISIGMET.EQ.8)THEN
               IF(PAZM(J).GT.180.AND.PAZM(J).LT.360.0)THEN
                  IF(SWEEPZ(I,J+1).GT.-32.)THEN
                     IF(ABS(SWEEPZ(I,J)-SWEEPZ(I,J+1)).GT.5.)THEN
                        SWEEPZ(I,J)=-32.
                        SWEEP(I,J)=-888.8
                     ENDIF
                  ELSE
                     SWEEPZ(I,J)=-32.
                     SWEEP(I,J)=-888.8
                  ENDIF
               ENDIF
            ENDIF
         ENDDO
      ENDDO
      DO I=IRINSIDE,IROUTSIDE
       DO J=1,NUM_RAYS
        IF(SWEEPZ(I,J).LT.20..AND.IPLANE.EQ.2)THEN
         SWEEPZ(I,J)=-32.
         SWEEP(I,J)=-999.9
        ENDIF
       ENDDO
      ENDDO
C        IF(SWEEPZ(I,J).LT.20..OR.ZRSWEEP(I,J).LE.0.5)THEN
Cc        IF(SWEEPZ(I,J).LT.10..OR.ZRSWEEP(I,J).LE.0.1)THEN
CC     1      OR.RDTAIIN(I).LE.3.0)THEN
C         SWEEP(I,J)=-999.9
C         SWEEPZ(I,J)=-32.
C        ENDIF
C       ENDDO
C      ENDDO
c      ENDIF
c      WRITE(6,*)'NBINS = ',NBINS
      WRITE(6,*)'NBINS = ',NBINS
 7777 FORMAT(10F8.2)
c      DO J=1,NUM_RAYS
c       WRITE(6,*)'J,AZEL = ',J,AZ_EL(1,J)
c       WRITE(6,7777)(SWEEPZ(I,J),I=1,NBINS)
c      ENDDO
      DO I=1,NBINS
c       WRITE(6,*)'I,RDTAIIN(I),RATEST = ',I,RDTAIIN(I),RATEST
       IF(RDTAIIN(I).GT.RATEST)THEN
        IGTEST=0
        J=NUM_RAYS+1
        JSTART=1
        JJ=JSTART
c        WRITE(6,*)'EXPECTING AZ_EL TO INCREASE'
c        WRITE(6,*)'JSTART,AZ_EL = ',JSTART,AZ_EL(1,JSTART)
        DO WHILE(JJ.LE.NUM_RAYS.AND.AZ_EL(1,JJ).LT.180.)
c         WRITE(6,*)'EXPECTING AZ_EL TO INCREASE'
c         WRITE(6,*)'JJ,AZ_EL = ',JJ,AZ_EL(1,JJ)
c         WRITE(6,*)'SWEEPZ(I,JJ) = ',SWEEPZ(I,JJ)
         IF(SWEEPZ(I,JJ).GT.-32.)THEN
          J=JJ+1
C         ELSE
C          GO TO 6498
         ENDIF
         JJ=JJ+1
c         WRITE(6,*)'NUM_RAYS,J,JJ = ',NUM_RAYS,J,JJ
        ENDDO
C6498    IF(J.LE.NUM_RAYS.AND.AZ_EL(1,J).LT.180.)THEN
        IF(J.LE.NUM_RAYS.AND.AZ_EL(1,J).LT.180.)THEN
         ICHECK=1
c         write(6,*)'i,icheck,j,azel = ',i,icheck,j,az_el(1,j)
         CALL GROUNDCHECK(SWEEP,SWEEPZ,NUM_RAYS,I,J,ICHECK,ZRSWEEP,
     +    RDTAIIN)
        ENDIF
        J=0
        JJ=JEND
        JAZTEST=1
c        write(6,*)'i,j,jend = ',i,j,jend
        DO WHILE(JJ.GE.1.AND.JAZTEST.EQ.1)
         IF(AZ_EL(1,JJ).GT.180.)THEN
C         write(6,*)'i,j,sweep(i,j) = ',i,j,sweep(i,j)
          IF(SWEEPZ(I,JJ).GT.-32.)THEN
           J=JJ-1
C         ELSE
C          GO TO 6499
          ENDIF
          JJ=JJ-1
          JAZTEST=1
         ELSE
          JAZTEST=0
         ENDIF
        ENDDO
c        WRITE(6,*)'J,JEND = ',J,JEND
        IF(J.GE.1)THEN
C6499    IF(J.GE.1)THEN
         IF(AZ_EL(1,J).GT.180.)THEN
          ICHECK=2
c         write(6,*)'i,icheck,j,azel = ',i,icheck,j,az_el(1,j)
          CALL GROUNDCHECK(SWEEP,SWEEPZ,NUM_RAYS,I,J,ICHECK,ZRSWEEP,
     +    RDTAIIN)
         ENDIF
        ENDIF
       ENDIF
      ENDDO
C      DO J=1,NUM_RAYS
C       WRITE(6,*)'AFTER,J,EEV,SWEEP(1,10),SWEEPZ(1,10) = ',
C     + J,EEV(J),(SWEEP(I,J),I=1,10),(SWEEPZ(I,J),I=1,10)
C      ENDDO
C      WRITE(6,'(" NCEPWRITE_FILE....ending.")')
C      DO J=1,NUM_RAYS
C       DO I=1,512
C        ZDIFF(I,J)=-888.8
C       ENDDO
C      ENDDO
C      DO J=1,NUM_RAYS
C       J1=J-1
C       J2=J+1
C       IF(J.EQ.1)THEN
C        J1=NUM_RAYS
C       ELSEIF(J.EQ.NUM_RAYS)THEN
C        J2=1
C       ENDIF
C       AZ1=AZ_EL(1,J1)
C       AZ2=AZ_EL(1,J2)
C       AZDIFF=AZ2-AZ1
C       IF(AZDIFF.LT..0)AZDIFF=AZDIFF+360.
C       DO I=IBST(1),512
C        IF(SWEEPZ(I,J2).GT.-31.99.AND.SWEEPZ(I,J1).GT.-31.99.AND.
C     +    AZDIFF.LT.5..AND.AZDIFF.GE..5)THEN
C         ZDIFF(I,J)=(SWEEPZ(I,J2)-SWEEPZ(I,J1))/AZDIFF
CC         WRITE(6,*)'I,J,SWEEPZ1,SWEEPZ2,AZ1,AZ2,AZDIFF,ZDIFF = ',
CC     +   I,J,SWEEPZ(I,J1),SWEEPZ(I,J2),AZ1,AZ2,AZDIFF,ZDIFF(I,J)
C        ENDIF
C       ENDDO
C      ENDDO
C      DO I=1,512
C       DO J=1,NUM_RAYS
C        XRMAX(I,J)=XRSWEEP(I,J)
C        YRMAX(I,J)=YRSWEEP(I,J)
C        ZRMAX(I,J)=ZRSWEEP(I,J)
C        XRMIN(I,J)=XRSWEEP(I,J)
C        YRMIN(I,J)=YRSWEEP(I,J)
C        ZRMIN(I,J)=ZRSWEEP(I,J)
C        AZMIN(I,J)=AZ_EL(1,J)
C        AZMAX(I,J)=AZ_EL(1,J)
C        IF(ZDIFF(I,J).GT.-888.8)THEN
C         ZMIN(I,J)=ZDIFF(I,J)
C         ZMAX(I,J)=ABS(ZDIFF(I,J))
C        ELSE
C         ZMIN(I,J)=888.8
C         ZMAX(I,J)=-888.8
C        ENDIF
C       ENDDO
C      ENDDO
C      DO I=1,512
C       DO J=1,11
C        DO L=J+1,NUM_RAYS
C         IF(ZMAX(I,L).GT.ZMAX(I,J))THEN
C          ABC=ZMAX(I,J)
C          ZMAX(I,J)=ZMAX(I,L)
C          ZMAX(I,L)=ABC
C          ABC=XRMAX(I,J)
C          XRMAX(I,J)=XRMAX(I,L)
C          XRMAX(I,L)=ABC
C          ABC=YRMAX(I,J)
C          YRMAX(I,J)=YRMAX(I,L)
C          YRMAX(I,L)=ABC
C          ABC=ZRMAX(I,J)
C          ZRMAX(I,J)=ZRMAX(I,L)
C          ZRMAX(I,L)=ABC
C          ABC=AZMAX(I,J)
C          AZMAX(I,J)=AZMAX(I,L)
C          AZMAX(I,L)=ABC
C          ABC=ZMIN(I,J)
C          ZMIN(I,J)=ZMIN(I,L)
C          ZMIN(I,L)=ABC
C         ENDIF
Cc         IF(ZMIN(I,L).LT.ZMIN(I,J))THEN
Cc          ABC=ZMIN(I,J)
Cc          ZMIN(I,J)=ZMIN(I,L)
Cc          ZMIN(I,L)=ABC
Cc          ABC=XRMIN(I,J)
Cc          XRMIN(I,J)=XRMIN(I,L)
Cc          XRMIN(I,L)=ABC
Cc          ABC=YRMIN(I,J)
Cc          YRMIN(I,J)=YRMIN(I,L)
Cc          YRMIN(I,L)=ABC
Cc          ABC=ZRMIN(I,J)
Cc          ZRMIN(I,J)=ZRMIN(I,L)
Cc          ZRMIN(I,L)=ABC
Cc          ABC=AZMIN(I,J)
Cc          AZMIN(I,J)=AZMIN(I,L)
Cc          AZMIN(I,L)=ABC
Cc         ENDIF
C        ENDDO
C       ENDDO
C      ENDDO
Cc      DO I=IBST(1),512
Cc       DO J=1,10
Cc        IF(ZMAX(I,J).GT.-888.)THEN
Cc         WRITE(6,412)I,J,ZMIN(I,J),AZMAX(I,J),XRMAX(I,J),YRMAX(I,J),
Cc     +               ZRMAX(I,J)
Cc        ENDIF
Cc       ENDDO
Cc      ENDDO
C412   FORMAT(' MAX ',2I4,5F8.2)
CC      DO I=IBST(1),512
CC       DO J=1,10
CC        IF(ZMIN(I,J).LT.888.)THEN
CC         WRITE(6,413)I,J,ZMIN(I,J),AZMIN(I,J),XRMIN(I,J),YRMIN(I,J),
CC     +               ZRMIN(I,J)
CC        ENDIF
CC       ENDDO
CC      ENDDO
CC413   FORMAT(' MIN ',2I4,5F8.2)
c      DO J=1,NUM_RAYS
c       DO I=1,512
c        SWEEP(I,J)=SWEEPZ(I,J)
c       ENDDO
c      ENDDO
C19187 DO ICHECKSWEEP=1,3
C      IDESPECKLE=2
      IF(IDESPECKLE.EQ.2)THEN
       DO ICHECKSWEEP=1,3
c       WRITE(6,*)'ICHECKSWEEP = ',ICHECKSWEEP
c       PAUSE
        DO I=1,NBINS
         DO J=1,NUM_RAYS
          IKEEP(I,J)=1
          IF(SWEEPZ(I,J).GT.-31.95)THEN
           DO I1=1,5
            II=I+I1-3
            IF(II.GT.0.AND.II.LE.NBINS)THEN
             IF(SWEEPZ(II,J).GT.-31.95)THEN
              IITEST(I1)=1
             ELSE
              IITEST(I1)=0
             ENDIF
            ELSE
             IITEST(I1)=0
            ENDIF
           ENDDO
           DO J1=1,5
            JJ=J+J1-3
            IF(JJ.GT.0.AND.JJ.LE.NUM_RAYS)THEN
             IF(SWEEPZ(I,JJ).GT.-31.95)THEN
              JJTEST(J1)=1
             ELSE
              JJTEST(J1)=0
             ENDIF
            ELSE
             JJTEST(J1)=0
            ENDIF
           ENDDO
           IKEEPER=0
           IF(IITEST(2).EQ.1.AND.IITEST(4).EQ.1)THEN
            IKEEPER=1
           ELSEIF(IITEST(1).EQ.1.AND.IITEST(2).EQ.1)THEN
            IKEEPER=1
           ELSEIF(IITEST(4).EQ.1.AND.IITEST(5).EQ.1)THEN
            IKEEPER=1
           ENDIF
           JKEEPER=0
           IF(JJTEST(2).EQ.1.AND.JJTEST(4).EQ.1)THEN
            JKEEPER=1
           ELSEIF(JJTEST(1).EQ.1.AND.JJTEST(2).EQ.1)THEN
            JKEEPER=1
           ELSEIF(JJTEST(4).EQ.1.AND.JJTEST(5).EQ.1)THEN
            JKEEPER=1
           ENDIF
           IF(IKEEPER.EQ.0.OR.JKEEPER.EQ.0)THEN
            IKEEP(I,J)=0
           ENDIF
          ENDIF
         ENDDO
        ENDDO
        DO I=1,NBINS
         DO J=1,NUM_RAYS
          IF(IKEEP(I,J).EQ.0)SWEEP(I,J)=-999.9
          IF(IKEEP(I,J).EQ.0)SWEEPZ(I,J)=-32.
c         SWPZ=SWEEPZ(I,J)
c         IF(ICHECKSWEEP.EQ.3.AND.SWEEPZ(I,J).GT.-20.)SWPZ=35.
c         IF(ICHECKSWEEP.EQ.3.AND.SWEEPZ(I,J).GT.-20.
c     1  .AND.SWEEPZ(I,J).LT.0.)SWPZ=60.
c         SWEEPZ(I,J)=SWPZ         
c         IF(SWEEPZ(I,J).GT.-32..AND.SWEEP(I,J).LT.10.)SWEEPZ(I,J)=60.
         ENDDO
        ENDDO
       ENDDO
      ENDIF
c       DO ICHECKSWEEP=1,3
cc       WRITE(6,*)'ICHECKSWEEP = ',ICHECKSWEEP
cc       PAUSE
c        DO I=1,NBINS
c         DO J=1,NUM_RAYS
c          IKEEP(I,J)=1
c          IF(SWEEPZ(I,J).GT.-31.95)THEN
c           DO I1=1,9
c            II=I+I1-5
c            IF(II.GT.0.AND.II.LE.NBINS)THEN
c             IF(SWEEPZ(II,J).GT.-31.95)THEN
c              IITEST(I1)=1
c             ELSE
c              IITEST(I1)=0
c             ENDIF
c            ELSE
c             IITEST(I1)=0
c            ENDIF
c           ENDDO
c           DO J1=1,9
c            JJ=J+J1-5
c            IF(JJ.GT.0.AND.JJ.LE.NUM_RAYS)THEN
c             IF(SWEEPZ(I,JJ).GT.-31.95)THEN
c              JJTEST(J1)=1
c             ELSE
c              JJTEST(J1)=0
c             ENDIF
c            ELSE
c             JJTEST(J1)=0
c            ENDIF
c           ENDDO
c           IKEEPER=0
c           IF(IITEST(3).EQ.1.AND.IITEST(4).EQ.1.AND.
c     1        IITEST(6).EQ.1.AND.IITEST(7).EQ.1)THEN
c            IKEEPER=1
c           ELSEIF(IITEST(1).EQ.1.AND.IITEST(2).EQ.1.AND.
c     1        IITEST(3).EQ.1.AND.IITEST(4).EQ.1)THEN
c            IKEEPER=1
c           ELSEIF(IITEST(2).EQ.1.AND.IITEST(3).EQ.1.AND.
c     1        IITEST(4).EQ.1.AND.IITEST(6).EQ.1)THEN
c            IKEEPER=1
c           ELSEIF(IITEST(4).EQ.1.AND.IITEST(6).EQ.1.AND.
c     1        IITEST(7).EQ.1.AND.IITEST(8).EQ.1)THEN
c            IKEEPER=1
c           ELSEIF(IITEST(6).EQ.1.AND.IITEST(7).EQ.1.AND.
c     1        IITEST(8).EQ.1.AND.IITEST(9).EQ.1)THEN
c            IKEEPER=1
c           ENDIF
c           JKEEPER=0
c           IF(JJTEST(3).EQ.1.AND.JJTEST(4).EQ.1.AND.
c     1        JJTEST(6).EQ.1.AND.JJTEST(7).EQ.1)THEN
c            JKEEPER=1
c           ELSEIF(JJTEST(1).EQ.1.AND.JJTEST(2).EQ.1.AND.
c     1        JJTEST(3).EQ.1.AND.JJTEST(4).EQ.1)THEN
c            JKEEPER=1
c           ELSEIF(JJTEST(2).EQ.1.AND.JJTEST(3).EQ.1.AND.
c     1        JJTEST(4).EQ.1.AND.JJTEST(6).EQ.1)THEN
c            JKEEPER=1
c           ELSEIF(JJTEST(4).EQ.1.AND.JJTEST(6).EQ.1.AND.
c     1        JJTEST(7).EQ.1.AND.JJTEST(8).EQ.1)THEN
c            JKEEPER=1
c           ELSEIF(JJTEST(6).EQ.1.AND.JJTEST(7).EQ.1.AND.
c     1        JJTEST(8).EQ.1.AND.JJTEST(9).EQ.1)THEN
c            JKEEPER=1
c           ENDIF
c           IF(IKEEPER.EQ.0.OR.JKEEPER.EQ.0)THEN
c            IKEEP(I,J)=0
c           ENDIF
c          ENDIF
c         ENDDO
c        ENDDO
c        DO I=1,NBINS
c         DO J=1,NUM_RAYS
c          IF(IKEEP(I,J).EQ.0)SWEEP(I,J)=-999.9
c          IF(IKEEP(I,J).EQ.0)SWEEPZ(I,J)=-32.
cc         SWPZ=SWEEPZ(I,J)
cc         IF(ICHECKSWEEP.EQ.3.AND.SWEEPZ(I,J).GT.-20.)SWPZ=35.
cc         IF(ICHECKSWEEP.EQ.3.AND.SWEEPZ(I,J).GT.-20.
cc     1  .AND.SWEEPZ(I,J).LT.0.)SWPZ=60.
cc         SWEEPZ(I,J)=SWPZ         
cc         IF(SWEEPZ(I,J).GT.-32..AND.SWEEP(I,J).LT.10.)SWEEPZ(I,J)=60.
c         ENDDO
c        ENDDO
c       ENDDO
c      ENDIF
      IF(IDESPECKLE.EQ.1)THEN
         CALL DESPECKLE(MAX_GATES,MAX_RAYS,NBINS,NUM_RAYS,NUMTIMES,
     +                  NUMCONTIG,SWEEP,SWEEPZ,IKEEP,IOLDDESPECKLE,
     +                  ZRSWEEP,ZRDIFFMAX,RA,ZSPECKLEMAX)
      ENDIF
      IF(ICONSERVE.EQ.1)THEN
       DO J=1,NUM_RAYS
        RADSAVER=0.
        I=1
        DO WHILE(I.LT.NBINS)
         IF(SWEEP(I,J).GT.-98..OR.RDTAIIN(I).LT.2.)THEN
          RADSAVER=RDTAIIN(I)
          I=I+1
         ELSEIF(RDTAIIN(I).LE.RADMAX.AND.
     1          (RDTAIIN(I)-RADSAVER).GT.1.)THEN
          DO L=I,NBINS
           SWEEP(L,J)=-888.8
          ENDDO
          GO TO 6305
         ELSE
          I=I+1
         ENDIF
        ENDDO
6305   ENDDO
      ENDIF
      XNIQTA1=XNIQTA
c      WRITE(6,*)'BEFORE,IMAXBINS,JMAXRAYS,NUM_RAYS = ',
c     1 IMAXBINS,JMAXRAYS,NUM_RAYS
c      WRITE(6,*)'BEFORE DEFRECKLE'
c      DO J=1,NUM_RAYS
c       WRITE(6,*)'J SWEEP = ',J
c       WRITE(6,7777)(SWEEP(I,J),I=1,NBINS)
c       WRITE(6,*)'J SWEEPZ = ',J
c       WRITE(6,7777)(SWEEPZ(I,J),I=1,NBINS)
c      ENDDO
      CALL DEFRECKLE(IMAXBINS,JMAXRAYS,
     1 NBINS,NUM_RAYS,PAZM,SWEEP,VROUT,XNIQTA1)
c      CALL DEFRECKLEBOTH(IMAXBINS,JMAXRAYS,
c     1 NBINS,NUM_RAYS,PAZM,SWEEP,VROUT,XNIQTA1,SWEEPZ,ZOUT)
c      WRITE(6,*)'RETURNED FROM DEFRECKLE'
c      DO J=1,NUM_RAYS
c       WRITE(6,*)'J SWEEP = ',J
c       WRITE(6,7777)(SWEEP(I,J),I=1,NBINS)
c       WRITE(6,*)'J SWEEPZ = ',J
c       WRITE(6,7777)(SWEEPZ(I,J),I=1,NBINS)
c      ENDDO
      DO J=1,NUM_RAYS
       DO I=2,511
c        if(j.eq.261)
c     1   WRITE(6,*)'I,J,SWEEPS = ',I,J,(SWEEP(II,J),II=I-1,I+1)
        IF(SWEEP(I,J).GT.-800..AND.SWEEP(I-1,J).LT.-799..AND.
     1     SWEEP(I+1,J).LT.-799.)THEN
c         WRITE(6,*)'REMOVING I,J = ',I,J
         SWEEP(I,J)=-888.88
c         WRITE(6,*)'I,J,SWEEPS = ',I,J,(SWEEP(II,J),II=I-1,I+1)
        ENDIF
       ENDDO
      ENDDO
      DO J=1,NUM_RAYS
       V00=V0SAVE(J)
       M=INOB(1)
       IRS=IBST(1)
       NB=NBINS
       VN=XNIQTA
c       DO I=1,NBINS
c        RAY(I)=SWEEP(I,J)
c       ENDDO
c       WRITE(6,*)'BEFORE, J = ',J
c       WRITE(6,*)'VRRAD = '
c       WRITE(6,'(10F8.2)')(VRRAD(L,J),L=1,20)
c       WRITE(6,*)'RAY = '
c       WRITE(6,'(10F8.2)')(RAY(L),L=1,20)
c       WRITE(6,*)'RADSWEEP = '
c       WRITE(6,'(10F8.2)')(RADSWEEP(L,J),L=1,20)
       DO I=1,NBINS
        RAY(I)=SWEEP(I,J)
        IF(ABS(HEADSTORE(J)).LT..1)THEN
         RAY(I)=-888.8
         SWEEP(I,J)=-888.8
C         VRRAD(I,J)=-888.8
        ENDIF
        DIFFHDTRK=HEADSTORE(J)-TRACKSTORE(J)
        IF(ABS(DIFFHDTRK).LT..1)THEN
         RAY(I)=-888.8
         SWEEP(I,J)=-888.8
C         VRRAD(I,J)=-888.8
        ENDIF
        IF(IUSEWIND.NE.1)THEN
         VRRAD(I,J)=-888.8
        ELSEIF(IUSEWIND.EQ.1)THEN
c         if(vrrad(i,j).gt.-800..and.ray(i).gt.-800.)then
c         write(6,*)'iusewind,vrrad,ray = ',iusewind,vrrad(i,j),ray(i)
c         endif
         IF(VRRAD(I,J).LT.-800..AND.RADSWEEP(I,J).LT.RADMAX)THEN
          RAY(I)=-888.88
         ELSEIF(RADSWEEP(I,J).LT.G4P3RADMIN)THEN
c          WRITE(6,*)'RADSWEEP,G4P3RADMIN = ',RADSWEEP(I,J),G4P3RADMIN
          RAY(I)=-888.8
c         ELSEIF(RADSWEEP(I,J).LT.111.1)THEN
c          RAY(I)=-888.8
         ENDIF
        ENDIF
        URAY(I)=VRRAD(I,J)
       ENDDO
c       WRITE(6,*)'AFTER RAY = '
c       WRITE(6,'(10F8.2)')(RAY(L),L=1,20)
c       write(6,*)'AZM = ',az_el(1,j)
c       write(6,*)'calling unfolder'
c       CALL UNFLD1(V00,VN,M,IRS,NB,RAY,URAY,NB)
       NB1=NBINS
       NB2=NBINS
c       WRITE(6,*)'UNFLDNEW,IAFTFORE,VN = ',IAFTFORE,VN
       CALL UNFLDNEW(V00,VN,M,IRS,NB1,RAY,URAY,NB2)
c       WRITE(6,*)'AFTER UNFLDNEW RAY = '
c       WRITE(6,'(10F8.2)')(RAY(L),L=1,20)
c       WRITE(6,*)'AFTER UNFLDNEW URAY = '
c       WRITE(6,'(10F8.2)')(RAY(L),L=1,20)
c       write(6,*)'j,ray,uray = ',j,(ray(i),uray(i),i=1,30)
c       iraytest=0
       do i=1,8
        if(ray(i).ne.uray(i).and.ray(i).gt.-800.)iraytest=1
       enddo
c       if(iraytest.eq.1)then
c        write(6,*)'j,pazm = ',j,pazm(j)
c        write(6,*)'v00,vn = ',v00,vn
c        write(6,*)'ray  ',(ray(i),i=1,8)
c        write(6,*)'uray ',(uray(i),i=1,8)
c       endif
       DO I=1,NBINS
        SWEEP(I,J)=URAY(I)
       ENDDO
c       write(6,*)'finished calling unfolder'
      ENDDO
c      WRITE(6,*)'FINISHED ALL RADILS UNFLDNEW'
c      DO J=1,NUM_RAYS
c       DO I=1,512
c        SWEEP(I,J)=SWEEPZ(I,J)
c       ENDDO
c      ENDDO
      XXNIQTA=XNIQTA*.7
      XXNIQ=XNIQTA
c      write(6,*)'setting nyq to ',xxniq
      DO I=1,MAX_GATES
       DO J=1,NUM_RAYS
        NYQ(I,J)=XXNIQ
       ENDDO
      ENDDO
c      write(6,*)'finished setting nyq'
c      write(6,*)'calling aziunfld'
c      do j=1,num_rays
c       write(6,*)'j = ',j
c      enddo
c      DO J=1,NUM_RAYS
c       WRITE(6,*)'J,PAZM(J),V0 = ',J,PAZM(J),V0SAVE(J)
c       WRITE(6,*)'SWEEP BEFORE = ',(SWEEP(I,J),I=1,8)
c       WRITE(6,*)'VRRAD BEFORE = ',(VRRAD(I,J),I=1,8)
c      ENDDO
      NB=NBINS
c      write(6,*)'calling varunfld'
c      write(6,*)'max_gates, max_rays = ',MAX_GATES,MAX_RAYS
c      write(6,*)'xrsweep = ',xrsweep(1,1)
c      IF(NUM_RAYS.GT.0)THEN
c       CALL VARUNFLD(SWEEP,MAX_GATES,NBINS,MAX_RAYS,
c     1 RDTAIIN,AZ_EL,NUM_RAYS,VRRAD,PAZM,XXNIQ)
c      ENDIF
c      write(6,*)'returned from varunfld'
c      DO J=1,NUM_RAYS
c       DO I=1,NBINS
c        SWEEP(I,J)=VRRAD(I,J)
c       ENDDO
c      ENDDO
c      write(6,*)'calling aziunfld and iusewind = ',iusewind
c      ALLOWEDDIFF=6.0
c      ALLOWEDDIFF=60.
c      ALLOWEDDIFF=6.
      VTOL1=1.
      INDEXCALL=1
      IF(NUM_RAYS.GT.0)THEN
       IF(IVARIATIONAL.EQ.1)THEN
        VFLAG=-888.88
        CALL CONTIG(SWEEP,ICOL,JCOL,MAX_HRD_DIM,MAX_RAYS,VFLAG,
     1              NB,NUM_RAYS,PAZM,PELEV,VTOL1,XXNIQ)
        CALL VARUNFLD(SWEEP,MAX_GATES,NB,MAX_RAYS,RDTAIIN,AZ_EL,
     1                NUM_RAYS,VRRAD,PAZM,XXNIQ,JCOL,ALLOWEDDIFF,
     1                INDEXCALL,VTOL1)
c        WRITE(6,*)'AFTER'
c        WRITE(6,*)'AZ_EL(1,J) = '
c        WRITE(6,591)(AZ_EL(1,J),J=1,NUM_RAYS)
c        DO J=1,NUM_RAYS
c         WRITE(6,*)'J,TIME,EEV,EAZM,SWEEP(I,J = ',
c     1    J,TMSWEEP(J),EEV(J),EAZM(J)
c          WRITE(6,591)(SWEEP(I,J),I=1,NB)
c         WRITE(6,*)'J,VRRAD(I,J = '
c         WRITE(6,591)(VRRAD(I,J),I=1,NB)
c        ENDDO
c        WRITE(6,*)'END AFTER'
       ELSE
c        WRITE(6,*)'BEFORE'
C        WRITE(6,*)'AZ_EL(1,J) = '
C        WRITE(6,591)(AZ_EL(1,J),J=1,NUM_RAYS)
c        DO J=1,NUM_RAYS
c         WRITE(6,*)'J,AZ_EL1,AZ_EL2,SWEEP(I,J = ',
c     1    J,AZ_EL(1,J),AZ_EL(2,J)
c         WRITE(6,591)(SWEEP(I,J),I=1,100)
c         WRITE(6,*)'J,VRRAD(I,J = '
c         WRITE(6,591)(VRRAD(I,J),I=1,100)
c        ENDDO
c        WRITE(6,*)'END BEFORE'
        CALL AZIUNFLDG(SWEEP,ISEG,ISEGE,MAX_GATES,NB,MAX_RAYS,XXNIQTA,
     1 RDTAIIN,AZ_EL,XXNIQ,NUM_RAYS,VRRAD,IUSEWIND,PAZM,ALLOWEDDIFF)
c        WRITE(6,*)'AFTER'
C        WRITE(6,*)'AZ_EL(1,J) = '
C        WRITE(6,591)(AZ_EL(1,J),J=1,NUM_RAYS)
c        DO J=1,NUM_RAYS
c         WRITE(6,*)'J,AZ_EL1,AZ_EL2,SWEEP(I,J = ',
c     1    J,AZ_EL(1,J),AZ_EL(2,J)
c         WRITE(6,591)(SWEEP(I,J),I=1,100)
c         WRITE(6,*)'J,VRRAD(I,J = '
c         WRITE(6,591)(VRRAD(I,J),I=1,100)
c        ENDDO
c        WRITE(6,*)'END AFTER'
        IBST1=IBST(1)+1
        DO J=1,NUM_RAYS
           IF(ABS(EEV(J)).LE.10..AND.SWEEP(IBST1,J).GT.-200.)THEN
            IWRITETEST=1
            TRAKAZM=AZ_EL(1,J)
            IF(TRAKAZM.LT.0.)TRAKAZM=TRAKAZM+360.
            IF(TRAKAZM.LT.180.)THEN
             N1SUMV0=N1SUMV0+1
             DIFFV0=SWEEP(IBST1,J)-V0SAVE(J)
             SUM1V0=SUM1V0+DIFFV0
             SUM1V02=SUM1V02+DIFFV0*DIFFV0
            ELSE
             N2SUMV0=N2SUMV0+1
             DIFFV0=SWEEP(IBST1,J)-V0SAVE(J)
             SUM2V0=SUM2V0+DIFFV0
             SUM2V02=SUM2V02+DIFFV0*DIFFV0
            ENDIF
           ENDIF
        ENDDO
c        IF(N1SUMV0.GT.0.AND.IWRITETEST.EQ.1)THEN
c           DIFFV0MEAN=SUM1V0/N1SUMV0
c           RMSV0MEAN=SQRT(SUM1V02/N1SUMV0)
c           WRITE(6,*)'RIGHT'
c           WRITE(6,*)'NSUMV0,SUMV0,SUMV02 = ',N1SUMV0,SUM1V0,SUM1V02
c           WRITE(6,*)'NSUMV0,DIFFV0MEAN,RMSV0MEAN = ',
c     +                   N1SUMV0,DIFFV0MEAN,RMSV0MEAN
c        ENDIF
c        IF(N2SUMV0.GT.0..AND.IWRITETEST.EQ.1)THEN
c           DIFFV0MEAN=SUM2V0/N2SUMV0
c           RMSV0MEAN=SQRT(SUM2V02/N2SUMV0)
c           WRITE(6,*)'LEFT'
c           WRITE(6,*)'NSUMV0,SUMV0,SUMV02 = ',N2SUMV0,SUM2V0,SUM2V02
c           WRITE(6,*)'NSUMV0,DIFFV0MEAN,RMSV0MEAN = ',
c     +                   N2SUMV0,DIFFV0MEAN,RMSV0MEAN
c        ENDIF
       ENDIF
      ENDIF
c      write(6,*)'returned from aziunfld'
c       DO J=1,NUM_RAYS
c        WRITE(6,*)'J,SWEEP = ',J,(SWEEP(I,J),I=1,512)
c       ENDDO
c      DO J=1,NUM_RAYS
c       WRITE(6,*)'J,PAZM(J),V0 = ',J,PAZM(J),V0SAVE(J)
c       WRITE(6,*)'SWEEP AFTER = ',(SWEEP(I,J),I=1,8)
c       WRITE(6,*)'VRRAD AFTER = ',(VRRAD(I,J),I=1,8)
c       ENDDO
      FLAGVAL=-888.8
      IVADFLAG=10
c      DO J=1,NUM_RAYS
c       DO I=1,MAX_GATES
c        SWEEP(I,J)=VRRAD(I,J)
c       ENDDO
c      ENDDO
C      DO J=1,NUM_RAYS
C       DO I=1,MAX_GATES
c        IF(ILATERSWEEP.EQ.0.OR.SWEEP(I,J).LT.-200.)THEN
C         VRRAD(I,J)=SWEEP(I,J)
c        ELSE
c         VRRAD(I,J)=SWEEPSAVE(I,J)
c        ENDIF
C       ENDDO
C      ENDDO
      IMINRNG=1
      NRANG=NBINS
c      DO J=1,NUM_RAYS
c       WRITE(6,*)'J,AZ = ',J,AZ_EL(1,J),AZ_EL(2,J)
c       WRITE(6,*)'SWEEP = ',(SWEEP(I,J),I=1,512)
c       WRITE(6,*)'VRRAD = ',(VRRAD(I,J),I=1,512)
c      ENDDO
c      write(6,*)'returning from aziunfld'
c      write(6,*)'num_rays,iminrng,nrang,flagval,ivadflag,vnyq = ',
c     1           num_rays,iminrng,nrang,flagval,ivadflag,XNIQTA
c      WRITE(6,*)'BEFORE SWEEPSAVE'
      DO J=1,NUM_RAYS
       DO I=1,NBINS
        SWEEPSAVE(I,J)=SWEEP(I,J)
       ENDDO
      ENDDO
c      WRITE(6,*)'AFTER SWEEPSAVE'
c      CALL DEALIAS_EILTS(MAX_GATES,MAX_RAYS,SWEEP,NUM_RAYS,IMINRNG,
c     1 NRANG,VRRAD,NYQ,FLAGVAL,IVADFLAG,UNFVEL,TMP1,TMP2,JINDEX,
c     1 JIINDEX)
c      CALL UNFNQC(MAX_GATES,MAX_RAYS,NRANG,NUM_RAYS,SWEEP,XXNIQ,
c     1 UNFVEL,TMP1,TMP2,IVADFLAG,VRRAD,JINDEX)
c      write(6,*)'returning from aziunfld'
c      write(6,*)'num_rays,iminrng,nrang,flagval,ivadflag = ',
c     1           num_rays,iminrng,nrang,flagval,ivadflag
c      DO J=1,NUM_RAYS
cc       write(6,*)j,(unfvel(i,j),i=1,512)
c       DO I=1,MAX_GATES
cc        SWEEP(I,J)=VRRAD(I,J)
c        IF(SWEEPSAVE(I,J).GT.-800)THEN
c         SWEEP(I,J)=UNFVEL(I,J)
c         SWEEPSAVE(I,J)=UNFVEL(I,J)
c        ELSE
c         SWEEP(I,J)=-888.8
c         SWEEPSAVE(I,J)=-888.8
c        ENDIF
c       ENDDO
c      ENDDO
      ILATERSWEEP=1
      PELEVMAX=0.
      DO J=1,NUM_RAYS
       PELEVTEST=ABS(PELEV(J))
       IF(PELEVTEST.GT.PELEVMAX)PELEVMAX=PELEVTEST
      ENDDO
c      WRITE(6,*)'PELEVMAX = ',PELEVMAX
      IF(PELEVMAX.LT.15..AND.FASTON.NE.0)THEN
       DO J=1,10
        WRITE(6,*)'PELEVMAX = ',PELEVMAX
       ENDDO
      ENDIF
      DO J=1,MAX_RAYS
         IF(IUSEMELT.EQ.1)THEN
            IF(TMSWEEP(J).GT.TIMEMELT.AND.I65CLOSE.EQ.0)THEN
               HTMELTBEFORE=HTMELT
               TKMELTBEFORE=TKMELT
               TIMEMELTBEFORE=TIMEMELT
               READ(65,*,END=898)TIMEMELT,HTMELT,TKMELT
               GO TO 897
 898           CLOSE(65)
               TIMEMELT=TIMEMELTBEFORE
               HTMELT=HTMELTBEFORE
               TKMELT=TKMELTBEFORE
               I65CLOSE=1
            ENDIF
            WRITE(6,*)'IUSEMELT,TMSWEEP(J),TIMEMELT,HTMELT,TKMELT = ',
     1            IUSEMELT,TMSWEEP(J),TIMEMELT,HTMELT,TKMELT
       ENDIF
 897   DO I=1,MAX_GATES
c        IF(SWEEPZ(I,J).LE.-32.)SWEEPZ(I,J)=-31.5
        IF(ABS(PELEV(J)).GT..0001.AND.ZRSWEEP(I,J).GT.0.AND.
     1   SWEEP(I,J).GT.-400..AND.SWEEPZ(I,J).GT.-32.)THEN
         H=ZRSWEEP(I,J)
         ZDBZ=SWEEPZ(I,J)
         IF(IUSEMELT.EQ.1)THEN
            VTSUB1=VTERM_NEW(ZDBZ,H,HTMELT,TKMELT,IRSW,ZLOW,ZHIGH)
         ELSE
            VTSUB1=VTERM_NEW(ZDBZ,H,HTBBPT,DBBPT,IRSW,ZLOW,ZHIGH)
C            IF(ZRSWEEP(I,J).GT.HTBBPT-.5*DBBPT.AND.
C     1         ZRSWEEP(I,J).LT.HTBBPT+.5*DBBPT)THEN
C                 WRITE(6,*)'Z,VTSUB1 = ',ZRSWEEP(I,J),VTSUB1
C                 VTSUBADD=4.-4.*(ZRSWEEP(I,J)-HTBBPT)*
C     1                           (ZRSWEEP(I,J)-HTBBPT)/
C     1            (.25*DBBPT**2.)
C                 VTSUB1=VTSUB1+VTSUBADD
C                 WRITE(6,*)'Z,VTSUBADD,VTSUB1 = ',ZRSWEEP(I,J),
C     1                        VTSUBADD,VTSUB1
C            ENDIF
         ENDIF
c         WRITE(6,*)
c     1       'I,J,TMSWEEP,ZDBZ,ZRSWEEP(I,J),HTMELT,TKMELT,VTSUB1 = ',
c     1        I,J,TMSWEEP(J),ZDBZ,ZRSWEEP(I,J),HTMELT,TKMELT,VTSUB1
         VTSUB=VTSUB1*SIN(EEV(J)*3.14159/180.)
         SWEEPVT(I,J)=SWEEP(I,J)-VTSUB
         SWEEP(I,J)=SWEEPVT(I,J)
         SWEEPVTVT=SWEEPVT(I,J)*10.
         ISWEEPVT(I,J)=NINT(SWEEPVTVT)
c          WRITE(6,*)'I,J,EVV,H,VTSUB,VTSUB1,SWEEP,SWEEPVT,SWEEPZ = ',
c     1     I,J,EEV(J),
c     1     H,VTSUB,VTSUB1,SWEEP(I,J),SWEEPVT(I,J),SWEEPZ(I,J)
        ELSE
c         SWEEP(I,J)=-888.88
c         SWEEPZ(I,J)=-32.
         SWEEPVT(I,J)=-888.88
         ISWEEPVT(I,J)=-8888
        ENDIF
       ENDDO
      ENDDO
c      DO J=1,NUM_RAYS
c         WRITE(6,*)'RADIITA,J,TMSWEEP = ',J,TMSWEEP(J)
c         WRITE(6,5961)(RADIITA(I),I=1,40)
c         WRITE(6,*)'RDTAIIN,J,TMSWEEP = ',J,TMSWEEP(J)
c         WRITE(6,5961)(RDTAIIN(I),I=1,40)
c         WRITE(6,*)'SWEEPVT,J,TMSWEEP = ',J,TMSWEEP(J)
c         WRITE(6,5961)(SWEEPVT(I,J),I=1,40)
c         WRITE(6,*)'SWEEPZ,J,TMSWEEP = ',J,TMSWEEP(J)
c         WRITE(6,5961)(SWEEPZ(I,J),I=1,40)
c 5961    FORMAT(10F8.3)
c      ENDDO
c      DO J=1,NUM_RAYS
c       WRITE(6,*)'J,TIME,PELEV,EEV,EAZM,SWEEP(I,J = ',
c     1    J,TMSWEEP(J),PELEV(J),EEV(J),EAZM(J)
c       WRITE(6,591)(SWEEP(I,J),I=1,NB)
c       WRITE(6,*)'J,SWEEPVT(I,J = '
c       WRITE(6,591)(SWEEPVT(I,J),I=1,NB)
c       WRITE(6,*)'J,SWEEPZ(I,J = '
c       WRITE(6,591)(SWEEPZ(I,J),I=1,NB)
c       WRITE(6,*)'J,ZRSWEEP(I,J = '
c       WRITE(6,591)(ZRSWEEP(I,J),I=1,NB)
c      ENDDO
c      WRITE(6,*)'NBINSMAX,NBINSMAXSAVE = ',NBINSMAX,NBINSMAXSAVE
c      PAUSE
c      IF(NBINSMAX.NE.NBINSMAXSAVE.AND.IPLANE.EQ.1)INEWRAD=1
      NBINSMAXSAVE=NBINSMAX
c      WRITE(6,*)'I150 = ',I150
c      WRITE(6,*)'SXBIG,I150 = ',SXBIG,I150
      IF(SXBIG.LT.20.)THEN
c       WRITE(6,*)'SXBIG,I150= ',SXBIG,I150
       IF(I150.EQ.1)THEN
c        IF(RADRES.LE..101)THEN
c         ITEST1=MAX_HRD_DIM/2
c         MULT1=2
c         MAXI=MAX_HRD_DIM/2
c        ELSE
        IF(ISIGMET.EQ.5)THEN 
c         ITEST1=256
c         MULT1=2
c         MAXI=256
         ITEST1=256
         MULT1=2
         MAXI=256
        ELSE
         ITEST1=MAX_HRD_DIM
         IF(RADRES.LT..099)THEN
            MULT1=2
         ELSE
            MULT1=1
         ENDIF
         MAXI=MAX_HRD_DIM
        ENDIF
        ITEST2=-1
        ITEST3=-1
        ITEST4=-1
        MULT2=-1
        MULT3=-1
        MULT4=-1
        KSTART1=1
        KSTART2=-1000
        KSTART3=-1000
       ELSE
        WRITE(6,*)'I GOT HERE SO MULT1 = 4'
        MULT1=4
        MULT2=2
        MULT3=1
        KSTART1=1
        KSTART2=257
        KSTART3=385
        ITEST1=64
        ITEST2=65
        ITEST3=128
        ITEST4=129
        MAXI=256
       ENDIF
C       MAXI=NBINS
      ELSE
       IF(I150.EQ.1)THEN
        MULT1=16
        ITEST1=MAX_HRD_DIM/MULT1
        ITEST2=ITEST1+1
        ITEST3=ITEST2
        ITEST4=ITEST2
        MULT2=-1
        MULT3=-1
        MULT4=-1
        KSTART1=1
        KSTART2=-1000
        KSTART3=-1000
       ELSE
        MULT1=32
        MULT2=16
        MULT3=8
        KSTART1=1
        KSTART2=257
        KSTART3=385
        ITEST1=8
        ITEST2=9
        ITEST3=16
        ITEST4=17
       ENDIF
       MAXI=32
      ENDIF
c      WRITE(6,*)'RDTAIIN = '
c      WRITE(6,652)RDTAIIN
c 652  FORMAT(10F8.2)
c      WRITE(6,*)'ITEST1,ITEST2,ITEST3,ITEST4 = ',
c     1           ITEST1,ITEST2,ITEST3,ITEST4
c      WRITE(6,*)'MULT1,MULT2,MULT3,MULT4 = ',
c     1           MULT1,MULT2,MULT3,MULT4
c      WRITE(6,*)'KSTART1,KSTART2,KSTART3,KSTART4 = ',
c     1           KSTART1,KSTART2,KSTART3,KSTART4
c      PAUSE
      DO J=1,NUM_RAYS
c       IF(TMSWEEP(J).GT.45529.5.AND.TMSWEEP(J).LT.45529.6)THEN
c        WRITE(6,*)'TIMES,SWEEP,EAZM,EEV = ',
c     1   EAZM(J),EEV(J),TMSWEEP(J),(SWEEP(I,J),I=1,MAXI)
c        WRITE(6,*)'TIMES,SWEEPVT,EAZM,EEV = ',
c     1   EAZM(J),EEV(J),TMSWEEP(J),(SWEEPVT(I,J),I=1,MAXI)
c        PAUSE
c       ENDIF
c       WRITE(6,*)'MAXI,ITEST1,ITEST2,ITEST3,ITEST4 = ',
c     1            MAXI,ITEST1,ITEST2,ITEST3,ITEST4
       DO I=1,MAXI
        IF(I.LE.ITEST1)THEN
         K=KSTART1+(I-1)*MULT1
         M=I*MULT1
        ELSEIF(I.GE.ITEST2.AND.I.LE.ITEST3)THEN
         K=KSTART2+(I-ITEST2)*MULT2
         M=K+MULT2-1
        ELSEIF(I.GE.ITEST4)THEN
         K=KSTART3+(I-ITEST4)*MULT3
         M=K+MULT3-1
        ENDIF
        SUMVT=0.
        SUM=0.
        SUMD=0.
        SUMND=0.
        SUMN=0.
        RADSUM=0.
        RADSUMN=0.
c        write(6,*)'k,m,maxi,nbins = ',k,m,maxi,nbins
        DO L=K,M
C           write(6,*)'icallsweepin = ',icallsweepin
C           write(6,*)'L,RADIITA,RDTAIIN = ',L,RADIITA(L),RDTAIIN(L)
c         IF((ICALLSWEEPIN.EQ.0..OR.INEWRAD.EQ.1).AND.J.EQ.1)THEN
         IF(J.EQ.NUM_RAYS)THEN
c          WRITE(6,*)'RDTAIIN = '
c          WRITE(6,'(10F8.3)')(RDTAIIN(LIJ),LIJ=1,512)
          IF(RDTAIIN(L).LT.200.)THEN
           RADSUMN=RADSUMN+1
           RADSUM=RADSUM+RDTAIIN(L)
C           WRITE(6,*)'L,RADSUMN,RADSUM = ',L,RADSUMN,RADSUM
c           PAUSE
          ENDIF
         ENDIF
C           write(6,*)'icallsweepin = ',icallsweepin
C           write(6,*)'L,RADIITA,RDTAIIN = ',L,RADIITA(L),RDTAIIN(L)
c         pause
c         if(j.eq.1)
c     1   write(6,*)'i,l,radsumn,radsum,RDTAIIN,icallsweepin = ',
c     1 i,l,radsum,radsumn,RDTAIIN(l),icallsweepin
         IF(SWEEP(L,J).GT.-888.8)THEN
          SUM=SUM+SWEEP(L,J)
          SUMVT=SUMVT+SWEEPVT(L,J)
          SUMN=SUMN+1.
         ENDIF
         IF(SWEEPZ(L,J).GT.-20.)THEN
          SUMD=SUMD+SWEEPZ(L,J)
          SUMND=SUMND+1.
         ENDIF
        ENDDO
        IF(SUMND.GT.0..AND.IBLANKSWEEP.EQ.0)THEN
         SWEEPZVT(I,J)=SUMD/SUMND
        ELSE
         SWEEPZVT(I,J)=-32.
        ENDIF
        IF(SUMN.GT.0..AND.IBLANKSWEEP.EQ.0)THEN
c         SWEEP(I,J)=SUM/SUMN
         SWEEPVT(I,J)=SUMVT/SUMN
        ELSE
c         SWEEP(I,J)=-888.8
         SWEEPVT(I,J)=-888.8
        ENDIF
        ISWEEPVT(I,J)=NINT(10.*SWEEPVT(I,J))
C        WRITE(6,*)'RADSUM,RADSUMN = ',RADSUM,RADSUMN
c        IF((ICALLSWEEPIN.EQ.0..OR.INEWRAD.EQ.1).AND.J.EQ.1)THEN
        IF(J.EQ.NUM_RAYS)THEN
         IF(RADSUMN.GT.0.)THEN
          RDTAI(I)=RADSUM/RADSUMN
c         WRITE(6,*)'I,RADSUM,RADSUMN,RDTAI = ',I,RADSUM,RADSUMN,RDTAI(I)
         ELSE
          RDTAI(I)=1000.
         ENDIF
        ENDIF
c        IF(SUMND.GT.0.)THEN
c         SWEEPZ(I,J)=SUMD/SUMND
c        ELSE
c         SWEEPZ(I,J)=-32.
c        ENDIF
c        if(j.eq.1)then
c         write(6,*)'sum,sumn,sumnd,sumd,radsum,radsumn = ',
c     1             sum,sumn,sumnd,sumd,radsum,radsumn
c         write(6,*)'i,rdtai,sweep,sweepz = ',
c     1             i,rdtai(i),sweep(i,j),sweepz(i,j)
c        endif
       ENDDO
c       IF(J.EQ.1)THEN
c        WRITE(6,*)'RDTAI = '
c        WRITE(6,529)(RDTAI(I),I=1,400)
cc       pause
c       ENDIF
      ENDDO
c      WRITE(87,*)'FIRST RDTAI(10) = ',RDTAI(10)
      MAXI2=0
      DO I=2,MAXI
       IF(RDTAI(I).GT.0..AND.RDTAI(I).LT.500.)THEN
        IF(MAXI2.EQ.0.AND.ICALLSWEEPIN.EQ.0)IBSTRSS=I-1
        MAXI2=I
       ENDIF
      ENDDO
      WRITE(6,*)'MAXI2 = ',MAXI2
      WRITE(6,*)'IBSTRSS = ',IBSTRSS
      MAXI=MAXI2
C      write(6,*)'i got here 2'
      GO TO 76000
c      IF(NUM_RAYS.GT.0)THEN
c       WRITE(6,*)'AZ_EL = '
c       WRITE(6,'(10F8.2)')(AZ_EL(1,J),J=1,NUM_RAYS)
       DO J=1,NUM_RAYS
        TMSWEEP2(J)=TMSWEEP(J)
       ENDDO
c       WRITE(6,*)'AZEL = '
c       WRITE(6,'(10F8.1)')(AZEL(1,J),J=1,NUM_RAYS)
c       WRITE(6,*)'I GOT HERE'
c       GO TO 76000
       CALL TIMESORT(NUM_RAYS,TMSWEEP,RDVWS,IPLANE)
       CALL TIMESORT(NUM_RAYS,TMSWEEP,PAZM,IPLANE)
       CALL TIMESORT(NUM_RAYS,TMSWEEP,PELEV,IPLANE)
       CALL TIMESORT(NUM_RAYS,TMSWEEP,EAZM,IPLANE)
       CALL TIMESORT(NUM_RAYS,TMSWEEP,EEV,IPLANE)
       CALL TIMESORT(NUM_RAYS,TMSWEEP,RRLAT,IPLANE)
       CALL TIMESORT(NUM_RAYS,TMSWEEP,RRLON,IPLANE)
       CALL TIMESORT(NUM_RAYS,TMSWEEP,RRA,IPLANE)
       CALL TIMESORT(NUM_RAYS,TMSWEEP,TMSWEEP2,IPLANE)
       CALL TIMESORT(NUM_RAYS,TMSWEEP,V0SAVE,IPLANE)
       CALL TIMESORT(NUM_RAYS,TMSWEEP,TRACKSTORE,IPLANE)
       CALL TIMESORT(NUM_RAYS,TMSWEEP,HEADSTORE,IPLANE)
       CALL ITIMESORT(NUM_RAYS,TMSWEEP,IAZM,IPLANE)
       NUMI=2
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,AZ_EL,IPLANE)
c       WRITE(6,*)'I GOT HERE 2'
       NUMI=MAX_GATES
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,SWEEPVT,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,SWEEPZVT,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,UNFVEL,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,TMP1,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,TMP2,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,SWEEP,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,SWEEPSAVE,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,VRRAD,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,NYQ,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,VROUT,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,XRSWEEP,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,YRSWEEP,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,ZRSWEEP,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,RADSWEEP,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,XRMIN,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,YRMIN,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,ZRMIN,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,XRMAX,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,YRMAX,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,ZRMAX,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,AZMIN,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,AZMAX,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,SWEEPZ,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,ZDIFF,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,ZRMIN,IPLANE)
       CALL TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,ZRMAX,IPLANE)
c       WRITE(6,*)'I GOT HERE 3'
       CALL ITIMESORT2(NUMI,NUM_RAYS,TMSWEEP,JINDEX,IPLANE)
       CALL ITIMESORT2(NUMI,NUM_RAYS,TMSWEEP,JIINDEX,IPLANE)
       CALL ITIMESORT2(NUMI,NUM_RAYS,TMSWEEP,ISEG,IPLANE)
       CALL ITIMESORT2(NUMI,NUM_RAYS,TMSWEEP,ISEGB,IPLANE)
       CALL ITIMESORT2(NUMI,NUM_RAYS,TMSWEEP,ISEGE,IPLANE)
       CALL ITIMESORT2(NUMI,NUM_RAYS,TMSWEEP,IKEEP,IPLANE)
       CALL ITIMESORT2(NUMI,NUM_RAYS,TMSWEEP,ISWEEP,IPLANE)
       CALL ITIMESORT2(NUMI,NUM_RAYS,TMSWEEP,ISWEEPVT,IPLANE)
c      WRITE(6,*)'JUST AFTER RAY SORTING'
c      DO J=1,NUM_RAYS
c       WRITE(6,*)'J SWEEP = ',J
c       WRITE(6,7777)(SWEEP(I,J),I=1,NBINS)
c       WRITE(6,*)'J SWEEPZ = ',J
c       WRITE(6,7777)(SWEEPZ(I,J),I=1,NBINS)
c      ENDDO
c       WRITE(6,*)'AZEL = '
c       WRITE(6,'(10F8.1)')(AZEL(1,J),J=1,NUM_RAYS)
c       WRITE(6,*)'TMSWEEP = '
c       WRITE(6,'(10F8.1)')(TMSWEEP(J),J=1,NUM_RAYS)
       DO J=1,NUM_RAYS
        TMSWEEP(J)=TMSWEEP2(J)
       ENDDO
c       WRITE(6,*)'VOSAVE = '
c       WRITE(6,591)(V0SAVE(J),J=1,NUM_RAYS)
c      ENDIF
76000 IF(ICALLSWEEPIN.EQ.0)THEN
6528   FORMAT(I2)
       WRITE(6,6528)NAIRCRAFT
       READ(IFLT,'(I2)')IYEAR
       MAXI=60./RADRES/MULT1
       WRITE(86)IYEAR,MONTH,IDAY,MAXI
       MAXISET=MAXI
       MAXIOLD=MAXISET
       MAXISEND=60./RADRES/IBINAVG
       WRITE(6,*)'MAXISEND,RADRES,IBINAVG = ',MAXISEND,RADRES,IBINAVG
c       PAUSE
       write(6,*)'iyear = ',iyear
       WRITE(6,'(3I2.2,1X,I4)')IYEAR,MONTH,IDAY,MAXI
c       PAUSE
       WRITE(87,'(3I2.2,1X,I4)')IYEAR,MONTHTAPE,IDAYTAPE,MAXI
       WRITE(85,'(I4,2I2.2)')IYEARTAPE,MONTHTAPE,IDAYTAPE
       WRITE(85,6528)NAIRCRAFT
       WRITE(85,'(I3)')IATCFNO
       MAXIOUT=MAXI-IBSTRSS
       WRITE(85,'(I3)')MAXIOUT
C       IBSTT=IBST(1)
       RANGERES=(RDTAI(IBSTRSS+3)-RDTAI(IBSTRSS+2))
c       WRITE(6,*)IBSTRSS,RDTAI(IBSTRSS+3),RDTAI(IBSTRSS+2)
C      -5.5*RANGERES INSTEAD OF -2.*RANGERES TO ACCOUNT FOR
C      RSS SOFTWARE AVERAGING 8 BINS AND BUT SETTING RADIUS
C      TO THE 8TH BIN INSTEAD OF THE 4.5TH BIN
C      SEPT 1 2020 -5.5 CHANGED TO -1.5 SINCE BUFR CODE IS 
C      ALREADY MAKING THE CORRECTION
       RADIUSNO0=(RDTAI(IBSTRSS+2)-1.5*RANGERES)*1000.
       RANGERES=RANGERES*1000.
       IRADIALTYPE=10
c       WRITE(6,*)'IBSTRSS,RANGERES,RADIUSNO0 = ',
c     1   IBSTRSS,RANGERES,RADIUSNO0
       WRITE(85,'(F6.1)')RADIUSNO0
       WRITE(85,'(F6.1)')RANGERES
       WRITE(85,'(I3.3)')IRADIALTYPE
       WRITE(85,'(I1)')IFRANCENO
       WRITE(6,'(I4,2I2.2)')IYEAR,MONTH,IDAY,MAXI
c       PAUSE
      ENDIF
c      WRITE(87,*)'RDTAI(10),RADTEST2,INEWRAD = ',
c     +            RDTAI(10),RADTEST2,INEWRAD
c      IF(RDTAI(10).NE.RADTEST2.OR.INEWRAD.EQ.1)THEN
      IF(ICALLSWEEPIN.EQ.0)THEN
       INEWRAD2=1
       WRITE(86)(RDTAI(I),I=1,MAXI)
       WRITE(87,'(8F10.3)')(RDTAI(I),I=1,MAXI)
      ELSE
       INEWRAD2=0
      ENDIF
      INEWRAD2=0
c      WRITE(87,*)'ONE RDTAI(10),RADTEST2 = ',RDTAI(10),RADTEST2
      RADTEST2=RDTAI(10)
c      WRITE(87,*)'ONEA RDTAI(10),RADTEST2 = ',RDTAI(10),RADTEST2
c      WRITE(87,*)'INEWRAD2 = ',INEWRAD2
c      write(6,*)'MAXI,MAXI2,MAXIOLD = ',MAXI,MAXI2,MAXIOLD
C      write(6,*)'i got here 4'
c      WRITE(87,*)'ICALLSWEEPIN,INEWRAD2 = ',ICALLSWEEPIN,INEWRAD2
      IF(ICALLSWEEPIN.NE.0.AND.INEWRAD2.EQ.1)THEN
       J=1
       TIMERAD=-1.
       DO I=1,NBINS
        ISWEEP(I,J)=NINT(SWEEP(I,J)*10)
       ENDDO
       WRITE(86,IOSTAT=IERR,ERR=1040)TIMERAD,RRLAT(J),RRLON(J),
     +    RRA(J),EAZM(J),EEV(J),(SWEEPVT(I,J),I=1,MAXISET)
       WRITE(87,'(A4)')'FORE'
       WRITE(87,'(8F10.3)')TIMRAD,RRLAT(J),RRLON(J),
     +    RRA(J),EAZM(J),EEV(J),(SWEEPVT(I,J),I=1,MAXISET)
       WRITE(87,'(8F10.3)')TIMRAD,RRLAT(J),RRLON(J),
     +    RRA(J),EAZM(J),EEV(J),(SWEEPZVT(I,J),I=1,MAXISET)
       RANGERESNEW=(RDTAI(IBSTRSS+3)-RDTAI(IBSTRSS+2))
C      -5.5*RANGERESNEW INSTEAD OF -2.*RANGERESNEW TO ACCOUNT FOR
C      RSS SOFTWARE AVERAGING 8 BINS AND BUT SETTING RADIUS
C      TO THE 8TH BIN INSTEAD OF THE 4.5TH BIN
C      SEPT 1 2020 -5.5 CHANGED TO -1.5 SINCE BUFR CODE IS 
C      ALREADY MAKING THE CORRECTION
       RADIUSNO0NEW=(RDTAI(IBSTRSS+2)-1.5*RANGERESNEW)*1000.
       RANGERESNEW=RANGERESNEW*1000.
       IF(RANGERESNEW.NE.RANGERES)THEN
        RADIUSNO0=RADIUSNO0NEW
        RANGERES=RANGERESNEW
        WRITE(85,'(8F10.3)')TIMRAD,RRLAT(J),RRLON(J),
     +    RRA(J),EAZM(J),EEV(J)
c        WRITE(6,*)'IBSTRSS,MAXISET = ',IBSTRSS,MAXISET
        WRITE(85,'(10I6)')(ISWEEPVT(I,J),I=IBSTRSS+1,MAXISET)
        WRITE(85,'(I3)')MAXI
        WRITE(85,'(F6.1)')RADIUSNO0
        WRITE(85,'(F6.1)')RANGERES
       ENDIF
       WRITE(87,'(I3)')MAXI
       WRITE(86)MAXI
C       WRITE(86)(RDTAI(I),I=1,MAXI)
C       WRITE(85,'(8F10.3)')(RDTAI(I),I=1,MAXI)
      ENDIF
C      write(6,*)'i got here 5 num_rays = ',num_rays
C Change made Dec 2021 to delete sweeps in F. Zhang-style superobs where
C  fore and aft cannot be determined.  This should only really occur with
C  data that were obtained in track-normal scanning
      IF(NUM_RAYS.GE.30.AND.ICALLSWEEPIN.NE.0.AND.PELEV(30).NE.0.)THEN
C       WRITE(6,'(A)')'PELEV'
C       WRITE(6,'(10F8.2)')(PELEV(J),J=1,20)
       DO J=1,NUM_RAYS
        IF(J.EQ.1.AND.ICALLSWEEPIN.EQ.0)THEN
         WRITE(6,*)(RDTAI(I),I=1,MAXI)
        ENDIF
c       write(6,*)'j,eev(j),sweep(4,5),dbz(4,5) = ',
c     +   j,eev(j),sweep(4,j),sweep(5,j),sweepz(4,j),sweep(5,j)
        DO I=1,NBINS
         ISWEEP(I,J)=NINT(SWEEP(I,J)*10)
        ENDDO
        ISWEEPVTTEST=1
c       IF(IAZM(J).EQ.1)THEN
c        WRITE(86,IOSTAT=IERR,ERR=1040)TMSWEEP(J),RRLAT(J),RRLON(J),
c     +    RRA(J),EAZM(J),EEV(J),(SWEEPVT(I,J),I=1,MAXI)
c        WRITE(85,'(8F10.3)')TMSWEEP(J),RRLAT(J),RRLON(J),
c     +    RRA(J),EAZM(J),EEV(J),(SWEEPVT(I,J),I=1,MAXI)
c        WRITE(6,'(8F10.3)')TMSWEEP(J),RRLAT(J),RRLON(J),
c     +    RRA(J),EAZM(J),EEV(J),(SWEEPVT(I,J),I=1,MAXI)
c       ENDIF
        IF(ISWEEPVTTEST.EQ.1)THEN
         DOUBLETM=TMSWEEP(J)
         CALL SECS1970(IYEARTAPE,MONTHTAPE,IDAYTAPE,
     +   DOUBLETM,DOUBLETMJUL)
         IF(J.EQ.1)THEN
          TMSWEEPCHECK=-1000.
         WRITE(85,'(F16.3,5F10.3)')TMSWEEPCHECK,RRLAT(J),RRLON(J),
     +    RRA(J),EAZM(J),EEV(J)
         WRITE(85,'(10I6)')(ISWEEPVT(I,J),I=IBSTRSS+1,MAXISET)
          WRITE(87,'(8F10.3)')TMSWEEPCHECK,RRLAT(J),RRLON(J),
     +    RRA(J),EAZM(J),EEV(J),(SWEEPVT(I,J),I=1,MAXISET)
          WRITE(87,'(8F10.3)')TMSWEEPCHECK,RRLAT(J),RRLON(J),
     +    RRA(J),EAZM(J),EEV(J),(SWEEPZVT(I,J),I=1,MAXISET)
          IF(PELEV(30).GT.0.)THEN
           WRITE(87,'(A4)')'FORE'
          ELSEIF(PELEV(30).LT.0.)THEN
           WRITE(87,'(A4)')'AFT '
          ELSE
           WRITE(6,*)'ZERO ELEVATION FOUND'
           WRITE(6,*)'TYPE lower case "go" to continue'
c           PAUSE
          ENDIF
         ENDIF
C         IRAYWRITE=0
C         DO I=1,MAXISET
C            IF(SWEEPVT(I,J).GT.-200.)IRAYWRITE=1
C         ENDDO
C         IF(J.LE.3.OR.IRAYWRITE.EQ.1)THEN
          WRITE(87,'(8F10.3)')TMSWEEP(J),RRLAT(J),RRLON(J),
     +    RRA(J),EAZM(J),EEV(J),(SWEEPVT(I,J),I=1,MAXISET)
          WRITE(87,'(8F10.3)')TMSWEEP(J),RRLAT(J),RRLON(J),
     +    RRA(J),EAZM(J),EEV(J),(SWEEPZVT(I,J),I=1,MAXISET)
          WRITE(85,'(F16.3,5F10.3)')DOUBLETMJUL,RRLAT(J),RRLON(J),
     +    RRA(J),EAZM(J),EEV(J)
          WRITE(85,'(10I6)')(ISWEEPVT(I,J),I=IBSTRSS+1,MAXISET)
C         ENDIF
C         IBSTT=IBST(1)
c        WRITE(85,*)IYEARTAPE,MONTHTAPE,IDAYTAPE,DOUBLETM,DOUBLETMJUL
c        WRITE(85,*)IBSTT,MAXI
C        WRITE(87,'(8F10.3)')(SWEEPVT(I,J),I=1,MAXI)
        ENDIF
       ENDDO
      ENDIF
c      WRITE(6,*)'JUST BEFORE AVERAGING INTO ABCD BINS'
c      DO J=1,NUM_RAYS
c       WRITE(6,*)'J SWEEP = ',J
c       WRITE(6,7777)(SWEEP(I,J),I=1,NBINS)
c       WRITE(6,*)'J SWEEPZ = ',J
c       WRITE(6,7777)(SWEEPZ(I,J),I=1,NBINS)
c 7777  FORMAT(10F8.2)
c      ENDDO
c      ENDDO
c      DO J=1,NUM_RAYS
c       DO I=1,NBINS
c        IF(SWEEPZ(I,J).GT.-100.)THEN
c         SWEEP(I,J)=VRRAD(I,J)
c        ELSE
c         SWEEP(I,J)=-888.8
c        ENDIF
c       ENDDO
c      ENDDO
      MAXIOLD=MAXI
      IF(SXBIG.LT.0.01)THEN
       IF(I150.EQ.1)THEN
        ITEST1=MAX_HRD_DIM
        ITEST2=-1
        ITEST3=-1
        ITEST4=-1
        MULT1=1
        MULT2=-1
        MULT3=-1
        MULT4=-1
        KSTART1=1
        KSTART2=-1000
        KSTART3=-1000
       ELSE
        MULT1=16
        MULT2=8
        MULT3=4
        KSTART1=1
        KSTART2=257
        KSTART3=385
        ITEST1=16
        ITEST2=17
        ITEST3=32
        ITEST4=33
       ENDIF
       MAXI=MAX_HRD_DIM
      ELSE
       IF(I150.EQ.1)THEN
        ITEST1=MAXISET
        ITEST2=ITEST1+1
        ITEST3=ITEST2
        ITEST4=ITEST3
        MULT1=IBINAVG
        IF(ISIGMET.EQ.5)THEN
         ITEST1=256
         MULT1=2
         MAXI=256
        ENDIF
c        MULT1=1
c        IF(ISIGMET.EQ.5)MULT1=2
        MULT2=-1
        MULT3=-1
        MULT4=-1
        KSTART1=1
        KSTART2=-1000
        KSTART3=-1000
       ELSE
        MULT1=4
        MULT2=2
        MULT3=1
c        MULT1=16
c        MULT2=8
c        MULT3=4
        KSTART1=1
        KSTART2=257
        KSTART3=385
        ITEST1=64
        ITEST2=65
        ITEST3=128
        ITEST4=129
c        ITEST1=16
c        ITEST2=17
c        ITEST3=32
c        ITEST4=33
       ENDIF
       IF(ISIGMET.EQ.8)MAXI=MAX_HRD_DIM/IBINAVG
c       WRITE(6,*)'MAXI, MAXI = ',MAXI
      ENDIF
c      WRITE(6,*)'MAXI,ITEST1,ITEST2,ITEST3,ITEST4 = ',
c     1  MAXI,ITEST1,ITEST2,ITEST3,ITEST4
c      WRITE(6,*)'I150,MULT1,MULT2,MULT3,MULT4 = ',
c     1 I150,MULT1,MULT2,MULT3,MULT4
c      WRITE(6,*)'NBINSMAX = ',NBINSMAX
c      PAUSE
c      WRITE(87,*)'ITEST1,MULT1 = ',ITEST1,MULT1
      DO J=1,NUM_RAYS
       IF(ISIGMET.EQ.5)THEN
          MAXISET2=256
          MAXISEND=256
       ELSE
          MAXISET2=MAXISET
       ENDIF
       DO I=1,MAXISET2
        IF(I.LE.ITEST1)THEN
         K=KSTART1+(I-1)*MULT1
         M=I*MULT1
        ELSEIF(I.GE.ITEST2.AND.I.LE.ITEST3)THEN
         K=KSTART2+(I-ITEST2)*MULT2
         M=K+MULT2-1
        ELSEIF(I.GE.ITEST4)THEN
         K=KSTART3+(I-ITEST4)*MULT3
         M=K+MULT3-1
        ENDIF
        SUMVRAD=0.
        SUMNVRAD=0.
        SUM=0.
        SUMD=0.
        SUMND=0.
        SUMN=0.
        RADSUM=0.
        RADSUMN=0.
c        IF(J.EQ.1)WRITE(6,*)'I,L,M,INEWRAD = ',I,L,M,INEWRAD
        DO L=K,M
c         IF(INEWRAD.EQ.1.AND.J.EQ.1)THEN
         IF(J.EQ.1)THEN
C          WRITE(6,*)'DEBUG I,L,M,NBINSMAX = ',I,L,M,NBINSMAX
         ENDIF
c         WRITE(6,*)'NBINSMAX = ',NBINSMAX
         IF(L.GT.NBINSMAX)GO TO 56652
c         IF((ICALLSWEEPIN.EQ.0..OR.INEWRAD.EQ.1).AND.J.EQ.1)THEN
         IF(J.EQ.NUM_RAYS)THEN
          IF(RDTAIIN(L).LT.200.)THEN
           RADSUMN=RADSUMN+1
           RADSUM=RADSUM+RDTAIIN(L)
c           write(6,*)'L,RADIITA,RDTAIIN = ',L,RADIITA(L),RDTAIIN(L)
          ENDIF
         ENDIF
c         if(j.eq.1)
c     1   write(6,*)'i,l,radsumn,radsum,RDTAIIN,icallsweepin = ',
c     1 i,l,radsum,radsumn,RDTAIIN(l),icallsweepin
         IF(SWEEP(L,J).GT.-888.8)THEN
          SUM=SUM+SWEEP(L,J)
          SUMN=SUMN+1.
         ENDIF
         IF(VRRAD(L,J).GT.-888.8)THEN
          SUMVRAD=SUMVRAD+VRRAD(L,J)
          SUMNVRAD=SUMNVRAD+1.
         ENDIF
         IF(SWEEPZ(L,J).GT.-20.)THEN
          SUMD=SUMD+SWEEPZ(L,J)
          SUMND=SUMND+1.
         ENDIF
        ENDDO
56652   IF(SUMN.GT.0..AND.IBLANKSWEEP.EQ.0)THEN
         SWEEP(I,J)=SUM/SUMN
        ELSE
         SWEEP(I,J)=-888.8
        ENDIF
        IF(SUMNVRAD.GT.0.)THEN
         VRRAD(I,J)=SUMVRAD/SUMNVRAD
        ELSE
         VRRAD(I,J)=-888.8
        ENDIF
c        IF((ICALLSWEEPIN.EQ.0..OR.INEWRAD.EQ.1).AND.J.EQ.1)THEN
        IF(J.EQ.NUM_RAYS)THEN
         IF(RADSUMN.GT.0.)THEN
          RDTAI2(I)=RADSUM/RADSUMN
         ELSE
          RDTAI2(I)=1000.
         ENDIF
        ENDIF
        IF(SUMND.GT.0..AND.IBLANKSWEEP.EQ.0)THEN
         SWEEPZ(I,J)=SUMD/SUMND
        ELSE
         SWEEPZ(I,J)=-32.
        ENDIF
c        if(j.eq.1)then
c         write(6,*)'sum,sumn,sumnd,sumd,radsum,radsumn = ',
c     1             sum,sumn,sumnd,sumd,radsum,radsumn
c         write(6,*)'i,rdtai,sweep,sweepz = ',
c     1             i,rdtai(i),sweep(i,j),sweepz(i,j)
c        endif
       ENDDO
      ENDDO
c      WRITE(87,*)'TWO RDTAI(10) = ',RDTAI(10)
      DO I=2,MAXISET2
       IF(RDTAI2(I).GT.0..AND.RDTAI2(I).LT.500.)THEN
        MAXI2=I
       ENDIF
c       WRITE(6,*)'RDTAI(I),MAXI2 = ',RDTAI(I),MAXI2
      ENDDO
c      WRITE(6,*)'MAXI2 = ',MAXI2
      MAXI=MAXI2
C      write(6,*)'i got here 2'
      IF(ICALLSWEEPIN.EQ.0)THEN
       WRITE(83)IYEAR,MONTH,IDAY,MAXI
       WRITE(82,'(3I2,1X,I3)')IYEAR,MONTH,IDAY,MAXI
      ENDIF
C      write(6,*)'i got here 3 maxi = ',maxi
      IF(RDTAI(10).NE.RADTEST2.OR.INEWRAD.EQ.1)THEN
       INEWRAD2=1
       WRITE(83)(RDTAI(I),I=1,MAXI)
       WRITE(82,'(8F10.3)')(RDTAI(I),I=1,MAXI)
      ELSE
       INEWRAD2=0
      ENDIF
      INEWRAD2=0
C      WRITE(87,*)'TWO RDTAI(10),RADTEST2 = ',RDTAI(10),RADTEST2
C      RADTEST2=RDTAI(10)
C      WRITE(87,*)'TWOA RDTAI(10),RADTEST2 = ',RDTAI(10),RADTEST2
C      write(6,*)'i got here 4'
      IF(ICALLSWEEPIN.NE.0.AND.INEWRAD2.EQ.1)THEN
       J=1
       TIMERAD=-1.
       DO I=1,NBINS
        ISWEEP(I,J)=NINT(SWEEP(I,J)*10)
       ENDDO
c       WRITE(83,IOSTAT=IERR,ERR=1040)TIMERAD,RRLAT(J),RRLON(J),
c     +    RRA(J),EAZM(J),EEV(J),(ISWEEP(I,J),I=1,MAXI)
       WRITE(82,'(8F10.3)')TIMRAD,RRLAT(J),RRLON(J),
     +    RRA(J),EAZM(J),EEV(J),(SWEEP(I,J),I=1,MAXI)
      ENDIF
C      write(6,*)'i got here 5 num_rays = ',num_rays
      DO J=1,NUM_RAYS
       I=1
c       DO WHILE(RDTAI(I).LE.3..OR.RDTAI(I).GT.999.9)
c        SWEEP(I,J)=-888.8
c        SWEEPZ(I,J)=-32.
c        I=I+1
c       ENDDO
       IF(J.EQ.1.AND.ICALLSWEEPIN.EQ.0)THEN
        WRITE(6,*)(RDTAI(I),I=1,MAXI)
       ENDIF
c       write(6,*)'j,eev(j),sweep(4,5),dbz(4,5) = ',
c     +   j,eev(j),sweep(4,j),sweep(5,j),sweepz(4,j),sweep(5,j)
       DO I=1,NBINS
        ISWEEP(I,J)=NINT(SWEEP(I,J)*10)
       ENDDO
       IF(IAZM(J).EQ.1)THEN
c        WRITE(83,IOSTAT=IERR,ERR=1040)TMSWEEP(J),RRLAT(J),RRLON(J),
c     +    RRA(J),EAZM(J),EEV(J),(ISWEEP(I,J),I=1,MAXI)
        WRITE(82,'(8F10.3)')TMSWEEP(J),RRLAT(J),RRLON(J),
     +    RRA(J),EAZM(J),EEV(J),(SWEEP(I,J),I=1,MAXI)
       ENDIF
      ENDDO
c      DO J=1,NUM_RAYS
c       DO I=1,NBINS
c        IF(SWEEPZ(I,J).GT.-100.)THEN
c         SWEEP(I,J)=VRRAD(I,J)
c        ELSE
c         SWEEP(I,J)=-888.8
c        ENDIF
c       ENDDO
c      ENDDO
      ANGTEST=-999.9
      AZMSLOPE=-999.9
c      WRITE(6,*)'MAXI = ',MAXI
c      WRITE(6,*)'INEWRAD = ',INEWRAD
c      WRITE(6,*)'ELEV = ',PELEV(NUM_RAYS)
c      IF(INEWRAD.EQ.1)PAUSE
c      WRITE(6,*)'DBZRADIUSMIN = ',DBZRADIUSMIN
c      PAUSE
      MAXI=MAXISEND
      IF(ISIGMET.EQ.5)MAXI=256
      IF(ICALLSWEEPIN.EQ.0)THEN
       ICALLSWEEPIN=1
       GO TO 4275
      ENDIF
      RETURN
      END 
c      SUBROUTINE AZIUNFLD(SWEEP,ISEG,ISEGE,MAX_GATES,MAX_RAYS,
c     1 XXNIQTA,RDTAI,AZ_EL,XXNIQ,NUM_RAYS,VRRAD,IUSEWIND)
c      REAL SWEEP(MAX_GATES,MAX_RAYS)
c      INTEGER ISEG(MAX_GATES,MAX_RAYS),ISEGE(MAX_GATES,MAX_RAYS)
c      REAL RDTAI(MAX_GATES),AZ_EL(2,MAX_RAYS)
c      REAL VRRAD(MAX_GATES,MAX_RAYS)
c      REAL SWEEPKEEP(512,800)
c      XXNIQ2=XXNIQ*2.
cc      OPEN(77,FILE='lister')
cc      IF(IUSEWIND.NE.1)THEN
c      write(6,*)'iusewind = ',iusewind
c      write(6,*)'setting sweepkeep'
c       DO J=1,NUM_RAYS
c        DO I=1,MAX_GATES
c         SWEEPKEEP(I,J)=SWEEP(I,J)
c        ENDDO
c       ENDDO
cc      ENDIF
c      DO J=1,NUM_RAYS
c       IFIRST=0
c       DO I=1,MAX_GATES
c        ISEG(I,J)=0
c       ENDDO
c       DO I=1,512
c        IF(SWEEP(I,J).GT.-800..AND.IFIRST.EQ.0)THEN
cC---VERY FIRST GOOD GATE IN RAY
c         BEFORE=SWEEP(I,J)
c         IFIRST=1
c         ISEG(I,J)=-1
c         ILAST=I
c        ELSEIF(SWEEP(I,J).GT.-800.)THEN
c         IF(ABS(SWEEP(I,J)-BEFORE).GE.XXNIQTA.OR.
c     1      RDTAI(I)-RDTAI(ILAST).GT..9)THEN
cC---DIFFERENCE BETWEEN GATE AND PREVIOUS GOOD GATE MORE THEN .7*VNYQ
cc         WRITE(6,*)'SWEEP,BEFORE,XNIQTA7 = ',
cc     1               SWEEP(I,J),BEFORE,XXNIQTA
cc          WRITE(6,*)'RDTAII,RDTAILAST = ',RDTAI(I),RDTAI(ILAST)
cC
cC---ISEG AT THE LAST GOOD GATE BEFORE THIS LARGE SHIFT IS SET TO 1
c          ISEG(ILAST,J)=1
c          ISEG(I,J)=-1
cC---ISEG AT THIS BREAKPOINT IS SET TO -1
cc          WRITE(6,*)'ILAST,I,AZ_EL = ',ILAST,I,AZ_EL(1,J)
c         ENDIF
cC
cC---GOOD VALUES SET ILAST AND BEFORE TO THESE VALUES
c         ILAST=I
c         BEFORE=SWEEP(I,J)
c        ENDIF
c       ENDDO
cC---VERY LAST GOOD VALUE GETS AN ISEG VALUE OF 1
c       IF(IFIRST.EQ.1)ISEG(ILAST,J)=1
c       IISEGE=-1
c       DO I=MAX_GATES,1,-1
c        IF(ISEG(I,J).EQ.1)THEN
c         IISEGE=I
c         ISEGE(I,J)=IISEGE
c        ELSEIF(ISEG(I,J).EQ.-1)THEN
c         ISEGE(I,J)=IISEGE
c         IISEGE=-1
c        ELSE
c         ISEGE(I,J)=IISEGE
c        ENDIF
c       ENDDO
cc       WRITE(77,'(F10.2,2I5,F10.2)')
cc     1        (SWEEP(I,J),ISEGE(I,J),I,AZ_EL(1,J),I=1,512)       
c      ENDDO
cc      CLOSE(77)
c      IUSETEST=0
c      DO J=2,NUM_RAYS
c       JMAX=J-1
cc       WRITE(6,*)'J,AZ_EL = ',J,AZ_EL(1,J)
c       IF(AZ_EL(1,J).GT.180..AND.AZ_EL(1,J).LT.320.)GO TO 777
c       I=1
c       DO WHILE(I.LE.511)
c        IF(SWEEP(I,J).GT.-800.AND.SWEEP(I,J-1).GT.-800.)THEN
c         NSUM=0
c         SUM=0
c         N=ISEGE(I,J)
c         DO L=I,N
c          IF(SWEEP(L,J).GT.-800.AND.SWEEP(L,J-1).GT.-800.)THEN
c           SUM=SUM+SWEEP(L,J)-SWEEP(L,J-1)
c           NSUM=NSUM+1
c          ENDIF
c         ENDDO
cc         write(6,*)'j,i,n,sum,nsum = ',j,i,n,sum,nsum
c         IF(NSUM.GE.1)THEN
c          DIFMEAN=SUM/NSUM
c          IF(DIFMEAN.GT.XXNIQ)THEN
c           CHANGE=NINT(DIFMEAN/XXNIQ2)*XXNIQ2
cc           write(6,*)'j,nsum,difmean,change,xxniq,xxniq2 = ',
cc     1      j,nsum,difmean,change,xxniq,xxniq2
c           DO L=I,N
c            IF(SWEEP(L,J).GT.-800.)SWEEP(L,J)=SWEEP(L,J)-CHANGE
c           ENDDO
c          ELSEIF(DIFMEAN.LT.-XXNIQ)THEN
c           CHANGE=NINT(DIFMEAN/XXNIQ2)*XXNIQ2
cc           write(6,*)'j,nsum,difmean,change,xxniq,xxniq2 = ',
cc     1      j,nsum,difmean,change,xxniq,xxniq2
c           DO L=I,N
c            IF(SWEEP(L,J).GT.-800.)SWEEP(L,J)=SWEEP(L,J)-CHANGE
c           ENDDO
c          ENDIF
c         ENDIF
c         I=N+1
c        ELSE
c         I=I+1
c        ENDIF
c       ENDDO        
c      ENDDO
c777   NSUM=0
c      SUM=0.
c      DO J=1,JMAX
c       DO I=1,512
c        IF(SWEEP(I,J).GT.-800.AND.VRRAD(I,J).GT.-800.)THEN
c         DIFF=SWEEP(I,J)-VRRAD(I,J)
c         NSUM=NSUM+1
c         SUM=SUM+DIFF
c        ENDIF
c       ENDDO
c      ENDDO
c      IF(NSUM.GT.0)THEN
c       IUSETEST=1
c       DIFF=SUM/FLOAT(NSUM)
c       write(6,*)'difference on right side is ',DIFF
c       IF(ABS(DIFF).GT.XXNIQ)THEN
c        IF(DIFF.GT.0.)THEN
c         VCHANGE=-XXNIQ2
c        ELSE
c         VCHANGE=XXNIQ2
c        ENDIF
c        DO J=1,JMAX
c         DO I=1,512
c          IF(SWEEP(I,J).GT.-800.)THEN
c           SWEEP(I,J)=SWEEP(I,J)+VCHANGE
c          ENDIF
c         ENDDO
c        ENDDO
c       ENDIF
c      ELSE
c       IUSETEST=0
c      ENDIF
c      IF(IUSEWIND.NE.1.OR.IUSETEST.NE.1)THEN
c       NSUM=0
c       SUM=0
c       DO J=1,JMAX
c        DO I=1,512
c         IF(SWEEP(I,J).GT.-800.AND.SWEEPKEEP(I,J).GT.-800.)THEN
c          SUM=SUM+SWEEP(I,J)-SWEEPKEEP(I,J)
c          NSUM=NSUM+1
c         ENDIF
c        ENDDO
c       ENDDO
cc       write(6,*)'iusewind,sum,nsum = ',iusewind,sum,nsum
c       IF(NSUM.GT.0)THEN
c        DIFFMEAN=SUM/NSUM
c        CHANGE=0.
c        IF(DIFFMEAN.GT.XXNIQ)THEN
c         CHANGE=-XXNIQ2
c        ELSEIF(DIFFMEAN.LT.-XXNIQ)THEN
c         CHANGE=XXNIQ2
c        ENDIF
c        write(6,*)'right change = ',change
c        IF(CHANGE.NE.0.)THEN
c         write(6,*)'changing'
c         DO J=1,JMAX
c          DO I=1,512
c           IF(SWEEP(I,J).GT.-800.)THEN
c            SWEEP(I,J)=SWEEP(I,J)+CHANGE
c           ENDIF
c          ENDDO
c         ENDDO
c        ENDIF
c       ENDIF
c      ENDIF
c      IUSETEST=0
c      DO J=NUM_RAYS-1,1,-1
c       JMIN=J+1
cc       WRITE(6,*)'J,AZ_EL = ',J,AZ_EL(1,J)
c       IF(AZ_EL(1,J).LT.180..AND.AZ_EL(1,J).GT.40.)GO TO 778
c       I=1
c       DO WHILE(I.LE.511)
c        IF(SWEEP(I,J).GT.-800.AND.SWEEP(I,J+1).GT.-800.)THEN
c         NSUM=0
c         SUM=0
c         N=ISEGE(I,J)
c         DO L=I,N
c          IF(SWEEP(L,J).GT.-800.AND.SWEEP(L,J+1).GT.-800.)THEN
c           SUM=SUM+SWEEP(L,J)-SWEEP(L,J+1)
c           NSUM=NSUM+1
c          ENDIF
c         ENDDO
c         IF(NSUM.GE.1)THEN
c          IUSETEST=1
c          DIFMEAN=SUM/NSUM
c          IF(DIFMEAN.GT.XXNIQ)THEN
c           CHANGE=NINT(DIFMEAN/XXNIQ2)*XXNIQ2
cc           write(6,*)'j,nsum,difmean,change,xxniq,xxniq2 = ',
cc     1      j,nsum,difmean,change,xxniq,xxniq2
c           DO L=I,N
c            IF(SWEEP(L,J).GT.-800.)SWEEP(L,J)=SWEEP(L,J)-CHANGE
c           ENDDO
c          ELSEIF(DIFMEAN.LT.-XXNIQ)THEN
c           CHANGE=NINT(DIFMEAN/XXNIQ2)*XXNIQ2
cc           write(6,*)'j,nsum,difmean,change,xxniq,xxniq2 = ',
cc     1      j,nsum,difmean,change,xxniq,xxniq2
c           DO L=I,N
c            IF(SWEEP(L,J).GT.-800.)SWEEP(L,J)=SWEEP(L,J)-CHANGE
c           ENDDO
c          ENDIF
c         ENDIF
c         I=N+1
c        ELSE
c         I=I+1
c        ENDIF
c       ENDDO        
c      ENDDO
c778   NSUM=0
c      SUM=0.
c      DO J=JMIN,NUM_RAYS
c       DO I=1,512
c        IF(SWEEP(I,J).GT.-800.AND.
c     1      VRRAD(I,J).GT.-800.)THEN
c         DIFF=SWEEP(I,J)-VRRAD(I,J)
c         NSUM=NSUM+1
c         SUM=SUM+DIFF
c        ENDIF
c       ENDDO
c      ENDDO
c      IF(NSUM.GT.0)THEN
c       IUSETEST=1
c       DIFF=SUM/FLOAT(NSUM)
c       write(6,*)'difference on left side is ',DIFF
c       IF(ABS(DIFF).GT.XXNIQ)THEN
c        IF(DIFF.GT.0.)THEN
c         VCHANGE=-XXNIQ2
c        ELSE
c         VCHANGE=XXNIQ2
c        ENDIF
c        DO J=JMIN,NUM_RAYS
c         DO I=1,512
c          IF(SWEEP(I,J).GT.-800.)THEN
c           SWEEP(I,J)=SWEEP(I,J)+VCHANGE
c          ENDIF
c         ENDDO
c        ENDDO
c       ENDIF
c      ELSE
c       IUSETEST=0
c      ENDIF
c      IF(IUSEWIND.NE.1.OR.IUSETEST.NE.1)THEN
c       NSUM=0
c       SUM=0
c       DO J=JMIN,NUM_RAYS
c        DO I=1,512
c         IF(SWEEP(I,J).GT.-800.AND.SWEEPKEEP(I,J).GT.-800.)THEN
c          SUM=SUM+SWEEP(I,J)-SWEEPKEEP(I,J)
c          NSUM=NSUM+1
c         ENDIF
c        ENDDO
c       ENDDO
c       WRITE(6,*)'LEFT SIDE SUM,NSUM = ',SUM,NSUM
c       IF(NSUM.GT.0)THEN
c        DIFFMEAN=SUM/NSUM
c        CHANGE=0.
c        IF(DIFFMEAN.GT.XXNIQ)THEN
c         CHANGE=-XXNIQ2
c        ELSEIF(DIFFMEAN.LT.-XXNIQ)THEN
c         CHANGE=XXNIQ2
c        ENDIF
c        write(6,*)'left change = ',change
c        IF(CHANGE.NE.0.)THEN
c         write(6,*)'changing'
c         DO J=JMIN,NUM_RAYS
c          DO I=1,512
c           IF(SWEEP(I,J).GT.-800.)THEN
c            SWEEP(I,J)=SWEEP(I,J)+CHANGE
c           ENDIF
c          ENDDO
c         ENDDO
c        ENDIF
c       ENDIF
c      ENDIF
c      RETURN
c      END
      SUBROUTINE GROUNDCHECK(SWEEP,SWEEPZ,NUM_RAYS,I,JSTART,ICHECK,
     + ZRSWEEP,RD)
      INCLUDE "hrd_radar_settings.f"
      PARAMETER(MAX_RAYS=800)
      PARAMETER(MAX_GATES=MAX_HRD_DIM)
      REAL SWEEP(MAX_GATES,MAX_RAYS),SWEEPZ(MAX_GATES,MAX_RAYS)
      REAL ZRSWEEP(MAX_GATES,MAX_RAYS)
      REAL RD(MAX_GATES)
      IF(ICHECK.LT.1.OR.ICHECK.GT.2)THEN
       WRITE(6,*)'PROBLEM WITH ICHECK IN GROUNDCHECK'
       STOP
      ENDIF
c      IF(JSTART.GT.2.AND.JSTART.LT.NUM_RAYS-1)THEN
c       WRITE(6,*)'I,JSTART,SWEEPZ = ',I,JSTART,
c     + (SWEEPZ(I,J),J=JSTART-2,JSTART)
c      ENDIF
c      PAUSE
      IF(SWEEPZ(I,JSTART).GT.-32.)THEN
       WRITE(6,*)'SWEEP(I,JSTART) GT -999.'
       WRITE(6,*)'ICHECK,I,JSTART,SWEEP,SWEEPZ = ',
     +  ICHECK,I,JSTART,SWEEP(I,JSTART),SWEEPZ(I,JSTART)
       STOP
      ENDIF
      IDBZTEST=0
c      WRITE(6,*)'GROUNDCHECK STARTING AND JSTART = ',JSTART
c      IF(ICHECK.EQ.1.AND.JSTART.GE.5)THEN
c       JSTARTCHECK1=0
c       DO J=JSTART,JSTART-4
c        IF(SWEEPZ(I,J).GT.48.)JSTARTCHECK1=1
c       ENDDO
c       IF(JSTARTCHECK1.EQ.1)THEN
c         J=JSTART
c         WRITE(6,6296)J,(SWEEPZ(I,J),J=JSTART,JSTART-4,-1)
c 6296    FORMAT(I5,6F10.2)
c       ENDIF
c      ELSEIF(ICHECK.EQ.2.AND.JSTART+4.LE.NUM_RAYS)THEN
c       JSTARTCHECK2=0
c       DO J=JSTART,JSTART+4
c        IF(SWEEPZ(I,J).GT.48.)JSTARTCHECK2=1
c       ENDDO
c       IF(JSTARTCHECK2.EQ.1)THEN
c         J=JSTART
c         WRITE(6,6296)J,(SWEEPZ(I,J),J=JSTART,JSTART+4)
c       ENDIF
c      ENDIF
      IF(ICHECK.EQ.1)THEN
       IF(JSTART.LT.5)THEN
        DO J=JSTART,1,-1
         SWEEPZ(I,J)=-32.
         SWEEP(I,J)=-888.8
        ENDDO
        RETURN
       ELSE
        IF(SWEEPZ(I,JSTART-1).GT.40..OR.
     +     SWEEPZ(I,JSTART-4).GT.40.)IDBZTEST=1
c        IF(IDBZTEST.GT.0)WRITE(6,*)'BEFORE RIGHT,JSTART,SWEEPZ = ',
c     +    JSTART,(SWEEPZ(I,J),J=JSTART-9,JSTART)
       ENDIF
c       WRITE(6,*)'I,JSTART,SWEEPZ = ',
c     +  I,J,(SWEEPZ(I,J),J=JSTART-2,JSTART)
       IF(SWEEPZ(I,JSTART).LE.-32..AND.SWEEPZ(I,JSTART-1).GT.-32..AND.
     +    SWEEP(I,JSTART-2).LE.-32.)THEN
        SWEEPZ(I,JSTART-1)=-32.
        SWEEP(I,JSTART-1)=-888.8
c        write(6,*)'removed'
       ENDIF
       IF(SWEEPZ(I,JSTART).LE.-32..AND.SWEEPZ(I,JSTART-1).GT.-32..AND.
     +    SWEEP(I,JSTART-3).LE.-32.)THEN
        SWEEPZ(I,JSTART-1)=-32.
        SWEEP(I,JSTART-1)=-888.8
        SWEEPZ(I,JSTART-2)=-32.
        SWEEP(I,JSTART-2)=-888.8
c        write(6,*)'removed 2'
       ENDIF
       IF(SWEEPZ(I,JSTART).LE.-32..AND.SWEEPZ(I,JSTART-1).GT.-32..AND.
     +    SWEEP(I,JSTART-4).LE.-32.)THEN
        SWEEPZ(I,JSTART-1)=-32.
        SWEEP(I,JSTART-1)=-888.8
        SWEEPZ(I,JSTART-2)=-32.
        SWEEP(I,JSTART-2)=-888.8
        SWEEPZ(I,JSTART-3)=-32.
        SWEEP(I,JSTART-3)=-888.8
c        write(6,*)'removed 3'
       ENDIF
       DO J=JSTART-1,JSTART-3,-1
        IF(SWEEPZ(I,J).GT.-32..AND.SWEEPZ(I,J-1).GT.-32.AND.
     +      SWEEPZ(I,J)-SWEEPZ(I,J-1).GT.3.)THEN
c        IF(SWEEPZ(I,J)-SWEEPZ(I,J-1).GT.10.)THEN
         DO JJ=J,JSTART
          SWEEPZ(I,JJ)=-32.
          SWEEP(I,JJ)=-888.8
         ENDDO
        ENDIF
       ENDDO
c       IF(IDBZTEST.GT.0)WRITE(6,*)'AFTER RIGHT,JSTART,SWEEPZ = ',
c     +   JSTART,(SWEEPZ(I,J),J=JSTART-9,JSTART)
c       IF(IDBZTEST.GT.0)WRITE(6,*)'ZR AFTER RIGHT,JSTART,SWEEPZ = ',
c     +   JSTART,(ZRSWEEP(I,J),J=JSTART-9,JSTART)
c       IF(IDBZTEST.GT.0)WRITE(6,*)'RADIUS = ',RD(I)
c       IF(SWEEPZ(I,JSTART-9).GT.20.)THEN
c        WRITE(6,*)'SWEEPZ(I,JSTART-9) = ',SWEEPZ(I,JSTART-9)
c        WRITE(6,*)'ZRSWEEP(I,JSTART-9) = ',ZRSWEEP(I,JSTART-9)
c       WRITE(6,*)'RADIUS = ',RD(I)
c        PAUSE
c       ENDIF
      ELSE
       IF(NUM_RAYS-JSTART.LT.4)THEN
        DO J=JSTART,NUM_RAYS
         SWEEPZ(I,J)=-32.
         SWEEP(I,J)=-888.8
        ENDDO
        RETURN
       ELSE
        IF(SWEEPZ(I,JSTART+1).GT.40..OR.
     +     SWEEPZ(I,JSTART+4).GT.40.)IDBZTEST=1
c        IF(IDBZTEST.GT.0)WRITE(6,*)'BEFORE LEFT,JSTART,SWEEPZ = ',
c     +   JSTART,(SWEEPZ(I,J),J=JSTART,JSTART+9)
       ENDIF
c       WRITE(6,*)'I,JSTART,SWEEPZ = ',
c     +  I,J,(SWEEPZ(I,J),J=JSTART+1,JSTART+2)
       IF(SWEEPZ(I,JSTART).LE.-32..AND.SWEEPZ(I,JSTART+1).GT.-32..AND.
     +    SWEEP(I,JSTART+2).LE.-32.)THEN
        SWEEPZ(I,JSTART+1)=-32.
        SWEEP(I,JSTART+1)=-888.8
c        write(6,*)'removed'
       ENDIF
       IF(SWEEPZ(I,JSTART).LE.-32..AND.SWEEPZ(I,JSTART+1).GT.-32..AND.
     +    SWEEP(I,JSTART+3).LE.-32.)THEN
        SWEEPZ(I,JSTART+1)=-32.
        SWEEP(I,JSTART+1)=-888.8
        SWEEPZ(I,JSTART+2)=-32.
        SWEEP(I,JSTART+2)=-888.8
c        write(6,*)'removed 2'
       ENDIF
       IF(SWEEPZ(I,JSTART).LE.-32..AND.SWEEPZ(I,JSTART+1).GT.-32..AND.
     +    SWEEP(I,JSTART+4).LE.-32.)THEN
        SWEEPZ(I,JSTART+1)=-32.
        SWEEP(I,JSTART+1)=-888.8
        SWEEPZ(I,JSTART+2)=-32.
        SWEEP(I,JSTART+2)=-888.8
        SWEEPZ(I,JSTART+3)=-32.
        SWEEP(I,JSTART+3)=-888.8
c        write(6,*)'removed 3'
       ENDIF
       DO J=JSTART+1,JSTART+3
c        IF(SWEEPZ(I,J)-SWEEPZ(I,J+1).GT.10.)THEN
        IF(SWEEPZ(I,J).GT.-32..AND.SWEEPZ(I,J+1).GT.-32.AND.
     +      SWEEPZ(I,J)-SWEEPZ(I,J+1).GT.3.)THEN
         DO JJ=J,JSTART,-1
          SWEEPZ(I,JJ)=-32.
          SWEEP(I,JJ)=-888.8
         ENDDO
        ENDIF
       ENDDO
c       IF(IDBZTEST.GT.0)WRITE(6,*)'AFTERLEFT,JSTART,SWEEPZ = ',
c     +            JSTART,(SWEEPZ(I,J),J=JSTART,JSTART+9)
c       IF(IDBZTEST.GT.0)WRITE(6,*)'ZR AFTERLEFT,JSTART,SWEEPZ = ',
c     +            JSTART,(ZRSWEEP(I,J),J=JSTART,JSTART+9)
c       IF(IDBZTEST.GT.0)WRITE(6,*)'RADIUS = ',RD(I)
c       IF(SWEEPZ(I,JSTART+4).GT.20.)THEN
c        WRITE(6,*)'SWEEPZ(I,JSTART+9) = ',SWEEPZ(I,JSTART+9)
c        WRITE(6,*)'ZRSWEEP(I,JSTART+9) = ',ZRSWEEP(I,JSTART+9)
c        WRITE(6,*)'RADIUS = ',RD(I)
c        PAUSE
c       ENDIF
      ENDIF
c      WRITE(6,*)'GROUNDCHECK RETURNING'
c      IF(ICHECK.EQ.1.AND.JSTART.GE.5)THEN
c       JSTARTCHECK1=0
c       DO J=JSTART,JSTART-4
c        IF(SWEEPZ(I,J).GT.48.)JSTARTCHECK1=1
c       ENDDO
c       IF(JSTARTCHECK1.EQ.1)THEN
c         J=JSTART
c         WRITE(6,6296)J,(SWEEPZ(I,J),J=JSTART,JSTART-4,-1)
c         PAUSE
c       ENDIF
c      ELSEIF(ICHECK.EQ.2.AND.JSTART+4.LE.NUM_RAYS)THEN
c       JSTARTCHECK2=0
c       DO J=JSTART,JSTART+4
c        IF(SWEEPZ(I,J).GT.48.)JSTARTCHECK2=1
c       ENDDO
c       IF(JSTARTCHECK2.EQ.1)THEN
c         J=JSTART
c         WRITE(6,6296)J,(SWEEPZ(I,J),J=JSTART,JSTART+4)
c         PAUSE
c       ENDIF
c      ENDIF
      RETURN
      END
C ********************
      SUBROUTINE SVGROUNDCHECK(SWEEP,SWEEPZ,NUM_RAYS,I,JSTART,ICHECK)
      REAL SWEEP(2048,800),SWEEPZ(2048,800)
      IF(ICHECK.LT.1.OR.ICHECK.GT.2)THEN
       WRITE(6,*)'PROBLEM WITH ICHECK IN GROUNDCHECK'
       STOP
      ENDIF
      IF(SWEEPZ(I,JSTART).GT.-32.)THEN
       WRITE(6,*)'SWEEP(I,JSTART) GT -999.'
       WRITE(6,*)'ICHECK,I,JSTART,SWEEP,SWEEPZ = ',
     +  ICHECK,I,JSTART,SWEEP(I,JSTART),SWEEPZ(I,JSTART)
       STOP
      ENDIF
      IF(ICHECK.EQ.1)THEN
       IF(JSTART.LT.5)RETURN
       J=JSTART-4
c       WRITE(6,*)'RIGHT,I,JSTART,VEL = ',I,JSTART,
c     +             (SWEEP(I,L),L=J,JSTART)
c       WRITE(6,*)'RIGHT,I,JSTART,DBZ = ',I,JSTART,
c     +             (SWEEPZ(I,L),L=J,JSTART)
      SWTEST1=SWEEPZ(I,JSTART-1)-SWEEPZ(I,JSTART-3)
      SWTEST2=SWEEPZ(I,JSTART-2)-SWEEPZ(I,JSTART-3)
      IF(SWTEST1.GT.5..OR.SWTEST2.GT.5.)THEN
C       IF((SWEEPZ(I,JSTART-1).GT.-32..OR.SWEEPZ(I,JSTART-2).GT.-32.).
C     +  AND.SWEEPZ(I,JSTART-3).LE.-32.)THEN
        SWEEPZ(I,JSTART-1)=-32.
        SWEEPZ(I,JSTART-2)=-32.
        SWEEPZ(I,JSTART-3)=-32.
        SWEEP(I,JSTART-1)=-888.8
        SWEEP(I,JSTART-2)=-888.8
        SWEEP(I,JSTART-3)=-888.8
       ENDIF
c       WRITE(6,*)'RIGHT,I,JSTART,VEL = ',I,JSTART,
c     +             (SWEEP(I,L),L=J,JSTART)
c       WRITE(6,*)'RIGHT,I,JSTART,DBZ = ',I,JSTART,
c     +             (SWEEPZ(I,L),L=J,JSTART)
      ELSE
       IF(NUM_RAYS-JSTART.LT.4)RETURN
       JEND=JSTART+4
c       WRITE(6,*) 'LEFT,I,JSTART,VEL = ',I,JSTART,
c     +             (SWEEP(I,L),L=JSTART,JEND)
c       WRITE(6,*) 'LEFT,I,JSTART,DBZ = ',I,JSTART,
c     +             (SWEEPZ(I,L),L=JSTART,JEND)
       SWTEST1=SWEEPZ(I,JSTART+1)-SWEEPZ(I,JSTART+3)
       SWTEST2=SWEEPZ(I,JSTART+2)-SWEEPZ(I,JSTART+3)
       IF(SWTEST1.GT.5..OR.SWTEST2.GT.5.)THEN
C       IF((SWEEPZ(I,JSTART+1).GT.-32..OR.SWEEPZ(I,JSTART+2).GT.-32.).
C     +  AND.SWEEPZ(I,JSTART+3).LE.-32.)THEN
        SWEEPZ(I,JSTART+1)=-32.
        SWEEPZ(I,JSTART+2)=-32.
        SWEEPZ(I,JSTART+3)=-32.
        SWEEP(I,JSTART+1)=-888.8
        SWEEP(I,JSTART+2)=-888.8
        SWEEP(I,JSTART+3)=-888.8
       ENDIF
c       WRITE(6,*) 'LEFT,I,JSTART,VEL = ',I,JSTART,
c     +             (SWEEP(I,L),L=JSTART,JEND)
c       WRITE(6,*) 'LEFT,I,JSTART,DBZ = ',I,JSTART,
c     +             (SWEEPZ(I,L),L=JSTART,JEND)
      ENDIF
      RETURN
      END
C ********************
      SUBROUTINE READTAPE(TIME,RLAT,RLON,RA,AZM,EV,BIN,REF,BIN1,REF1,
     +                    RCAZM,ITAPEOPEN,RADARFILE,NUMREC,
     +                    PCORS,DCORS,RCORS,AZMCORS,
     +                    RDELCORTAS,ELCORS,ISIGMET,NDO)
      INCLUDE "hrd_radar_common_blocks_johns.f"
c      common/rvp8_files/sweep_open,current_fptr,current_fn
      COMMON /AREA1/ INM,IFLT,STIME,ETIME,WD,WS,NIX,NGATE1,LP,LUNR,
     +               IVT,RAMFL
      COMMON /PARAMS/ trakazm,trakelev,driftnew,
     +                rot,track,htbb,dbb,thresh,swthresh,dbzrs,ibst(2),
     +                inob(2),ileg,xniq,irsw,maxnbins,v0,
     +                pcor,dcor,rcor,azmcor,elcor,dbzcor,dbzslope,
     +                iunfoldflag,iattenflag,
     +                badstabflag,surfelimflag,echoflag,atmflag
      LOGICAL badstabflag, surfelimflag, echoflag, atmflag
c      logical*8 sweep_open
c      character*132 current_fn
c      integer*8 current_fptr
      INTEGER RTYPE
      REAL PCORS(2),DCORS(2),RCORS(2),AZMCORS(2)
      REAL RDELCORTAS(2),ELCORS(2)
      CHARACTER IFLT*8, INM*12
      CHARACTER *1 RAMFL, IVT
      CHARACTER*80 RADARFILE
      DIMENSION BIN(MAX_HRD_DIM),REF(MAX_HRD_DIM)
      DIMENSION BIN1(MAX_HRD_DIM),REF1(MAX_HRD_DIM)
      DATA RTYPE/6/
C Subroutine to read doppler and Reflectivity data from the new 1988
C format radar tapes.  Reads refl/doppler when rtype=6 and dop/ref/sw when
C rtype=7.  It returns one ray per call.
C NIX = -100 determines an end-of-file
C Read data from tape:
      NIX=0
      IHEADERFLAG=1
      DO I=1,MAX_HRD_DIM
       BIN(I)=-888.8
       REF(I)=-32.
       BIN1(I)=-888.8
       REF1(I)=-32.
      ENDDO
      IF (SWTHRESH.GT.0.0 .AND. SWTHRESH.LE.13.0) RTYPE=7
      RTYPE=7
c50    write(6,*)'calling radartaperead1'
c      write(6,*)'itapeopen,numrec = ',itapeopen,numrec
c      write(6,'(A80)')radarfile
      IF(ITAPEOPEN.EQ.0.AND.ISIGMET.EQ.5)THEN
c50    IF(ITAPEOPEN.EQ.0.AND.ISIGMET.EQ.5)THEN
c       write(6,*)'calling radardiscread,iheaderflag = ',iheaderflag
c       pause
c       write(6,*)'time is ',time
       LUNRNC=LUNR
       CALL RADARDISCREAD1(LUNRNC,2,IHEADERFLAG,RTYPE,IERR)
       LUNR=LUNRNC
c       write(6,*)'returned from radardiscread'
c       write(6,*)'time after rvp8 is ',time
c       write(6,*)'nbins,nbinsta = ',nbins,nbinsta
c       WRITE(6,*)'CALLED RADAR_RVP8_READ AND IERR = ',IERR
      ELSEIF(ITAPEOPEN.EQ.0)THEN
 6664   LUNRNC=LUNR
        call radar_rvp8_read(LUNRNC,2,0,RTYPE,IERR)
        IF(NDO.NE.0)RETURN
        LUNR=LUNRNC
c        WRITE(6,*)'IERR = ',IERR
C       CALL RADARFILEREAD(LUNR,2,0,RTYPE,IERR,ITAPEOPEN,RADARFILE,
C     + NUMREC)
c       WRITE(6,*)'IERR,NBINS = ',IERR,NBINS
       IF(NBINS.LT.1.OR.NBINS.GT.MAX_HRD_DIM)GO TO 6664
      ELSE
       LUNRNC=LUNR
       CALL RADARTAPEREAD(LUNRNC,2,0,RTYPE,IERR)
       LUNR=LUNRNC
c       write(6,*)'should not get here 2'
c       stop
       IF(IERR.NE.0)THEN
        write(6,*)'returned from radartaperead ierr = ',ierr
       ENDIF
      ENDIF
c      IF(NBINS.LT.MAX_HRD_DIM)THEN
c       DO I=NBINS+1,MAX_HRD_DIM
c        RADIITA(I)=0.
c       ENDDO
c      ENDIF
      IF (IERR .LT. 0.AND.ISIGMET.EQ.5) THEN
         IF(IERR.EQ.-4)THEN
          NIX=-200
         ELSE
          NIX= -100
         ENDIF
         RETURN
      ELSE
       NIX = 0
      ENDIF
      IF(ELEV.LT.0.)THEN
       PCOR=PCORS(1)
       DCOR=DCORS(1)
       RCOR=RCORS(1)
       AZMCOR=AZMCORS(1)
       ELCOR=ELCORS(1)
      ELSE
       PCOR=PCORS(2)
       DCOR=DCORS(2)
       RCOR=RCORS(2)
       AZMCOR=AZMCORS(2)
       ELCOR=ELCORS(2)
      ENDIF
C    clear nix variable
      NIX= 0
C    time in seconds  
      TIME=RADTIME
C    raw azimuth
      TRAKAZM=RADAZM
c    roll corrected azimuth but in heading rather than track
      RCAZM=RADAZM+RCOR+ROLL
C    raw elevation
      TRAKELEV=ELEV
C    raw drift
      DRIFTNEW=DRIFT
C    nyquist velocity
      XNIQ=XNIQTA
      track = AMOD(heading + driftnew + 360.0, 360.0)
C ANGLECOR corrects the aircraft pitch,drift,roll,azimuth,elevation and
C adds the roll to the azimuth.
c      write(6,*)'roll,rcor,radazm,rcazm = ',roll,rcor,radazm,rcazm
c      write(6,*)'driftnew,trakazm,trakelev = ',
c     1           driftnew,trakazm,trakelev
      TRAKAZMTEMP=TRAKAZM
      TRAKELEVTEMP=TRAKELEV
      PITCHTEMP=PITCH
      ROLLTEMP=ROLL
      PCORTEMP=PCOR
      DCORTEMP=DCOR
      RCORTEMP=RCOR
      AZMCORTEMP=AZMCOR
      ELCORTEMP=ELCOR
      DRIFTNEWTEMP=DRIFTNEW
      CALL ANGLECOR(PITCHTEMP,DRIFTNEWTEMP,ROLLTEMP,TRAKAZMTEMP,
     +              TRAKELEVTEMP,2,PCORTEMP,
     +              DCORTEMP,RCORTEMP,AZMCORTEMP,ELCORTEMP)
      PCOR=PCORTEMP
      TRAKAZM=TRAKAZMTEMP
      TRAKELEV=TRAKELEVTEMP
      PITCH=PITCHTEMP
      ROLL=ROLLTEMP
      DCOR=DCORTEMP
      RCOR=RCORTEMP
      AZMCOR=AZMCORTEMP
      ELCOR=ELCORTEMP
      DRIFTNEW=DRIFTNEWTEMP
c      write(6,*)'after roll,trakazm,track = ',roll,trakazm,track
C Convert aircraft angles to earth relative shperical coordinates
      IUNFOLDFLAG=0
      CALL RAYCOR1(BIN1,REF1)
      IUNFOLDFLAG=0
      CALL RAYCOR1(BIN,REF)
      IUNFOLDFLAG=0
      TRAKAZMTEMP=TRAKAZM
      TRAKELEVTEMP=TRAKELEV
      TRACKTEMP=TRACK
       CALL CONVERTANGLES(TRACKTEMP,TRAKAZMTEMP,TRAKELEVTEMP,
     1                    HORAZM,HORELEV)
      TRAKAZM=TRAKAZMTEMP
      TRAKELEV=TRAKELEVTEMP
      TRACK=TRACKTEMP
C       WRITE(6,*)'TRAKAZM,TRAKELEV = ',TRAKAZM,TRAKELEV
c      write(6,*)'after convertangles = ',trakazm,horazm
C    azimuth earth relative
      AZM=HORAZM
C    elevation earth relative
      EV=HORELEV
C get information from the ram files.
c      IF (RAMFL .EQ. 'Y')
c     *   CALL READRAMFILE(TIME,TIMERAM,RADLAT,RADLON,RADALT,
c     *                    RADWD,RADWS,UCOM,VCOM,RADVWS,RADVGS,IOS)
C get information from the radar tape or the standard tape
      GS=RADGS                       !ground speed
      VGS=RADVGS                     !vertical ground speed
      VWS=RADVWS                     !vertical wind speed
      RLAT=RADLAT                    !latitude(deg)
      RLON=RADLON                    !longitude(deg)
      RA=RADALT                      !radar altitude(meters) 
      WD=RADWD                       !wind direction
      WS=RADWS                       !wind speed
C RAYCOR corrects the velocities one ray at a time.  It returns the airplane
C track, the first guess wind, the stabilized, vt corrected and unfolded
c velocities as well as the dbz values from the tail radar.
c      IUNFOLDFLAG=0
c      CALL RAYCOR1(BIN1,REF1)
c      IUNFOLDFLAG=0
c      CALL RAYCOR1(BIN,REF)
c      IUNFOLDFLAG=0
      RETURN
      END 
C ********************
      BLOCK DATA
      INCLUDE "hrd_radar_settings.f"
      COMMON /AREA1/ INM,IFLT,STIME,ETIME,WD,WS,NIX,NGATE1,LP,LUNR,
     +               IVT,RAMFL
      COMMON /PARAMS/ trakazm,trakelev,driftnew,
     +                rot,track,htbb,dbb,thresh,swthresh,dbzrs,ibst(2),
     +                inob(2),ileg,xniq,irsw,maxnbins,v0,
     +                pcor,dcor,rcor,azmcor,elcor,dbzcor,dbzslope,
     +                iunfoldflag,iattenflag,
     +                badstabflag,surfelimflag,echoflag,atmflag
      LOGICAL badstabflag, surfelimflag, echoflag, atmflag
      CHARACTER IFLT*8, INM*12
      CHARACTER *1 RAMFL, IVT
      DATA NIX/0/, NGATE1/5/, IVT/'N'/, RAMFL/'N'/ 
      DATA rot/0.0/, htbb/-99./, dbb/2.0/, thresh/-99.0/, swthresh/99./,
     1     dbzrs/-99./, ibst/2*0/, inob/2*0/, ileg/1/, xniq/12.8/,
     2     irsw/0/, maxnbins/MAX_HRD_DIM/, 
     3     pcor,dcor,rcor,azmcor,elcor,dbzcor/6*0.0/, dbzslope/1.0/,
     4     iunfoldflag/0/, iattenflag/0/,
     5     badstabflag/.true./, surfelimflag/.false./,
     6     echoflag/.false./, atmflag/.true./
      END 
      SUBROUTINE VRLOCATER(TIMES,OLAT,OLON,
     + RLAT,RLON,ALT,ELEV,AZIM,RANGE,XR,YR,ZR,
     + ISCANDIM,SMOTIONU,SMOTIONV,CENTIME,BIN,REF)
      include "hrd_radar_settings.f"
      REAL RANGE(ISCANDIM),XR(ISCANDIM),YR(ISCANDIM),ZR(ISCANDIM)
      REAL SUM(MAX_HRD_DIM),WSUM(MAX_HRD_DIM),WEIGHT(200)
      REAL VR(MAX_HRD_DIM)
      REAL BIN(ISCANDIM),REF(ISCANDIM)
c      WRITE(6,*)'OLAT,OLON,RLAT,RLON,ALT,ELEV,AZIM = ',
c     + OLAT,OLON,RLAT,RLON,ALT,ELEV,AZIM
c      WRITE(6,*)'RANGE = ',RANGE
      RALT=ALT/1000.
      PI=ASIN(1.0)*2.
      DTR=PI/180.
      REARTH=6366.
C      SMOTIONU=0.
C      SMOTIONV=0.
      TDIFF=TIMES-CENTIME
c      WRITE(6,*)'TDIFF = ',TDIFF
c      write(6,*)'olat,rlat,times,centime,tdiff,smotionu,smotionv = ',
c     + olat,rlat,times,centime,tdiff,smotionu,smotionv
C      TDIFF=0.
C      JBINS=IBINS*3
c      DO I=1,ISCANDIM
c       SUM(I)=0
c       WSUM(I)=0
c       ISTART=I-JBINS
c       IEND=I+JBINS
c       IF(ISTART.LT.1)ISTART=1
c       IF(IEND.GT.ISCANDIM)IEND=ISCANDIM
c       DO J=ISTART,IEND
c        IF(VR(J).GT.-900.)THEN
c         IDIFF=J-I
c         IDIFF=IABS(IDIFF)
c         WSUM(I)=WSUM(I)+WEIGHT(IDIFF)
c         SUM(I)=SUM(I)+WEIGHT(IDIFF)*VR(J)
c        ENDIF
c       ENDDO
c      ENDDO
c      DO I=1,ISCANDIM
c       IF(WSUM(I).LE.0..AND.VR(I).LE.-900.)THEN
c        VR(I)=-999.9
c       ELSE
c        VR(I)=SUM(I)/WSUM(I)
c       ENDIF
c      ENDDO
      XSHIFT=TDIFF*SMOTIONU/1000.
      YSHIFT=TDIFF*SMOTIONV/1000.     
c      write(6,*)'xshift,yshift = ',xshift,yshift
      RAZIM=AZIM*DTR
      RELEV=ELEV*DTR
      DO I=1,ISCANDIM
c       IF(BIN(I).GT.-800..OR.REF(I).GT.-31.9)THEN
c xradar=horizontal distance from aircraft
c yradar=vertical distance from center of earth
       IF(RANGE(I).LT.200.)THEN
        XRADAR=RANGE(I)*COS(RELEV)
        YRADAR=REARTH+RALT+RANGE(I)*SIN(RELEV)
c radnew=distance of datum from center of earth
        RADNEW=SQRT(XRADAR*XRADAR+YRADAR*YRADAR)
c delangle=angle between vertical at aircraft and vertical at datum
        DELANGLE=ATAN(XRADAR/YRADAR)
c distance along great circle from radar to datum
        DISTANCE=.5*(RADNEW+REARTH+RALT)*DELANGLE
c height=altitude of datum
        HEIGHT=RADNEW-REARTH
c distance2=xradar
        DISTANCE2=RANGE(I)*COS(RELEV)
c height2=altitude of datum not accounting for earth's curvature
        HEIGHT2=RALT+RANGE(I)*SIN(RELEV)
c delx=distance (aircraft/datum) along great circle due to east west
        DELY=DISTANCE*SIN(RAZIM)
c dely=distance(aircraft/datum)along great circle due to north-south
         DELX=DISTANCE*COS(RAZIM)
c dx=east west distance from origin to aircraft
        XLAT=.5*(RLAT+OLAT)*DTR
        DX=(RLON-OLON)*DTR*REARTH*COS(XLAT)
c dy =north south distance from origin to aircraft
        DY=(RLAT-OLAT)*DTR*REARTH
c xshift=east-west distance from lower left corner to origin
c yshift=north-south distance from lower left corner to origin
c XR=distance of datum from lower left corner
c YR=distance of datum from lower left corner
        XR(I)=DELX+DX-XSHIFT
c yshift=distance from lower left corner to origin
        YR(I)=DELY+DY-YSHIFT
        ZR(I)=HEIGHT
       ELSE
        XR(I)=-1000.
        YR(I)=-1000.
        ZR(I)=-1000.
       ENDIF
c       IF(I.EQ.301)THEN
c        WRITE(6,*)'I,RANGE,DISTANCE,HEIGHT,DELX,DELY,DX,DY,XSHIFT,',
c     1  'YSHIFT = ',
c     1  I,RANGE(I),DISTANCE,HEIGHT,DELX,DELY,DX,DY,XSHIFT,YSHIFT
c        WRITE(6,*)'I,XR,YR,ZR = ',I,XR(I),YR(I),ZR(I)
c       ENDIF
c      ELSE
c       XR(I)=-888.8
c       YR(I)=-888.8
c       ZR(I)=-888.8
c       ENDIF
      ENDDO
c      WRITE(6,*)'XR = ',XR
c      WRITE(6,*)'YR = ',YR
c      WRITE(6,*)'ZR = ',ZR
      CONTINUE
      RETURN
      END
	subroutine find_ground(rdtai,deg2rad, beam_wid, 
     +		rs_th, rs_m, dBz_max, ibeg, Ng2, ibst,bin,isecondtrip,
     +          rmaxtata,rasend)
C Find the surface, as in Testud's memo.
        include "hrd_radar_common_blocks.f"
	real lambda
        real rdtai(MAX_HRD_DIM),bin(max_hrd_dim)
C
        ra=rasend
c        write(6,*)'ra = ',ra
        radres=rdtai(101)-rdtai(100)
	theta = elev * deg2rad ! tilt relative to plane perp to radar axis
	beta = pitch * deg2rad
C In Testud's form, 0 is down, -90 port, 90 starboard:
c	phi = (180 - (azm + roll) ) * deg2rad 
        phi = (azm + roll -180) * deg2rad
	epsilon = beam_wid * deg2rad
C Now get elevation of beam rel to horizontal plane through radar
	sn_lambda = sin(theta) * sin(beta) - 
     *			cos(theta) * cos(beta) * cos(phi)
	lambda = asin(sn_lambda)
C Find theoretical range of surface. - sign because lambda neg
	rs_th = -ra / sn_lambda ! ra in m, radiita in km
C Find # of gates intersecting surface at theoretical range
C This would be formula if dR was constant:
C	Ng = rs_th * epsilon / (dR * tan(lambda) )
C But we may have varying beamwidths, so
Cout	slant_depth = -rs_th * epsilon / tan(lambda) ! slight approximation
Cout	rs_th_in = ( rs_th - slant_depth * 0.5 ) * 0.001
Cout	rs_th_out = ( rs_th + slant_depth * 0.5 ) * 0.001
C mod dec 8 92:
	rs_th_in = -ra / sin(lambda - epsilon * 0.75) * 0.001
	rs_th_out = -ra / sin(lambda + epsilon * 0.75) * 0.001
	rs_km = rs_th * 0.001
c        write(6,*)'rs_th_out,rmaxtata,theta = ',
c     +    rs_th_out,rmaxtata,theta
        if((rs_km.gt.rmaxtata.or.rs_th_out.le.0.)
     + .and.isecondtrip.eq.1)then
           ibeg=-2
           return
        elseif(rs_th_in.gt.rmaxtata)then
           ibeg=0
c           write(6,*)'returning with ibeg = 0'
           return
        endif
c           do i=1,nbins
c              if(radiita(i).gt.0.0)then
c                 if(radiita(i).lt.rs_second)ibeg=i
c              endif
c           enddo
c           write(6,*)'i got here and'
c           write(6,*)'elev,azm,rs_th_out,rs_th_in,rs_second,ibeg = ',
c     +                elev,azm,rs_th_out,rs_th_in,rs_second,ibeg
c           return
c        endif
c        write(6,*)'rs_th_in,rs_km,rs_th_out = ',
c     +             rs_th_in,rs_km,rs_th_out
c	in = nbins-100
c        iout = nbins
        Nr = nbins-50
        in=-1
        iout=-1
	do i = 1, nbins
	    if( radiita(i) .gt. 0.0 )then
		if(radiita(i) .lt. rs_th_in) in = i
		if(radiita(i) .le. rs_th_out) iout = i
		if(radiita(i) .le. rs_km) Nr = i
	    end if
	end do
	if(in .eq. -1.or.iout.eq.-1)then
c		WRITE(6,*)' find_ground failure!'
c		WRITE(6,*)' ra:',ra
c		WRITE(6,*)'azm, phi: ', azm, phi
c		WRITE(6,*)'pitch, drift, roll: ',pitch, drift, roll
c		WRITE(6,*)'el, sin(lambda), lambda:',elev, 
c     +			sn_lambda, lambda
c		WRITE(6,*)'rs_th_in, rs_th_out, rs_km:'
c		WRITE(6,*)rs_th_in, rs_th_out, rs_km
c		WRITE(6,*)' find_gs in, iout, Nr: ',in, iout, Nr
c		pause ' pausing for this mystery '
		ibeg = 0
		return
	end if
	Ng = iout - in + 1
        Ng2 = Ng
	Ng2 =  0.5 * Ng
	if (Ng2 .eq. 0) Ng2 = 1
c        write(6,*)'in,iout,ng,ng2,nr = ',in,iout,ng,ng2,nr
C changed radius of check to 30 bins = 2.25 km, because of huge
C range delays in Andrew 8 dec 92
C Then search the gates within +- 30 of gate at theoretical
C range to find the swath Ng/2 wide with greatest Total Ze.
C Return bounding bins.
	dBz_max = -1.0
	ibeg = -1
        if(ng2.gt.30)then
         n30=ng2
        else
         n30=30
        endif
c        n30=ng2
c	ist = max(in, Nr - n30)
        ist = Nr - Ng2
	ien = min(nbins-Ng2, Nr + n30 -Ng2)
c        if(ist.gt.20)ist=ist-20
        if(ist.lt.1)ist=1
c        WRITE(6,*)'find_gd in,iout,Ng,Ng2,ibst = ',in,iout,Ng,Ng2,ibst
c	WRITE(6,*)'find_gd Nr, nbins,ist, ien: ',Nr,nbins,ist, ien
	do i = ist, ien
	   dBzsum = 0.0
           velsum = 0.0
           ndbzsum = 0
           nvelsum =0
	   do j = i, i + Ng2
c               write(6,*)'j,dbzbuffer(j) = ',j,dbzbuffer(j)
               if(j.gt.ibst.and.dbzbuffer(j).gt.-32.)then
		dBzsum = dBzsum + dbzbuffer(j)
                if(bin(j).gt.-800.)then
                 nvelsum=nvelsum+1
                 velsum=velsum+bin(j)
                endif
c                write(6,*)'bin ',bin(j)
                ndbzsum=ndbzsum+1
c                write(6,*)'j,dbzbuffer,ndbzsum,dBzsum = ',
c     1                     j,dbzbuffer(j),ndbzsum,dBzsum
               endif
c                dbzsum = dbzbuffer(i+Ng2)-dbzbuffer(i)
	   end do
           if(ndbzsum.gt.0)then
            dbzsum=dbzsum/ndbzsum
           else
            dbzsum=-32.
           endif
           if(nvelsum.gt.0)then
            velsum=velsum/nvelsum
           else
            velsum=-888.88
           endif
c           write(6,*)'i,dBzsum,dBz_max,dbzbuffer(i) = ',
c     1                i,dBzsum,dBz_max,dbzbuffer(i)
	   if( dBzsum .gt. dBz_max.and.dbzbuffer(i).lt.80)then
		dBz_max = dBzsum
		ibeg = i
c                write(6,*)'ibeg,dBz_max,dBzsum = ',
c     1                     ibeg,dBz_max,dBzsum
                if(nvelsum.gt.0)then
                 vel_max = velsum
                else
                 vel_max = -888.88
                endif
	   end if
	end do
c        write(6,*)'final computed ibeg = ',ibeg
        if(dbz_max.gt.0.)then
         extra=.1*40./dbz_max/abs(sn_lambda)
        else
         extra=0.
        endif
        ibeg=ibeg-int(extra/radres)
        if(ibeg.lt.1)ibeg=1
	iradius = ibeg + Ng2 * 0.5
	if( iradius .le.0) iradius = 1
        if( iradius .gt.nbins) iradius = nbins
	rs_m = radiita( iradius ) * 1000.0
        if(ibeg.lt.1)ibeg=1
	return
	end
      SUBROUTINE TESTTIMING
      REAL X(10000000)
      INTEGER*8 INUMBER,JNUMBER,J,IJ
c      WRITE(6,*)'ENTER NUMBER OF ITERATIONS FOR TESTING'
c      READ(5,*)INUMBER
      INUMBER=10000000
      JNUMBER=0
      DO I=1,5
C       WRITE(6,*)'I = ',I
       DO J=1,INUMBER
        IF(J.GE.2)THEN
         X(J)=FLOAT(J)/FLOAT(J-1)
        ENDIF
       ENDDO
C       WRITE(6,*)'JNUMBER = ',JNUMBER
      ENDDO
      RETURN
      END
      SUBROUTINE AZISORT(NUM_RAYS,AZI,X)
      REAL AZI(2,NUM_RAYS),X(NUM_RAYS),XSORT(800)
      AZITEST=361.
      JSTART=1
      IF(NUM_RAYS.GT.2)THEN
       AZICHECK=AZI(1,3)-AZI(1,2)
       IF(AZICHECK.LT.-180.)AZICHECK=AZICHECK+360.
       IF(AZICHECK.GT.180.)AZICHECK=AZICHECK-360.
      ELSE
       RETURN
      ENDIF
      DO J=1,NUM_RAYS
       IF(J.EQ.NUM_RAYS)THEN
        JLOW=NUM_RAYS
        JHIGH=1
       ELSE
        JLOW=J
        JHIGH=J+1
       ENDIF
       AZICHECK2=AZI(1,JHIGH)-AZI(1,JLOW)
       IF(ABS(AZICHECK2).GT.180.)THEN
        JSTART=J
        AZITEST=AZI(1,J)
       ENDIF
      ENDDO
      IF(JSTART.EQ.NUM_RAYS)THEN
       JSTART=1
      ELSE
       JSTART=JSTART+1
      ENDIF
      JEND=JSTART+NUM_RAYS-1
      DO JJ=JSTART,JEND
       J=JJ-JSTART+1
       IF(JJ.GT.NUM_RAYS)THEN
        I=JJ-NUM_RAYS
       ELSE
        I=JJ
       ENDIF
c       WRITE(6,*)'JJ,J,I,AZI = ',JJ,J,I,AZI(1,I)
       XSORT(J)=X(I)
      ENDDO
      DO J=1,NUM_RAYS
       I=NUM_RAYS-J+1
       IF(AZICHECK.LT.0.)THEN
        X(J)=XSORT(I)
       ELSE
        X(J)=XSORT(J)
       ENDIF
      ENDDO
      RETURN
      END
      SUBROUTINE TIMESORT(NUM_RAYS,TMSWEEP,X,IPLANE)
      REAL TMSWEEP(800),X(NUM_RAYS),XSORT(800)
c      WRITE(6,*)'ENTERED TIMESORT'
      IF(IPLANE.EQ.1)THEN
       TIMETEST=1000000.
      ELSE
       TIMETEST=0
      ENDIF
      JSTART=1
      IF(IPLANE.EQ.1)THEN
       DO J=1,NUM_RAYS
        IF(TMSWEEP(J).LT.TIMETEST)THEN
         JSTART=J
         TIMETEST=TMSWEEP(J)
        ENDIF
       ENDDO
      ELSE
       DO J=1,NUM_RAYS+1
        JJ=J
        IF(JJ.GT.NUM_RAYS)JJ=J-NUM_RAYS
        IF(TMSWEEP(JJ).GT.TIMETEST)THEN
         JSTART=JJ
         TIMETEST=TMSWEEP(JJ)
        ENDIF
       ENDDO
      ENDIF
      IF(JSTART.EQ.NUM_RAYS.AND.IPLANE.EQ.2)THEN
       JSTART=1
C      ELSEIF(IPLANE.EQ.2.AND.IPLANE.EQ.NUM_RAYS)THEN
C       JSTART=NUM_RAYS
      ENDIF
      JEND=JSTART+NUM_RAYS-1
      DO JJ=JSTART,JEND
       J=JJ-JSTART+1
       IF(JJ.GT.NUM_RAYS)THEN
        I=JJ-NUM_RAYS
       ELSE
        I=JJ
       ENDIF
c       WRITE(6,*)'JJ,J,I,AZI = ',JJ,J,I,AZI(1,I)
       XSORT(J)=X(I)
      ENDDO
      IF(IPLANE.LT.2)THEN
       DO J=1,NUM_RAYS
        X(J)=XSORT(J)
       ENDDO
      ELSE
       DO J=1,NUM_RAYS
        I=NUM_RAYS-J+1
        X(J)=XSORT(I)
       ENDDO
      ENDIF
      RETURN
      END
      SUBROUTINE TIMESORTOLD(NUM_RAYS,TMSWEEP,X)
      REAL TMSWEEP(800),X(NUM_RAYS),XSORT(800)
c      WRITE(6,*)'ENTERED TIMESORT'
      TIMETEST=1000000.
      JSTART=1
      DO J=1,NUM_RAYS
       IF(TMSWEEP(J).LT.TIMETEST)THEN
        JSTART=J
        TIMETEST=TMSWEEP(J)
       ENDIF
      ENDDO
      IF(JSTART.EQ.NUM_RAYS)THEN
       JSTART=1
      ELSE
       JSTART=JSTART+1
      ENDIF
      JEND=JSTART+NUM_RAYS-1
      DO JJ=JSTART,JEND
       J=JJ-JSTART+1
       IF(JJ.GT.NUM_RAYS)THEN
        I=JJ-NUM_RAYS
       ELSE
        I=JJ
       ENDIF
c       WRITE(6,*)'JJ,J,I,AZI = ',JJ,J,I,AZI(1,I)
       XSORT(J)=X(I)
      ENDDO
      DO J=1,NUM_RAYS
       I=NUM_RAYS-J+1
       X(J)=XSORT(I)
      ENDDO
      RETURN
      END
      SUBROUTINE AZISORT2(NUMI,NUM_RAYS,AZI,X)
      include "hrd_radar_settings.f"
      REAL AZI(2,NUM_RAYS),X(NUMI,NUM_RAYS),XSORT(MAX_HRD_DIM,800)
      JSTART=1
      AZITEST=361.
      IF(NUM_RAYS.GT.2)THEN
       AZICHECK=AZI(1,3)-AZI(1,2)
       IF(AZICHECK.LT.-180.)AZICHECK=AZICHECK+360.
       IF(AZICHECK.GT.180.)AZICHECK=AZICHECK-360.
      ELSE
       RETURN
      ENDIF
      DO J=1,NUM_RAYS
       IF(J.EQ.NUM_RAYS)THEN
        JLOW=NUM_RAYS
        JHIGH=1
       ELSE
        JLOW=J
        JHIGH=J+1
       ENDIF
       AZICHECK2=AZI(1,JHIGH)-AZI(1,JLOW)
       IF(ABS(AZICHECK2).GT.180.)THEN
        JSTART=J
        AZITEST=AZI(1,J)
       ENDIF
      ENDDO
      IF(JSTART.EQ.NUM_RAYS)THEN
       JSTART=1
      ELSE
       JSTART=JSTART+1
      ENDIF
      JEND=JSTART+NUM_RAYS-1
      DO JJ=JSTART,JEND
       J=JJ-JSTART+1
       IF(JJ.GT.NUM_RAYS)THEN
        K=JJ-NUM_RAYS
       ELSE
        K=JJ
       ENDIF
c       WRITE(6,*)'JJ,I,J,K,AZI = ',JJ,I,J,K,AZI(1,K)
       DO I=1,NUMI
        XSORT(I,J)=X(I,K)
       ENDDO
      ENDDO
      DO J=1,NUM_RAYS
       K=NUM_RAYS-J+1
       DO I=1,NUMI
        IF(AZICHECK.LT.0.)THEN
         X(I,J)=XSORT(I,K)
        ELSE
         X(I,J)=XSORT(I,J)
        ENDIF
       ENDDO       
      ENDDO
      RETURN
      END
      SUBROUTINE TIMESORT2(NUMI,NUM_RAYS,TMSWEEP,X,IPLANE)
      include "hrd_radar_settings.f"
      REAL TMSWEEP(NUM_RAYS),X(NUMI,NUM_RAYS),XSORT(MAX_HRD_DIM,800)
      IF(IPLANE.EQ.1)THEN
       TIMETEST=1000000.
      ELSE
       TIMETEST=0
      ENDIF
      JSTART=1
      IF(IPLANE.EQ.1)THEN
       DO J=1,NUM_RAYS
        IF(TMSWEEP(J).LT.TIMETEST)THEN
         JSTART=J
         TIMETEST=TMSWEEP(J)
        ENDIF
       ENDDO
      ELSE
       DO J=1,NUM_RAYS+1
        JJ=J
        IF(JJ.GT.NUM_RAYS)JJ=J-NUM_RAYS
        IF(TMSWEEP(JJ).GT.TIMETEST)THEN
         JSTART=JJ
         TIMETEST=TMSWEEP(JJ)
        ENDIF
       ENDDO
      ENDIF
      IF(JSTART.EQ.NUM_RAYS.AND.IPLANE.EQ.2)THEN
       JSTART=1
C      ELSEIF(IPLANE.EQ.2)THEN
C       JSTART=JSTART+1
      ENDIF
c     IF(JSTART.EQ.NUM_RAYS)THEN
c       JSTART=1
c      ELSE
c       JSTART=JSTART+1
c      ENDIF
      JEND=JSTART+NUM_RAYS-1
      DO JJ=JSTART,JEND
       J=JJ-JSTART+1
       IF(JJ.GT.NUM_RAYS)THEN
        K=JJ-NUM_RAYS
       ELSE
        K=JJ
       ENDIF
c       WRITE(6,*)'JJ,I,J,K,AZI = ',JJ,I,J,K,AZI(1,K)
       DO I=1,NUMI
        XSORT(I,J)=X(I,K)
       ENDDO
      ENDDO
      IF(IPLANE.LT.2)THEN
       DO J=1,NUM_RAYS
        DO I=1,NUMI
         X(I,J)=XSORT(I,J)
        ENDDO       
       ENDDO
      ELSE
       DO J=1,NUM_RAYS
        K=NUM_RAYS-J+1
        DO I=1,NUMI
         X(I,J)=XSORT(I,K)
        ENDDO       
       ENDDO
      ENDIF
      RETURN
      END
      SUBROUTINE TIMESORT2OLD(NUMI,NUM_RAYS,TMSWEEP,X)
      include "hrd_radar_settings.f"
      REAL TMSWEEP(NUM_RAYS),X(NUMI,NUM_RAYS),XSORT(MAX_HRD_DIM,800)
      TIMETEST=1000000.
      JSTART=1
      DO J=1,NUM_RAYS
       IF(TMSWEEP(J).LT.TIMETEST)THEN
        JSTART=J
        TIMETEST=TMSWEEP(J)
       ENDIF
      ENDDO
      IF(JSTART.EQ.NUM_RAYS)THEN
       JSTART=1
      ELSE
       JSTART=JSTART+1
      ENDIF
      JEND=JSTART+NUM_RAYS-1
      DO JJ=JSTART,JEND
       J=JJ-JSTART+1
       IF(JJ.GT.NUM_RAYS)THEN
        K=JJ-NUM_RAYS
       ELSE
        K=JJ
       ENDIF
c       WRITE(6,*)'JJ,I,J,K,AZI = ',JJ,I,J,K,AZI(1,K)
       DO I=1,NUMI
        XSORT(I,J)=X(I,K)
       ENDDO
      ENDDO
      DO J=1,NUM_RAYS
       K=NUM_RAYS-J+1
       DO I=1,NUMI
        X(I,J)=XSORT(I,K)
       ENDDO       
      ENDDO
      RETURN
      END
      SUBROUTINE IAZISORT(NUM_RAYS,AZI,X)
      REAL AZI(2,NUM_RAYS)
      INTEGER X(NUM_RAYS),XSORT(800)
      JSTART=1
      AZITEST=361.
      IF(NUM_RAYS.GT.2)THEN
       AZICHECK=AZI(1,3)-AZI(1,2)
       IF(AZICHECK.LT.-180.)AZICHECK=AZICHECK+360.
       IF(AZICHECK.GT.180.)AZICHECK=AZICHECK-360.
      ELSE
       RETURN
      ENDIF
      DO J=1,NUM_RAYS
       IF(J.EQ.NUM_RAYS)THEN
        JLOW=NUM_RAYS
        JHIGH=1
       ELSE
        JLOW=J
        JHIGH=J+1
       ENDIF
       AZICHECK2=AZI(1,JHIGH)-AZI(1,JLOW)
       IF(ABS(AZICHECK2).GT.180.)THEN
        JSTART=J
        AZITEST=AZI(1,J)
       ENDIF
      ENDDO
      IF(JSTART.EQ.NUM_RAYS)THEN
       JSTART=1
      ELSE
       JSTART=JSTART+1
      ENDIF
      JEND=JSTART+NUM_RAYS-1
      DO JJ=JSTART,JEND
       J=JJ-JSTART+1
       IF(JJ.GT.NUM_RAYS)THEN
        I=JJ-NUM_RAYS
       ELSE
        I=JJ
       ENDIF
c       WRITE(6,*)'JJ,J,I,AZI = ',JJ,J,I,AZI(1,I)
       XSORT(J)=X(I)
      ENDDO
      DO J=1,NUM_RAYS
       I=NUM_RAYS-J+1
       IF(AZICHECK.LT.0.)THEN
        X(J)=XSORT(I)
       ELSE
        X(J)=XSORT(J)
       ENDIF
      ENDDO
      RETURN
      END
      SUBROUTINE ITIMESORT(NUM_RAYS,TMSWEEP,X,IPLANE)
      REAL TMSWEEP(NUM_RAYS)
      INTEGER X(NUM_RAYS),XSORT(800)
      JSTART=1
      IF(IPLANE.EQ.1)THEN
       TIMETEST=1000000.
      ELSE
       TIMETEST=0
      ENDIF
      IF(IPLANE.EQ.1)THEN
       DO J=1,NUM_RAYS
        IF(TMSWEEP(J).LT.TIMETEST)THEN
         JSTART=J
         TIMETEST=TMSWEEP(J)
        ENDIF
       ENDDO
      ELSE
       DO J=1,NUM_RAYS+1
        JJ=J
        IF(JJ.GT.NUM_RAYS)JJ=J-NUM_RAYS
        IF(TMSWEEP(JJ).GT.TIMETEST)THEN
         JSTART=JJ
         TIMETEST=TMSWEEP(JJ)
        ENDIF
       ENDDO
      ENDIF
      IF(JSTART.EQ.NUM_RAYS.AND.IPLANE.EQ.2)THEN
       JSTART=1
C      ELSEIF(IPLANE.EQ.2)THEN
C       JSTART=JSTART+1
      ENDIF
c      IF(JSTART.EQ.NUM_RAYS)THEN
c       JSTART=1
c      ELSE
c       JSTART=JSTART+1
c      ENDIF
      JEND=JSTART+NUM_RAYS-1
      DO JJ=JSTART,JEND
       J=JJ-JSTART+1
       IF(JJ.GT.NUM_RAYS)THEN
        I=JJ-NUM_RAYS
       ELSE
        I=JJ
       ENDIF
c       WRITE(6,*)'JJ,J,I,AZI = ',JJ,J,I,AZI(1,I)
       XSORT(J)=X(I)
      ENDDO
      IF(IPLANE.LT.2)THEN
       DO J=1,NUM_RAYS
        X(J)=XSORT(J)
       ENDDO
      ELSE
       DO J=1,NUM_RAYS
        I=NUM_RAYS-J+1
        X(J)=XSORT(I)
       ENDDO
      ENDIF
      RETURN
      END
      SUBROUTINE ITIMESORTOLD(NUM_RAYS,TMSWEEP,X)
      REAL TMSWEEP(NUM_RAYS)
      INTEGER X(NUM_RAYS),XSORT(800)
      TIMETEST=1000000.
      JSTART=1
      DO J=1,NUM_RAYS
       IF(TMSWEEP(J).LT.TIMETEST)THEN
        JSTART=J
        TIMETEST=TMSWEEP(J)
       ENDIF
      ENDDO
      IF(JSTART.EQ.NUM_RAYS)THEN
       JSTART=1
      ELSE
       JSTART=JSTART+1
      ENDIF
      JEND=JSTART+NUM_RAYS-1
      DO JJ=JSTART,JEND
       J=JJ-JSTART+1
       IF(JJ.GT.NUM_RAYS)THEN
        I=JJ-NUM_RAYS
       ELSE
        I=JJ
       ENDIF
c       WRITE(6,*)'JJ,J,I,AZI = ',JJ,J,I,AZI(1,I)
       XSORT(J)=X(I)
      ENDDO
      DO J=1,NUM_RAYS
       I=NUM_RAYS-J+1
       X(J)=XSORT(I)
      ENDDO
      RETURN
      END
      SUBROUTINE IAZISORT2(NUMI,NUM_RAYS,AZI,X)
      include "hrd_radar_settings.f"
      REAL AZI(2,NUM_RAYS)
      INTEGER X(NUMI,NUM_RAYS),XSORT(MAX_HRD_DIM,800)
      AZITEST=361.
      JSTART=1
      IF(NUM_RAYS.GT.2)THEN
       AZICHECK=AZI(1,3)-AZI(1,2)
       IF(AZICHECK.LT.-180.)AZICHECK=AZICHECK+360.
       IF(AZICHECK.GT.180.)AZICHECK=AZICHECK-360.
      ELSE
       RETURN
      ENDIF
      DO J=1,NUM_RAYS
       IF(J.EQ.NUM_RAYS)THEN
        JLOW=NUM_RAYS
        JHIGH=1
       ELSE
        JLOW=J
        JHIGH=J+1
       ENDIF
       AZICHECK2=AZI(1,JHIGH)-AZI(1,JLOW)
       IF(ABS(AZICHECK2).GT.180.)THEN
        JSTART=J
        AZITEST=AZI(1,J)
       ENDIF
      ENDDO
      IF(JSTART.EQ.NUM_RAYS)THEN
       JSTART=1
      ELSE
       JSTART=JSTART+1
      ENDIF
      JEND=JSTART+NUM_RAYS-1
      DO JJ=JSTART,JEND
       J=JJ-JSTART+1
       IF(JJ.GT.NUM_RAYS)THEN
        K=JJ-NUM_RAYS
       ELSE
        K=JJ
       ENDIF
c       WRITE(6,*)'JJ,I,J,K,AZI = ',JJ,I,J,K,AZI(1,K)
       DO I=1,NUMI
        XSORT(I,J)=X(I,K)
       ENDDO
      ENDDO
      DO J=1,NUM_RAYS
       K=NUM_RAYS-J+1
       DO I=1,NUMI
        IF(AZICHECK.LT.0.)THEN
         X(I,J)=XSORT(I,K)
        ELSE
         X(I,J)=XSORT(I,J)
        ENDIF
       ENDDO       
      ENDDO
      RETURN
      END
      SUBROUTINE ITIMESORT2(NUMI,NUM_RAYS,TMSWEEP,X,IPLANE)
      include "hrd_radar_settings.f"
      REAL TMSWEEP(NUM_RAYS)
      INTEGER X(NUMI,NUM_RAYS),XSORT(MAX_HRD_DIM,800)
      JSTART=1
      IF(IPLANE.EQ.1)THEN
       TIMETEST=1000000.
      ELSE
       TIMETEST=0
      ENDIF
      JSTART=1
      IF(IPLANE.EQ.1)THEN
       DO J=1,NUM_RAYS
        IF(TMSWEEP(J).LT.TIMETEST)THEN
         JSTART=J
         TIMETEST=TMSWEEP(J)
        ENDIF
       ENDDO
      ELSE
       DO J=1,NUM_RAYS+1
        JJ=J
        IF(JJ.GT.NUM_RAYS)JJ=J-NUM_RAYS
        IF(TMSWEEP(JJ).GT.TIMETEST)THEN
         JSTART=JJ
         TIMETEST=TMSWEEP(JJ)
        ENDIF
       ENDDO
      ENDIF
      IF(JSTART.EQ.NUM_RAYS.AND.IPLANE.EQ.2)THEN
       JSTART=1
C      ELSEIF(IPLANE.EQ.2)THEN
C       JSTART=JSTART+1
      ENDIF
c      IF(JSTART.EQ.NUM_RAYS)THEN
c       JSTART=1
c      ELSE
c       JSTART=JSTART+1
c      ENDIF
      JEND=JSTART+NUM_RAYS-1
      DO JJ=JSTART,JEND
       J=JJ-JSTART+1
       IF(JJ.GT.NUM_RAYS)THEN
        K=JJ-NUM_RAYS
       ELSE
        K=JJ
       ENDIF
c       WRITE(6,*)'JJ,I,J,K,AZI = ',JJ,I,J,K,AZI(1,K)
       DO I=1,NUMI
        XSORT(I,J)=X(I,K)
       ENDDO
      ENDDO
      IF(IPLANE.LT.2)THEN
       DO J=1,NUM_RAYS
        DO I=1,NUMI
         X(I,J)=XSORT(I,J)
        ENDDO       
       ENDDO
      ELSE
       DO J=1,NUM_RAYS
        K=NUM_RAYS-J+1
        DO I=1,NUMI
         X(I,J)=XSORT(I,K)
        ENDDO       
       ENDDO
      ENDIF
      RETURN
      END
      SUBROUTINE ITIMESORT2OLD(NUMI,NUM_RAYS,TMSWEEP,X)
      include "hrd_radar_settings.f"
      REAL TMSWEEP(NUM_RAYS)
      INTEGER X(NUMI,NUM_RAYS),XSORT(MAX_HRD_DIM,800)
      TIMETEST=1000000.
      JSTART=1
      DO J=1,NUM_RAYS
       IF(TMSWEEP(J).LT.TIMETEST)THEN
        JSTART=J
        TIMETEST=TMSWEEP(J)
       ENDIF
      ENDDO
      IF(JSTART.EQ.NUM_RAYS)THEN
       JSTART=1
      ELSE
       JSTART=JSTART+1
      ENDIF
      JEND=JSTART+NUM_RAYS-1
      DO JJ=JSTART,JEND
       J=JJ-JSTART+1
       IF(JJ.GT.NUM_RAYS)THEN
        K=JJ-NUM_RAYS
       ELSE
        K=JJ
       ENDIF
c       WRITE(6,*)'JJ,I,J,K,AZI = ',JJ,I,J,K,AZI(1,K)
       DO I=1,NUMI
        XSORT(I,J)=X(I,K)
       ENDDO
      ENDDO
      DO J=1,NUM_RAYS
       K=NUM_RAYS-J+1
       DO I=1,NUMI
        X(I,J)=XSORT(I,K)
       ENDDO       
      ENDDO
      RETURN
      END
      SUBROUTINE SECS1970(IYEAR,IMONTH,IDAY,SECS,DSECS)
      DOUBLE PRECISION SECS,DSECS
c      WRITE(6,*)'IYEAR,IMONTH,IDAY = ',IYEAR,IMONTH,IDAY
      IJULIAN=JULIAN_DATE(IYEAR,IMONTH,IDAY)
C      WRITE(6,*)'JULIAN DAY = ',IJULIAN
      IY=1970
      IM=1
      ID=1
      IJDAY1=JULIAN_DATE(IY,IM,ID)
      IJDAY2=JULIAN_DATE(IYEAR,IMONTH,IDAY)
      IJDAY3=IJDAY2-IJDAY1
c      WRITE(6,*)'IJDAY1,IJDAY2,IJDAY3 = ',IJDAY1,IJDAY2,IJDAY3
      DSECS=DFLOAT(IJDAY3)*8.64D+04+SECS
      RETURN
      END
      FUNCTION JULIAN_DATE(YYYY,MM,DD)
      INTEGER YYYY,MM,DD
      JULIAN_DATE = dd-32075+1461*(yyyy+4800+(mm-14)/12)/4 + 
     1 367*(mm-2-((mm-14)/12)*12)/12- 
     1 3*((yyyy + 4900 + (mm - 14)/12)/100)/4
      RETURN
      END
      SUBROUTINE GROUNDCHECKI(REF,BIN,IBEG,NBINS,EVPASS,NUMMAX)
      REAL REF(NBINS),BIN(NBINS)
      NUMCHECK=-SIN(EVPASS*3.14159/180.)*NUMMAX
      IF(NUMCHECK.LT.4)NUMCHECK=4
      IF(REF(IBEG).LE.-32..AND.REF(I-1).GT.-32..AND.
     +   REF(IBEG-2).LE.-32.)THEN
         REF(IBEG-1)=-32.
         BIN(IBEG-1)=-888.8
      ENDIF
      IF(REF(IBEG).LE.-32..AND.REF(I-1).GT.-32..AND.
     +   REF(IBEG-3).LE.-32.)THEN
         REF(IBEG-1)=-32.
         BIN(IBEG-1)=-888.8
         REF(IBEG-2)=-32.
         BIN(IBEG-2)=-888.8
      ENDIF
      IF(REF(IBEG).LE.-32..AND.REF(I-1).GT.-32..AND.
     +   REF(IBEG-4).LE.-32.)THEN
         REF(IBEG-1)=-32.
         BIN(IBEG-1)=-888.8
         REF(IBEG-2)=-32.
         BIN(IBEG-2)=-888.8
         REF(IBEG-3)=-32.
         BIN(IBEG-3)=-888.8
      ENDIF
      DO I=IBEG,IBEG-NUMCHECK,-1
c         IF(REF(I).GT.-32..AND.REF(I-1).GT.-32..AND.
         IF(REF(I).GT.-32..AND.
     +      REF(I)-REF(I-1).GT.3.)THEN
            DO II=I,IBEG
               REF(II)=-32.
               BIN(II)=-888.8
            ENDDO
         ENDIF
      ENDDO
      RETURN
      END
